#include <signal.h>
#include "fun.h"
#include "cgi_fun.h"

void create_new_direction(int direction) { }    /* unused */
void put_log (const char *s, ...) { }           /* unused */
void set_alarm_out   (void)       { }           /* unused */
void unset_alarm_out (void)       { }           /* unused */
int login_year;
int login_mon;

static int flg_sleep_kill_initted;

void
sleep_kill_start (void)
{       /*  ,     */
  if(flg_sleep_kill_initted++ == 0)
    signal(SIGHUP, SIG_IGN);
}

void
sleep_kill_stop (void)
{       /*  ,     */
  if(--flg_sleep_kill_initted == 0)
    signal(SIGHUP, SIG_DFL);
}

char *decodeString(char *string)
{
  /* note that decoded string is always shorter than original */
  char *orig = string;
  char *ptr = string;
  while (*ptr)
  {
    if (*ptr == '+')    { *string++ = ' '; ptr++; }
    else if (*ptr != '%') *string++ = *ptr++;
    else  {
      unsigned int value;
      sscanf(ptr+1, "%2X", &value);
      *string++ = value;
      ptr += 3;
    }
  }
  *string = '\0';
  return orig;
}


const char main_cgi[]="/cgi-bin/main-cgi";
const char reg_form[]="/html/reg.form";
const char request_method[]="POST";
const char salt[]="DI";  /* salt fro crypt() */


static const char bottom[] = "\n</BODY>\n</HTML>\n";

void exit_bottom_msg(void)
{
	printf("%s", bottom);
}

struct DVAR dvar[] = {
	{ "UR", 's' },         /*  */
	{ "RF", 'd' },         /*   */
	{ "RN", 'd' },         /*   */
	{ "RA", 'd' },         /*   */
	{ "IF", 'd' },         /*    */
	{ "IN", 'd' },         /*    */
	{ "IA", 'd' },         /*    */
	{ "ON", 'd' },         /*    */
	{ "OF", 'd' },         /*    */
	{ "OA", 'd' },         /*    */
	{ "",    0  }
};

int find_var(const char *name)
{
	int i;

	for(i = 0; dvar[i].name[0]; i++)
	    if(strcmp(dvar[i].name, name) == 0)
		break;
	if(dvar[i].name[0] == 0)
	    error_d(3, "  ,   %s", name);
	return i;
}

void parse_form(FILE *f)
{
    int c;
    int parse_if = 0;
    char var[4];
    int i;

    while( (c=getc(f)) != EOF ) {
	if(c != '$') {
	    putchar(c);
	    continue;
	}
	do {
	    c = getc(f);
	    if(c == EOF)
		error_d(3, "  ,   ");
	    if(c == '?') {
		if(parse_if)
		    error_d(3, "  ,  $??");
		parse_if = 1;
	    } else {
		break;
	    }
	} while(1);

	var[0] = c;
	c = getc(f);
	if(c == EOF)
	    error_d(3, "  ,     ");
	var[1] = c;
	var[2] = 0;
	if(c < 'A' || c > 'Z')
	    error_d(3, "  ,   %s", var);
	if(parse_if) {
	    c = getc(f);
	    if(c == EOF)
		error_d(3, "  ,     $?%s", var);
	    if(c != '(')
		error_d(3, "  ,  '('  $?%s", var);
	}
	i = find_var(var);
	if(dvar[i].format != 's' && dvar[i].format != 'd')
	    error_d(3, " ,      %s", var);

	if(!parse_if) {
	    if(dvar[i].format == 's')
		printf("%s", dvar[i].v.sval);
	    else
		printf("%d", dvar[i].v.ival);
	    continue;
	}
	if(dvar[i].format == 's')
	    error_d(3, "  ,    %s", var);
	i = dvar[i].v.ival;
	while(parse_if > 0) {
	    c = getc(f);
	    if(c == EOF)
		error_d(3, "  ,     $?%s()", var);
	    if(c == ')')
		parse_if--;
	    if(i > 0 && parse_if > 0) {
		putchar(c);
	    }
	    if(c == '(')    /* '('   $?VAR(()) */
		parse_if++;
	}
    }
}
