#include "fun.h"
#include "keyboard.h"

/*     */
void
strip_dup_space (char *src, char **endp)
{
  char *s = src;
  while (*s) {
	if (*s == ' ' && *(s + 1) == ' ')
	  strcpy (s, s + 1);
	else
	  s++;
  }
  if (endp)
	*endp = s;
}

#define List_To_Ret_Ok_Next   1 /*   ,   "" */
#define List_To_Ret_Ok_EON    2 /*     */
#define List_To_Ret_Next_Scan 3 /*      */
#define List_To_Ret_Break     4 /*     */


static void scan_list (char *name, struct List_To_Ret *list_to_ret,
					   char *file);


static int
delete_name (char *u, struct List_To_Ret *ltr)
{
  char **new_list_to;
  int i, j;

  for (i = 0; i < ltr->n_list_to; i++)
	if (strcmp (u, ltr->list_to[i]) == 0)
	  break;
  if (i != ltr->n_list_to) {
	free0 (&ltr->list_to[i]);
	new_list_to = (char **) mallocc ((ltr->n_list_to - 1) * sizeof (char *));
	for (j = i = 0; i < ltr->n_list_to; i++)
	  if (ltr->list_to[i])
		new_list_to[j++] = ltr->list_to[i];
	free (ltr->list_to);
	ltr->list_to = new_list_to;
	ltr->n_list_to--;
	return 1;
  }
  return 0;
}

void
destroy_nlist (struct List_To_Ret *ltr)
{
  int i;
  if (ltr->n_list_to < 0 || ltr->list_to == 0)
	return;
  for (i = 0; i < ltr->n_list_to; i++)
	free (ltr->list_to[i]);
  free0 (&ltr->list_to);
  ltr->n_list_to = 0;
}

static void
add_name (char *u, struct List_To_Ret *list_to_ret)
{
  list_to_ret->n_list_to++;
  list_to_ret->list_to =
	(char **) reallocc (list_to_ret->list_to,
				list_to_ret->n_list_to * sizeof (char *));
  list_to_ret->list_to[list_to_ret->n_list_to - 1] = strcpym (u);
}


static void
form_list_to (char *s, struct List_To_Ret *list_to_ret, char *file)
{
  char *ps;
  char *ps2;
  int i, j;
  char u[160];
  struct PU pu;
  int flg_sub;

  ps = s;
  while (*ps) {
	if (*ps == '?') {
	  putcs ("\
    [@]  &  !\n\
 <*>     \n\
  -  `.', `-'  , <Enter>   ,\n\
-{|&|!|*}    `?'   \n\
   .\n");
	  list_to_ret->err_ok = List_To_Ret_Next_Scan;
	  return;
	}
	ps++;
  }
  strip_dup_space (s, &ps);     /*     */
/*   -   */
  if (*(ps - 1) == ',')
	*(ps - 1) = 0;

  switch (*s) {
  case 0:                       /*   */
	for (j = i = 0; i < list_to_ret->n_list_to; i++) {
	  j++;
	  if (j == 21) {
		if (wait_cr ())
		  break;
		j = 0;
	  }
	  warn_d ("=> %s\n", list_to_ret->list_to[i]);
	}
	list_to_ret->err_ok = List_To_Ret_Next_Scan;
	return;
  case ',':
  erre:
	putcs ("  .   `?'   .\n");
	list_to_ret->err_ok = List_To_Ret_Next_Scan;
	return;
  case '.':
	if (*(s + 1) != 0) /*   ,     */
	  goto erre;
	list_to_ret->err_ok = List_To_Ret_Ok_EON;
	return;
  }

rescan:
  if (*s == '-') {
	s++;
	flg_sub = 1;
	if (*s == ' ')
	  s++;
	if (*s == '.' && (*(s + 1) == 0 || (*(s + 1) == ' ' && *(s + 2) == 0)))
	  while (*s)
		s++;
	if (*s == 0) {
	  list_to_ret->err_ok = List_To_Ret_Break;
	  return;
	}
  } else
	flg_sub = 0;
  if (*s == '*') {
	char *flg_no_cur_grp;

	s++;
	flg_no_cur_grp = sort_db_abonents ();
	if (flg_no_cur_grp) {
	  for (i = 0; i < n_all_pu; i++) {
		if (flg_no_cur_grp[i] == 0) {
		  /* Adm    '*' :) */
		  if (strcmp (all_pu[i].user, Adm) == 0)
			continue;
		  for (j = 0; j < list_to_ret->n_list_to; j++)
			if (strcmp (all_pu[i].user, list_to_ret->list_to[j]) == 0)
			  break;
		  if (j == list_to_ret->n_list_to && flg_sub == 0)
			add_name (all_pu[i].user, list_to_ret);
		  else if (j != list_to_ret->n_list_to && flg_sub != 0)
			delete_name (all_pu[i].user, list_to_ret);
		}
	  }
	  free0 (&flg_no_cur_grp);
	}
  } else if (*s == '&' || *s == '!' || (*s >= 'A' && *s <= 'Z')) {
	if (*s >= 'A' && *s <= 'Z') {
	  i = 0;
	  ps = s;
	} else {
	  i = *s++;
	  ps = s;
	  if (*ps == ' ')
		strcpy (ps, ps + 1);
	}
	ps2 = ps;
	while ((*ps >= '@' && *ps <= 'Z') || *ps == '-' || *ps == '_' ||
		   (*ps >= '0' && *ps <= '9'))
	  ps++;
	if (ps == ps2)                          /*    */
	  goto erre;
	strncpy (u, ps2, (ps - ps2));
	u[(ps - ps2)] = 0;
	s = ps;
	ps = u;
	ps2 = 0;
	while (*ps) {
	  if (*ps == '@') {
		if (i)      /* '@'        */
		  goto erre;
		*ps = 0;
		if (*(ps + 1) != 0 && strcmp (ps + 1, hostname) != 0) {
		  warn_d ("`%s' -   \n", ps + 1);
		  list_to_ret->err_ok = List_To_Ret_Next_Scan;
		  return;
		}
		ps2 = ps;
		break;
	  }
	  ps++;
	}
	switch (i) {
	case '&':
	  if (flg_sub == 0)
		scan_list (u, list_to_ret, file);
	  else {
		struct List_To_Ret list_to_new;
		list_to_new.n_list_to = 0;
		list_to_new.list_to = 0;

		scan_list (u, &list_to_new, file);

		for (i = 0; i < list_to_new.n_list_to; i++) {
		  delete_name (list_to_new.list_to[i], list_to_ret);
		  free (list_to_new.list_to[i]);
		}
		free0 (&list_to_new.list_to);
	  }
	  if (list_to_ret->err_ok == List_To_Ret_Break)
		return;
	  break;
	case '!':
	  if (file == 0)
		putcs ("      \n");
	  else {
		if (flg_sub == 0)
		  scan_mask (u, list_to_ret, file, 1);
		else {
		  struct List_To_Ret list_to_new;
		  list_to_new.n_list_to = 0;
		  list_to_new.list_to = 0;
		  scan_mask (u, &list_to_new, file, 1);
		  for (i = 0; i < list_to_new.n_list_to; i++) {
			if (delete_name (list_to_new.list_to[i], list_to_ret) == 0)
			  warn_d (" '%s' -   \n",
					  list_to_new.list_to[i]);
			free (list_to_new.list_to[i]);
		  }
		  free0 (&list_to_new.list_to);
		}
		if (list_to_ret->err_ok == List_To_Ret_Break)
		  return;
	  }
	  break;
	case 0:
	  if (get_pu (&pu, u) == 0) {
		warn_d ("'%s' -   \n", u);
		list_to_ret->err_ok = List_To_Ret_Next_Scan;
		return;
	  }
	  if (ps2 == 0 && strcmp (pu.grp, "ALL") != 0 &&
		  strcmp (pu.grp, pu_cur.grp) != 0 && strcmp (pu_cur.grp, "ALL") != 0) {
		warn_d ("'%s' -      \n", u);
		list_to_ret->err_ok = List_To_Ret_Next_Scan;
		return;
	  }
	  strcpy (u, pu.user);
	  if (file == 0 && ps2 != 0)
		strcat (u, "@");
	  for (j = 0; j < list_to_ret->n_list_to; j++)
		if (strcmp (u, list_to_ret->list_to[j]) == 0)
		  break;
	  if (flg_sub == 0) {           /*    */
		if (j != list_to_ret->n_list_to) {
		  warn_d ("'%s'    \n", u);
		  break;                /*   */
		}
		add_name (u, list_to_ret);
	  } else {                      /*    */
		if (j == list_to_ret->n_list_to)
		  warn_d ("'%s'    \n", u);
		else
		  delete_name (u, list_to_ret);
	  }
	  break;
	}
  } else
	goto erre;
  if (*s == ' ')
	s++;
lcoma:
  if (*s == ',') {
	s++;
	if (*s == ' ')
	  s++;
	if (*s == ',')                  /*    */
	  goto erre;
  }
  if (*s == 0) {
	list_to_ret->err_ok = List_To_Ret_Ok_Next;
	return;
  }
  if (*s == '.') {
	s++;
	if (*s == ' ')
	  s++;
	if (*s == 0) {
	  list_to_ret->err_ok = List_To_Ret_Ok_EON;
	  return;
	}
	goto lcoma;         /*      ,  */
  }
  goto rescan;
}

int
get_list_users (char *fix_get_str, struct List_To_Ret *list_to,
				char *prompt1, char *promt_again, char *file)
{

  char *s;

  for (;;) {
	if (fix_get_str) {
	  s = fix_get_str;
	  fix_get_str = 0;
	} else
	  s = editstring (list_to->n_list_to == 0 ? prompt1 :
				(promt_again == 0 ? prompt1 : promt_again));
	form_list_to (s, list_to, file);
	if (list_to->err_ok == List_To_Ret_Break) {
	  destroy_nlist (list_to);
	  list_to->n_list_to = -1;
	  break;
	} else if (list_to->err_ok == List_To_Ret_Ok_EON)
	  break;
  }
  return list_to->n_list_to;
}

static void
scan_list (char *name, struct List_To_Ret *list_to_ret, char *file)
{
  FILE *in;
  char buff[80];
  int i;
  char *bs;
  int zbs;
  int czbs;

  list_to_ret->err_ok = List_To_Ret_Next_Scan;
  in = fopen (f_prompt ("list/%s", name), "r");
  if (in == 0)
	warn_d ("`%s' -   \n", name);
  else {
	zbs = 1000;
	bs = mallocc (zbs);
	czbs = 0;
	while (fgets (buff, 80, in) != NULL) {
	  i = strlen (buff);
	  if (i <= 0)
		continue;
	  buff[i - 1] = 0;
	  if (buff[0] == 0)
		continue;
	  i++;
	  czbs += i;
	  if (czbs >= zbs) {
		zbs += 1000;
		bs = reallocc (bs, zbs);
	  }
	  if (czbs != i)
		strcat (bs, " ");
	  strcat (bs, buff);
	}
	fclose (in);
	/*   ! */
	form_list_to (bs, list_to_ret, file);
	free (bs);
  }
}

void
scan_mask (char *name, struct List_To_Ret *list_to_ret, char *file,
		   int flg_err_put)
{
  FILE *in;
  char buff[80];
  int i;
  char *sp;

  in = fopen (f_prompt ("%s.msk", name), "r");
  if (in == 0) {
	if (flg_err_put == 0)
	  return;
	warn_d ("`%s' -    \n", name);
	list_to_ret->err_ok = List_To_Ret_Next_Scan;
  } else {
	sp = buff;
	*sp = 0;
	while (fgets (buff, 80, in) != NULL) {
	  i = strlen (buff);
	  if (i <= 0)
		continue;
	  buff[i - 1] = 0;
	  if (buff[0] == 0)
		continue;
	  sp = buff;
	  while (*sp != 0 && *sp != ' ')
		sp++;
	  if (*sp == ' ')
		*sp = 0;
	  else
		error_d (1, "    %s", name);
	  if (gmatch (file, buff)) {
		sp++;
		break;
	  }
	}
	fclose (in);

	if (*sp == 0) {
	  if (flg_err_put == 0)
		return;
	  warn_d ("\r1          `%s'\r7\n",
			  name);
	  list_to_ret->err_ok = List_To_Ret_Next_Scan;
	} else {
	  if (flg_err_put)
		form_list_to (sp, list_to_ret, file); /*   ! */
	  else
		add_name (sp, list_to_ret);
	}
  }
}

void
add_alias (char **pg, int n, char ***anames, int *nanames)
{
  struct List_To_Ret list_to;
  int i, j;
  char **pa = *anames;

  list_to.n_list_to = 0;
  list_to.list_to = 0;
  for (i = 0; i < *nanames; i++)
	add_name (pa[i], &list_to);
  for (i = 0; i < n; i++) {
	for (j = 0; j < list_to.n_list_to; j++)
	  if (strcmp (pg[i], list_to.list_to[j]) == 0)
		break;
	if (j == list_to.n_list_to)
	  add_name (pg[i], &list_to);
  }
  free0 (anames);
  *anames = list_to.list_to;
  *nanames = list_to.n_list_to;
}

void
delete_alias (char **pg, int n, char ***anames, int *nanames)
{
  struct List_To_Ret list_to;
  int i;
  char **pa = *anames;

  list_to.n_list_to = 0;
  list_to.list_to = 0;
  for (i = 0; i < *nanames; i++)
	add_name (pa[i], &list_to);
  for (i = 0; i < n; i++)
	if (delete_name (pg[i], &list_to) == 0)
	  warn_d ("`%s'     \n", pg[i]);
  free0 (anames);
  *anames = list_to.list_to;
  *nanames = list_to.n_list_to;
}


static int
qsort_compar_str (const void *p1, const void *p2)
{
  return strcmp (p1, p2);
}

void
sort_strndim (int n, char **ps)
{
  qsort (ps, n, sizeof (char *), qsort_compar_str);
}
