#include "fun.h"
#include "db.h"

char hostname[32] = "DIONIS";
char *prgname;

char Adm[] = "ADM";
char gates_group[] = "GATEWAYS";

char dir_users[] = "users";
char dir_arch[] = "archiv";
char dir_arch_no_arch[] = "_NO_ARCH";
char dir_news[] = "news";
char dir_auto[] = "auto";
char dir_ext[] = "ext";
char buf_news_empty[64] = "../../news/";        /*  users/adm */

/* #define OFFSET_SLASH_BUF_NEWS_EMPTY 11 -    */

char fname_single[] = "../single.lck";

int flg_inetd;
int flg_test;   /*       shell
		       Adm     */

int host_direction;

int disable_out;
FILE *cuslog;


struct OUTF_S *pof;
int n_pof;

static int
qsort_compar_ouf (const void *p1, const void *p2)
{
  struct OUTF_S *s1;
  struct OUTF_S *s2;
  s1 = (struct OUTF_S *) p1;
  s2 = (struct OUTF_S *) p2;
  return strcmp (s1->file_inc, s2->file_inc);
}

void
get_ouf (void)
{
  n_pof = get_db_ouf (&pof);
  qsort (pof, n_pof, sizeof (struct OUTF_S), qsort_compar_ouf);
}

void
put_r_from_reg (char *file_inc, char *user, char *din)
{
  int i, n;
  struct OUTF_S *of;

  n = n_pof;
  of = pof;
  for (i = 0; i < n; i++) {
	if (!strcmp (of->file_inc, file_inc)) {
	  for (i = 0; i < of->nuser; i++)
		if (!strcmp (of->user[i], user)) {
		  of->flg_r[i] = '1';
		  free (of->din[i]);
		  of->din[i] = strcpym (din);
		  put_db_ouf (of, 1);
		  break;
		}
	  break;
	}
	of++;
  }
}

int
chk_no_read (struct OUTF_S *p_o)
{
  int flg_no_read = 0;
  int j;

  if (p_o->flg_r == 0)
	flg_no_read++;
  else
	for (j = 0; j < p_o->nuser; j++)
	  if (p_o->flg_r[j] == '0')
		flg_no_read++;
  return flg_no_read;
}

int
qsort_compar_reg (const void *p1, const void *p2)
{
  struct REG_S *s1;
  struct REG_S *s2;
  s1 = (struct REG_S *) p1;
  s2 = (struct REG_S *) p2;
  return strcmp (s1->file_inc, s2->file_inc);
}

int
read_reg (struct REG_S *reg_s, FILE * out)
{
  char buf[5 * 80];

  strcpy (buf, f_prompt ("\n:              %s %s\n",
			  reg_s->file, reg_s->dfile));
  if (reg_s->rem[0])
	strcat (buf, f_prompt (":         %s\n", reg_s->rem));
  if (reg_s->din[0] == '+')
	strcat (buf, f_prompt ("          : %s %s\n\n",
			  reg_s->user, &reg_s->din[1]));
  else
	strcat (buf, f_prompt ("   : %s %s\n\n",
					reg_s->user, &reg_s->din[1]));
  if (out == 0)
	putcs (buf);
  else {
	putc_encode_buff(buf, out);
  }
  if(reg_s->flg_r != '1')
    reg_s->flg_r = 'Y';
  return strlen (buf);
}

char *
get_abon_email (void)
{
  FILE *femail;
  char *bufm;
  long l;

  femail = fopen ("email", "r");
  if (femail) {
	fseek (femail, 0l, SEEK_END);
	l = ftell (femail);
  erre:
	if (l >= 256 || l <= 1) {
	  warn_d ("     email\n");
	  return NULL;
	} else {
	  bufm = mallocc (l + 1);
	  fseek (femail, 0l, SEEK_SET);
	  fgets (bufm, l + 1, femail);
	  fclose (femail);
	  if (bufm[l - 1] != '\n') {
		l = 0;
		free (bufm);
		goto erre;
	  }
	  bufm[l - 1] = 0;
	  return bufm;
	}
  }
  return NULL;
}


char **msk_u;

int
view_mask (char *name, int flg_buf)
{
  FILE *in;
  char buff[80];
  int n;

  in = fopen (f_prompt ("%s.msk", name), "r");
  n = 0;
  msk_u = 0;
  if (in) {
	while (fgets (buff, 80, in) != NULL) {
	  if (flg_buf) {
		buff[strlen (buff) - 1] = 0;
		msk_u = (char **) reallocc (msk_u, (n + 1) * sizeof (char **));
		msk_u[n] = strcpym (buff);
	  }
	  n++;
	}
	fclose (in);
  }
  return n;
}

int
get_mask_to_file (char *name_mask)
{
  int n;

  n = view_mask (name_mask, 0);
  if (n == 0)
	warn_d ("`%s':    ", name_mask);
  return n;
}

int
mkdir_save_arch (int flg_out, char *mm_dd, char *name, char *dir, char **file)
{
  char str_tmp[16];
  struct stat statb;

  strcpy (str_tmp, mm_dd);
  str_tmp[2] = '_';                             /* _ */
  if (flg_out == SAVE_ARCH_PRO)
	sprintf (dir, "../../%s/%s/%s", dir_arch, dir_arch_no_arch, str_tmp);
  else
	sprintf (dir, "../../%s/%s/%s/%s",
		    dir_arch, pu_cur.user, flg_out ? "out" : "in", str_tmp);
  *file = bb_asprintf ("%s/%s", dir, name);
  if (stat (dir, &statb)) {
	if (mkdir (dir, 0770)) {
	  warn_d ("     \n");
	  return 1;
	}
  }
  return 0;
}
