/*     */

#include "fun.h"
#include "keyboard.h"
#include "db.h"
#include "hlps.h"
#include "ex.h"

void
list_abonents (void)
{
  int i, n, n2;
  char *flg_no_cur_grp;

  n = n_all_pu;
  if (n == 0)
	return;
  flg_no_cur_grp = sort_db_abonents ();
  n2 = 0;
  for (i = 0; i < n; i++) {
	if (flg_no_cur_grp[i] == 0) {
	  warn_d ("%c%12s", (n2 % 6 == 0) ? '\n' : ' ', all_pu[i].user);
	  n2++;
	}
  }
  free0 (&flg_no_cur_grp);
  putcc ('\n');
}

static int
check_name (char *s)
{
  int i = 0;
  if (strlen (s) >= MAXPU_LEN) {
	warn_d ("`%s' -   \n", s);
	return 0;
  }
  if (*s < 'A' || *s > 'Z');
  else
	for (i = 1; s[i]; i++)
	  if (!((s[i] >= 'A' && s[i] <= 'Z') ||
		 s[i] == '-' || s[i] == '_' || (s[i] >= '0' && s[i] <= '9')))
		break;
  if (s[i]) {
	putcs ("      \n");
	return 0;
  }
  return 1;
}

static void ext_chg_user(struct PU *pu, int old_ex_direction)
{
    if(have_ext_users()!=0) {
	    char *s;

	    if(pu->ex_direction != old_ex_direction) {
		if(have_ex_direction(old_ex_direction)==0) {
		    /*        */
		    delete_direction(old_ex_direction);
		}
		/*    */
		/*   -      */
		create_new_direction(pu->ex_direction);
	    }
	    s = form_w_pu_ex(pu);
	    ex_cmd(EXCMD_CHG_USER, pu->user, s, &pu_all_user);
	    free(s);
    }
}

static int flg_block_ex_chg_for_collect;

static int
user_chg (struct PU *pu)
{
  struct PU old;

  if (get_pu (&old, pu->user) == 0) {
	warn_d (" %s  ?\n", pu->user);
	goto err;
  }
  if (pu->l == 0)
	pu->l = old.l;
  if (pu->priv == 0)
	pu->priv = old.priv;
  if (pu->af == 0)
	pu->af = old.af;
  if (pu->grp[0] == 0)
	strcpy (pu->grp, old.grp);
  if (pu->pass[0] == 0)
	strcpy (pu->pass, old.pass);
  if (pu->rem[0] == 0)
	strcpy (pu->rem, old.rem);
  switch (pu->gate) {
  case -1:
	pu->gate = 0;
	break;
  case 0:
	pu->gate = old.gate;
	break;
	/*default:          // set
	   break; */
  }
  switch (pu->time_keeping_files) {
  case -1:
	pu->time_keeping_files = 0;
	break;
  case 0:
	pu->time_keeping_files = old.time_keeping_files;
	break;
	/*default:          // set
	   break; */
  }
  switch (pu->flg_ar) {
  case -1:
	pu->flg_ar = 0;
	break;
  case 1:
	pu->flg_ar = 1;
	break;
  default:                                              /* 0 */
	pu->flg_ar = old.flg_ar;
  }
  switch (pu->flg_nocolor) {
  case -1:
	pu->flg_nocolor = 0;
	break;
  case 1:
	pu->flg_nocolor = 1;
	break;
  default:                                              /* 0 */
	pu->flg_nocolor = old.flg_nocolor;
  }
  switch (pu->flg_gmf) {
  case -1:
	pu->flg_gmf = 0;
	break;
  case 0:
	pu->flg_gmf = old.flg_gmf;
	break;
	/*default:              // set
	   break; */
  }
  switch (pu->ex_direction) {
  case -1:
	pu->ex_direction = 0;
	break;
  case 0:
	pu->ex_direction = old.ex_direction;
	break;
	/*default:              // set
	   break; */
  }
  if (pu->naliases == 0) {
	pu->naliases = old.naliases;
	pu->aliases = old.aliases;
  } else
	pu->naliases--;
  /*     ? */
  if(memcmp(pu, &old, sizeof(struct PU))==0)
	return 0;
  if (db_add_user (pu, 1) == 0) {
err:
	warn_d ("     \n");
	return 1;
  }
  set_pu (pu);
  if(flg_block_ex_chg_for_collect==0) {
      ext_chg_user(pu, old.ex_direction);
  }
  return 0;
}

#define REQUIRE_PRIV_CUR_USER_CAN_CHANGE  1
#define REQUIRE_PRIV_GRANTS_USERMASTER    2
#define REQUIRE_PRIV_GRANTS_ACCESSMASTER  4
#define REQUIRE_PRIV_GRANTS_POSTMASTER    8
#define REQUIRE_PRIV_GRANTS_GATEMASTER    16
#define REQUIRE_PRIV_GRANTS_ARCHIVER      32
#define REQUIRE_PRIV_GRANTS_ADM           64

static int
have_grants_modify (struct PU *pu, int require_priv)
{
  if (strcmp (pu->user, pu_cur.user) == 0 &&
	  (require_priv & REQUIRE_PRIV_CUR_USER_CAN_CHANGE) != 0)
	return 1;
  if ((require_priv & REQUIRE_PRIV_GRANTS_USERMASTER) != 0 &&
	  (pu_cur.priv & GRANTS_USERMASTER) != 0)
	return 1;
  if ((require_priv & REQUIRE_PRIV_GRANTS_ACCESSMASTER) != 0 &&
	  (pu_cur.priv & GRANTS_ACCESSMASTER) != 0)
	return 1;
  if ((require_priv & REQUIRE_PRIV_GRANTS_POSTMASTER) != 0 &&
	  (pu_cur.priv & GRANTS_POSTMASTER) != 0)
	return 1;
  if ((require_priv & REQUIRE_PRIV_GRANTS_GATEMASTER) != 0 &&
	  (pu_cur.priv & GRANTS_GATEMASTER) != 0)
	return 1;
  if ((require_priv & REQUIRE_PRIV_GRANTS_ARCHIVER) != 0 &&
	  (pu_cur.priv & GRANTS_ARCHIVER) != 0)
	return 1;
  if ((require_priv & REQUIRE_PRIV_GRANTS_ADM) != 0 &&
	  (pu_cur.priv & GRANTS_ADM) == GRANTS_ADM)
	return 1;
  warn_d ("\r2       .\r7\n");
  return 0;
}

#define FLG_VIEW            1
#define FLG_CHANGE          2

static char *dlg_code[] = {
  "",
  "8",
  "",
  "",
  "-",
  "",
  "",
  "\n",
  NULL
};

static void
view_codepage (int l, int flg_nocolor)
{
  char *s;
  switch (l) {
  case 'E':
	s = dlg_code[0];
	break;
  case 'K':
	s = dlg_code[1];
	break;
  case 'A':
	s = dlg_code[2];
	break;
  case 'W':
	s = dlg_code[3];
	break;
  default:
	warn_d ("Error :  `%c'\n", l);
	s = dlg_code[4];
	break;
  }
  warn_d ("       : %s\n", s);
  warn_d ("ANSI    : %s\n",
		  flg_nocolor ? " vt100" : " vt200");
}

static void
chg_coding (struct PU *pu, struct PU *pu0, int flg_view_only)
{
  static char prompt[] =
      "\n ([.], , 8, , , , -, ?)";
  static const char alhlp[] = "\
 - transliteraciya\n\
8           -  \n\
 - CP866\n\
        - CP1251\n\
          -   \n\
       -   \n\n";
  struct IN_DLG in_dlg;

  int n;

  if ((flg_view_only & FLG_VIEW) != 0)
	view_codepage (pu->l, pu->flg_nocolor);
  if ((flg_view_only & FLG_CHANGE) == 0)
	return;
  if (have_grants_modify(pu,
      REQUIRE_PRIV_CUR_USER_CAN_CHANGE | REQUIRE_PRIV_GRANTS_USERMASTER) == 0)
	return;
  in_dlg.msgs = &dlg_code;
  in_dlg.prompt = prompt;
  in_dlg.alhlp = alhlp;
  in_dlg.hlps = &abon_dlg_hlps_cod;
  in_dlg.zvezda = 0;
  for (;;) {
	flg_auto_cr = 1;
	n = scan_input (&in_dlg);
	flg_auto_cr = 0;
	switch (n) {
	case 1:
	  pu0->l = 'E';
	  break;
	case 2:
	  pu0->l = 'K';
	  break;
	case 3:
	case 8:
	  pu0->l = 'A';
	  break;
	case 4:
	  pu0->l = 'W';
	  break;
	case 5:
	  return;
	case 6:
	  pu0->flg_nocolor = -1;
	  break;
	case 7:
	  pu0->flg_nocolor = 1;
	  break;
	}
	if (pu0->l != 0 || pu0->flg_nocolor != 0)
	  break;
  }
  user_chg (pu0);
  if (strcmp (pu0->user, pu_cur.user) == 0 && pu0->l != 0
	  && pu_cur.l != pu0->l && flg_inetd == 0) {
	n = pu_cur.l;
	pu_cur.l = 'E';
	if (yes_no ("   ")) {
	  pu_cur.l = pu0->l;
	  putcs ("  .\n");
	  pu_cur.l = 'E';
	  if (yes_no ("    "))
		pu_cur.l = pu0->l;
	  else
		pu_cur.l = n;
	} else
	  pu_cur.l = n;
  }
}

static int
chk_pass (char *s)
{
  if (strlen (s) >= MAXPU_LEN) {
	putcs ("  \n");
	return 0;
  }
  if (strlen (s) <= 2) {
	putcs ("  \n");
	return 0;
  }
  return 1;
}

static void
chg_pass (struct PU *pu, struct PU *pu0, int flg_view_only)
{
  char *s;
  char probap[MAXPU_LEN + 1];

  if ((pu_cur.priv & GRANTS_ADM) == GRANTS_ADM
	  && (flg_view_only & FLG_VIEW) != 0)
	warn_d ("          : %s\n", pu->pass);
  else if ((pu_cur.priv & GRANTS_ADM) != GRANTS_ADM &&
		   (flg_view_only & FLG_VIEW) != 0 &&
		   strcmp (pu->user, pu_cur.user) == 0)
	warn_d ("\r3     \r7\n");
  if ((flg_view_only & FLG_CHANGE) == 0)
	return;
  if (have_grants_modify(pu,
      REQUIRE_PRIV_CUR_USER_CAN_CHANGE | REQUIRE_PRIV_GRANTS_USERMASTER) == 0)
	return;
  for (;;) {
	s = pstringnoecho (" , `-'  ");
	if (*s == 0)
	  continue;
	if (*s == '-')
	  return;
	if (chk_pass (s))
	  break;
  }
  strcpy (probap, s);
  s = pstringnoecho (" , `-'  ");
  if (*s == '-')
	return;
  if (strcmp (probap, s)) {
	putcs ("   \n");
	return;
  }
  strcpy (pu0->pass, s);
  user_chg (pu0);
}

static void
chg_grp (struct PU *pu, struct PU *pu0, int flg_view_only)
{
  char *s;
  char **groupsl;
  int ng, i;

  if ((flg_view_only & FLG_VIEW) != 0) {
	putcs (" : ");
	if (strcmp (pu->grp, "ALL"))
	  warn_d ("%s\n", pu->grp);
	else
	  putcs ("    \n");
  }
  if ((flg_view_only & FLG_CHANGE) == 0)
	return;
  if (have_grants_modify (pu, REQUIRE_PRIV_GRANTS_USERMASTER) == 0)
	return;
  ng = get_all_group (&groupsl);
  for (;;) {
	s = editstring (", `-'  , <Enter>  ");
	if (*s == 0) {
	  for (i = 0; i < ng; i++)
		warn_d ("%c%12s", ((i % 6 == 0) ? '\n' : ' '), groupsl[i]);
	  putcc ('\n');
	  continue;
	}
	if (*s == '-')
	  return;
	if (strlen (s) < MAXPU_LEN)
	  break;
	putcs ("   \n");
  }
  for (i = 0; i < ng; i++)
	if (!strcmp (groupsl[i], s))
	  break;
  if (i == ng) {
	if (no_yes ("  ") != 0)
	  i = -1;
  }
  if (i != ng) {
	strcpy (pu0->grp, s);
	user_chg (pu0);
  }
  for (i = 0; i < ng; i++)
	free (groupsl[i]);
  free0 (&groupsl);
}


static void
chg_rem (struct PU *pu, struct PU *pu0, int flg_view_only)
{
  char *s;

  if ((flg_view_only & FLG_VIEW) != 0)
	warn_d ("      : %s\n", pu->rem);
  if ((flg_view_only & FLG_CHANGE) == 0)
	return;
  if (have_grants_modify (pu, REQUIRE_PRIV_GRANTS_USERMASTER) == 0)
	return;
  for (;;) {
	s = editrem (", `-'  ");
	if (*s == '-')
	  return;
	if (*s == 0)
	  continue;
	if (strlen (s) < MAXPU_REM_LEN)
	  break;
	putcs ("  \n");
  }
  strcpy (pu0->rem, s);
  user_chg (pu0);
}


static void
chg_keeping (struct PU *pu, struct PU *pu0, int flg_view_only)
{
  char *s;
  int keeping;

  if ((flg_view_only & FLG_VIEW) != 0) {
	putcs ("   : ");
	if (pu->time_keeping_files == 0)
	  putcs ("\n");
	else if (pu->time_keeping_files == 1)
	  putcs ("1 \n");
	else
	  warn_d ("%d \n", pu->time_keeping_files);
  }
  if ((flg_view_only & FLG_CHANGE) == 0)
	return;
  if (have_grants_modify(pu,
	REQUIRE_PRIV_CUR_USER_CAN_CHANGE | REQUIRE_PRIV_GRANTS_ARCHIVER) == 0)
		return;
  for (;;) {
	s = editrem ("  , 0 -  , `-'  ");
	if (*s == '-')
	  return;
	if (*s == 0)
	  continue;
	keeping = g_int (&s);
	if (*s == 0 && keeping >= 0)
	  break;
	putcs ("  \n");
  }
  pu0->time_keeping_files = keeping == 0 ? -1 : keeping;
  user_chg (pu0);
}

static void
chg_access (struct PU *pu, struct PU *pu0, int flg_view_only)
{
  static char *dlg_com[] = {
	"",
	"",
	"",
	"",
	"-",
	NULL
  };
  static char prompt[] = "\n (, , , , -, ?)";
  static const char alhlp[] = "\
     -    \n\
     -     c  \n\
     -       \n\
  -      ''\n\
		  -   \n\n";

  struct IN_DLG in_dlg;
  char *sdirect;
  int n;

  if ((flg_view_only & FLG_VIEW) != 0) {
	warn_d ("          : %s\n",
			(pu->af | 040) == 'a' ? "" : "");
	warn_d ("            : %s\n", pu->ex_direction == host_direction ?
			"" : f_prompt("%d", pu->ex_direction));
	warn_d ("     : %s\n", (pu->af | 040) != pu->af ?
					"" : " ");
  }
  if ((flg_view_only & FLG_CHANGE) == 0)
	return;
  if (have_grants_modify (pu, REQUIRE_PRIV_GRANTS_ACCESSMASTER) == 0)
	return;

  in_dlg.msgs = &dlg_com;
  in_dlg.prompt = prompt;
  in_dlg.alhlp = alhlp;
  in_dlg.hlps = &abon_dlg_hlps_ac;
  in_dlg.zvezda = 0;

  for (;;) {
	flg_auto_cr = 1;
	n = scan_input (&in_dlg);
	flg_auto_cr = 0;
	switch (n) {
	case 1:
	  pu0->af = 'D';
	  break;
	case 2:
	  pu0->af = 'A';
	  break;
	case 3:
	  pu0->af = 'a';
	  break;
	case 4:
	  sdirect = two_e_word();
	  if(sdirect==0) {
	      sdirect = editstring (" :  ");
	  }
	  n = g_int (&sdirect);
	  if(n<0 || n>MAX_DIRECTIONS || *sdirect != 0) {
	    warn_d("   . 0 <=  <= %d\n",
							    MAX_DIRECTIONS);
	    break;
	  }
	  if(n==0)
	    n = -1;
	  pu0->ex_direction = n;
	  break;
	case 5:
	  return;
	}
	if (pu0->af!=0 || pu0->ex_direction!=0)
	  break;
  }
  user_chg (pu0);
}


static void
only_view_aliases (int n, char **anames)
{
  int i;

  warn_d ("%c      : ", n == 1 ? ' ' : '');
  if (n > 0) {
	for (i = 0; i < n; i++) {
	  if (i)
		putcs (", ");
	  putcs (anames[i]);
	}
  } else
	warn_d (" ");
  putcc ('\n');
}

static int
view_aliases (char *user, char ***panames)
{
  struct PU pu;

  if (get_pu (&pu, user) == 0) {
	warn_d (" %s  ?\n", user);
	return 0;
  }
  *panames = pu.aliases;
  only_view_aliases (pu.naliases, pu.aliases);
  return pu.naliases;
}

static int
params (char *s, char ***pars)
{
  char *s2;
  char **dim;
  int n;
  int i;
  struct PU pu;

  s2 = s;
  while (*s2) {
	if (*s2 == ',')
	  *s2 = ' ';
	s2++;
  }
  strip_dup_space (s, 0);
  if (*s == 0) {
	warn_d (" \n");
	return 0;
  }
  n = 1;
  s2 = s;
  while (*s2) {
	if (*s2 == ' ')
	  n++;
	s2++;
  }
  *pars = (char **) mallocc (n * sizeof (char *));
  dim = *pars;
  s2 = s;
  for (i = 0; i < n; i++) {
	dim[i] = s2;
	s = s2;
	while (*s) {
	  if (*s == ' ') {
		*s++ = 0;
		s2 = s;
		break;
	  }
	  s++;
	}
  }
  for (i = 0; i < n; i++) {
	str_up (dim[i]);
	if (check_name (dim[i]) == 0)
	  return 0;
	if (get_pu (&pu, dim[i]) != 0 && strcmp (pu.user, dim[i]) == 0) {
	  warn_d (" `%s'     \n",
			  dim[i]);
	  return 0;
	}
  }
  return n;
}

static void
add_delete_fun_alias (int flg_add, int *pn, char ***panames)
{
  int chg;
  char **chg_anames;
  char *s;

  chg = 0;
  chg_anames = 0;
  s = two_e_word ();
  for (;;) {
	if (s == 0)
	  s = editstring (flg_add ?
		", `-'  , <Enter> " :
		", `-'  , <Enter> ");
	if (*s == 0) {
	  only_view_aliases (*pn, *panames);
	  s = 0;
	  continue;
	}
	if (*s != '-')
	  chg = params (s, &chg_anames);
	break;
  }
  if (chg) {
	if (flg_add)
	  add_alias (chg_anames, chg, panames, pn);
	else
	  delete_alias (chg_anames, chg, panames, pn);
	free (chg_anames);
  }
}

static void
chg_aliases (struct PU *pu, struct PU *pu0, int flg_view_only)
{
  static char *dlg_com[] = {
	"",
	"",
	"",
	"",
	"-",
	NULL
  };
  static char prompt[] =
	"\n (, , , , -, ?)";
  static const char alhlp[] = "\
     [par] -     \n\
        -     \n\
       -  \n\
    [par] -    \n\
            \n\n";

  struct IN_DLG in_dlg;

  int n;
  int i;
  char **anames;

  if ((flg_view_only & FLG_VIEW) != 0)
	n = view_aliases (pu->user, &anames);
  else
	n = -1;
  if ((flg_view_only & FLG_CHANGE) == 0)
	return;
  if (have_grants_modify (pu, REQUIRE_PRIV_GRANTS_USERMASTER) == 0)
	return;
  if (n < 0) {
	anames = pu->aliases;
	n = pu->naliases;
  }
  if (n == 0)
	anames = 0;
  else {
	char **pa;
	pa = (char **) mallocc (n * sizeof (char *));
	for (i = 0; i < n; i++)
	  pa[i] = anames[i];
	anames = pa;
  }
  in_dlg.msgs = &dlg_com;
  in_dlg.prompt = prompt;
  in_dlg.alhlp = alhlp;
  in_dlg.hlps = &abon_dlg_hlps_al;
  in_dlg.zvezda = 0;

  for (;;) {
	flg_auto_cr = 1;
	i = scan_input (&in_dlg);
	flg_auto_cr = 0;
	switch (i) {
	case 1:
	  add_delete_fun_alias (1, &n, &anames);
	  break;
	case 2:
	  only_view_aliases (n, anames);
	  break;
	case 3:                                 /*  */
	  pu0->naliases = n + 1;
	  pu0->aliases = anames;
	  user_chg (pu0);
	  return;
	case 4:                                 /*  */
	  if (n < 1) {
		warn_d ("  %s   \n", pu->user);
		break;
	  }
	  add_delete_fun_alias (0, &n, &anames);
	  break;
	case 5:                                 /* - */
	  return;
	}
  }
}

static int
viev_mail_gate (struct PU *pu, char *bp)
{
  char *s;
  char emailpth[10 + MAXPU_LEN];
  struct stat st;

  sprintf (emailpth, "../%s/email", pu->user);
  if (bp)
	strcpy (bp, emailpth);

  switch (pu->flg_gmf) {
  case MAIL_FILE_GATE_COPY:
	s = " ";
	break;
  case MAIL_FILE_GATE_INFO:
	s = "    ";
	break;
  case MAIL_FILE_GATE_REG:
	s = "      ";
	break;
  default:      /* case 0: */
	s = "";
	break;
  }
  warn_d ("    : %s\n", s);
  if (stat (emailpth, &st) == 0) {
	putcs ("   : ");
	putcs_mnogo_in_file (emailpth);
	return 1;
  }
  return 0;
}

static void
chg_mail_gate (struct PU *pu, struct PU *pu0, int flg_view_only)
{
  static char *dlg_com[] = {
	"",
	"",
	"",
	"",
	"-",
	NULL
  };
  static char prompt[] =
	"\n (, , ,  -, ?)";
  static const char alhlp[] = "\
   -       \n\
 -        \n\
     -   - \n\
    -        \n\
		  \n\n";
  struct IN_DLG in_dlg;
  int n;

  if ((flg_view_only & FLG_VIEW) != 0)
	viev_mail_gate (pu, 0);
  if ((flg_view_only & FLG_CHANGE) == 0)
	return;
  if (have_grants_modify (pu, REQUIRE_PRIV_GRANTS_POSTMASTER) == 0)
	return;
  in_dlg.msgs = &dlg_com;
  in_dlg.prompt = prompt;
  in_dlg.alhlp = alhlp;
  in_dlg.hlps = &abon_dlg_gatemail_ac;
  in_dlg.zvezda = 0;
  for (;;) {
	flg_auto_cr = 1;
	n = scan_input (&in_dlg);
	flg_auto_cr = 0;
	switch (n) {
	case 1:
	  pu0->flg_gmf = MAIL_FILE_GATE_COPY;
	  break;
	case 2:
	  pu0->flg_gmf = MAIL_FILE_GATE_INFO;
	  break;
	case 3:
	  pu0->flg_gmf = -1;
	  break;
	case 4:
	  pu0->flg_gmf = MAIL_FILE_GATE_REG;
	  break;
	case 5:
	  return;
	}
	if (pu0->flg_gmf)
	  break;
  }
  if (pu0->flg_gmf > 0) {
	char emailpth[10 + MAXPU_LEN];
	char *s;
	n = viev_mail_gate (pu0, emailpth);
	if (n == 0 || no_yes ("  ") != 0) {
	  for (;;) {
		s = editstring (" , `-'  ");
		if (*s != 0)
		  break;
	  }
	  if (*s != '-') {
		char *sp;
		FILE *emlf;
		emlf = fopen (emailpth, "w");
		if (emlf == 0)
		  error_d (1, "    ");
		sp = s;
		while (*s) {
		  if (*s == '@')
			break;
		  if (*s >= 'A' && *s <= 'Z')
			*s |= 040;
		  s++;
		}
		fprintf (emlf, "%s\n", sp);
		fclose (emlf);
	  }
	}
  }
  user_chg (pu0);
}

static void
chg_gate (struct PU *pu, struct PU *pu0, int flg_view_only)
{
  char *s;
  int g;

  if ((flg_view_only & FLG_VIEW) != 0) {
	if (pu->gate)
	  warn_d ("    : `%d'\n", pu->gate);
	else
	  warn_d ("    : \n");
  }
  if ((flg_view_only & FLG_CHANGE) == 0)
	return;
  if (have_grants_modify (pu, REQUIRE_PRIV_GRANTS_GATEMASTER) == 0)
	return;
  for (;;) {
	s = editrem (
	    "    , 0 - , `-'  ");
	if (*s == '-')
	  return;
	if (*s == 0)
	  continue;
	g = atoi (s);
	if (g != 0 && gate_exist (g, -1) == 0) {
	  putcs ("     \n");
	  return;
	}
	break;
  }
  pu0->gate = g == 0 ? -1 : g;
  user_chg (pu0);
  if (strcmp (pu->user, pu_cur.user) == 0)
	pu_cur.gate = g;
}

static char *
delete_user_archive (const char *u, int new_flg_ar)
{
  char *fda;

  fda = strcpym (f_prompt ("../../%s/%s", dir_arch, u));
  if (new_flg_ar == 0) {
	if ((pu_cur.priv & GRANTS_ARCHIVER) == 0) {
	  warn_d(
"\r1: \r2     .\n\
  \r1 .\r7\n");
	  free (fda);
	  return 0;
	}
	if (disable_out==1 || yes_no ("  ")) {
	  char *fda2 = f_prompt ("rm -r %s ../../%s/%s", fda, dir_auto, u);

	  put_log("%s\n", fda2);
	  system (fda2);
	  free (fda);
	  return 0;
	}
  }
  return fda;
}

void create_delete_arch_ex(const char *user, int flg_ar)
{
    char arx_dir_names[80];
    char *fda;
    int l;
    struct stat st;

    fda = delete_user_archive (user, flg_ar);
    if (fda) {
      strcpy (arx_dir_names, fda);
      if (stat (arx_dir_names, &st) < 0)
	    if (mkdir (arx_dir_names, 0770)) {
errd:
	      warn_d ("      %s\n",
			      arx_dir_names);
	      return;
	    }
      strcat (arx_dir_names, "/");
      l = strlen (arx_dir_names);
      strcat (arx_dir_names, "in");
      if (stat (arx_dir_names, &st) < 0)
	    if (mkdir (arx_dir_names, 0770))
	      goto errd;
      strcpy (&arx_dir_names[l], "out");
      if (stat (arx_dir_names, &st) < 0)
	    if (mkdir (arx_dir_names, 0770))
	      goto errd;
      strcpy (arx_dir_names, f_prompt ("../../%s/%s", dir_auto, user));
      if (stat (arx_dir_names, &st) < 0)
	    if (mkdir (arx_dir_names, 0770))
	      goto errd;
      free (fda);
      }
}

static void
chg_arch (struct PU *pu, struct PU *pu0, int flg_view_only)
{

  if ((flg_view_only & FLG_VIEW) != 0)
	warn_d (" : %s\n", pu->flg_ar ?
					"" : "");
  if ((flg_view_only & FLG_CHANGE) == 0)
	return;
  if (have_grants_modify (pu, REQUIRE_PRIV_GRANTS_ARCHIVER) == 0)
	return;
  if (no_yes (f_prompt ("%s    ", pu->flg_ar == 0 ?
						"" : ""))) {
	pu0->flg_ar = pu->flg_ar ? -1 : 1;
	user_chg (pu0);
	create_delete_arch_ex(pu->user, pu0->flg_ar);
	if (strcmp (pu->user, pu_cur.user) == 0)
	  pu_cur.flg_ar = pu0->flg_ar;
  }
}

static void
view_grants (priv)
{
  int n;
  if (priv != GRANTS_NO_GRANTS) {
	putcs ("      : ");
	if ((priv & GRANTS_ADM) == GRANTS_ADM)
	  putcs ("");
	else {
	  n = 0;
	  if ((priv & GRANTS_ACCESSMASTER)) {
		putcs ("");
		n++;
	  }
	  if ((priv & GRANTS_POSTMASTER)) {
		if (n)
		  putcs (", ");
		putcs ("email-");
		n++;
	  }
	  if ((priv & GRANTS_GATEMASTER)) {
		if (n)
		  putcs (", ");
		putcs ("");
		n++;
	  }
	  if ((priv & GRANTS_ARCHIVER)) {
		if (n)
		  putcs (", ");
		putcs ("");
		n++;
	  }
	  if ((priv & GRANTS_USERMASTER)) {
		if (n)
		  putcs (", ");
		putcs ("");
		n++;
	  }
	  if ((priv & GRANTS_NEWSMASTER)) {
		if (n)
		  putcs (", ");
		putcs ("");
		n++;
	  }
	}
  } else
	warn_d ("      :  ");
  putcc ('\n');
}

static void
chg_grants (struct PU *pu, struct PU *pu0, int flg_view_only)
{
  static char *dlg_grants[] = {
	"",
	"",
	"",
	"",
	"",
	"",
	"",
	"",
	"",
	"-",
	"\n",
	NULL
  };

  static char prompt[] =
	"\n (, , , ..., -, ?)";
  static const char alhlp[] = "\
     -    \n\
       -       \n\
       -   \n\
  -    \n\
      -    \n\
        -   \n\
       -    \n\
   -  \n\
        -      .\n\n\
         \n\n";

  struct IN_DLG in_dlg;
  int n;
  int priv;

  if ((flg_view_only & FLG_VIEW) != 0)
	view_grants (pu->priv);
  if ((flg_view_only & FLG_CHANGE) == 0)
	return;
  if (have_grants_modify (pu, REQUIRE_PRIV_GRANTS_ADM) == 0)
	return;
  if (strcmp (pu->user, Adm) == 0) {
	warn_d ("     \n");
	pu0->priv = GRANTS_ADM;
	user_chg (pu0);
	return;
  }
  priv = pu->priv;

  in_dlg.msgs = &dlg_grants;
  in_dlg.prompt = prompt;
  in_dlg.alhlp = alhlp;
  in_dlg.hlps = &dlg_hlps_grants;
  in_dlg.zvezda = 0;

  for (;;) {
	flg_auto_cr = 1;
	n = scan_input (&in_dlg);
	flg_auto_cr = 0;
	switch (n) {
	case 1:                                 /* "" */
	  priv ^= GRANTS_USERMASTER;
	  break;
	case 2:                                 /* "" */
	  priv ^= GRANTS_ARCHIVER;
	  break;
	case 3:                                 /* "" */
	  priv ^= GRANTS_ACCESSMASTER;
	  break;
	case 4:                                 /* "" */
	  priv ^= GRANTS_NEWSMASTER;
	  break;
	case 5:                                 /* "" */
	  priv = GRANTS_NO_GRANTS;
	  break;
	case 6:                                 /* "" */
	  priv ^= GRANTS_POSTMASTER;
	  break;
	case 7:                                 /* "" */
	  view_grants (priv);
	  break;
	case 8:                                 /* "" */
	  priv ^= GRANTS_GATEMASTER;
	  break;
	case 9:                                 /* "" */
	  priv |= (GRANTS_ADM + 1);
	  break;
	case 10:                                /* "-" */
	  return;
	case 11:                                /* "\n" */
	  break;
	}
	if ((priv & (GRANTS_ADM + 1)))
	  break;
  }
  pu0->priv = priv & (~(GRANTS_ADM + 1));
  if ((pu0->priv & (~GRANTS_NO_GRANTS)) != 0)
	pu0->priv &= ~GRANTS_NO_GRANTS;
  user_chg (pu0);
}


static void
prepare_pu0 (struct PU *pu0, char *user)
{
  memset (pu0, 0, sizeof (struct PU));
  strcpy (pu0->user, user);
}

int add_user_fun(char *user, struct PU *pu_set)
{
    if (add_user (user) != 0 && get_pu (pu_set, user) != 0) {
	chdir ("..");
	if (mkdir (user, 0770))
	    error_d (1, "       %s", user);
	chdir (user);
	create_empty (START_USERS_DB);
	chdir (pu_cur.user);
	return 1;
    }
    return 0;
}

static void
edit_user (void)
{
  char *s;
  struct PU pu;
  struct PU pu0;
  int i;

  s = two_e_word ();
  for (;;) {
	if (s == NULL)
	  s = editstring (" , <Enter> - , `-' ");
	if (*s == 0) {
	  list_abonents ();
	  s = NULL;
	  continue;
	}
	if (*s == '-')
	  return;
	if (check_name (s))
	  break;
	s = NULL;
  }
  if (get_pu (&pu, s) == 0) {
	prepare_pu0 (&pu, s);
	warn_d (" %s    \n", pu.user);
	if (yes_no (f_prompt ("  %s", pu.user)) == 0)
	  return;
	if (add_user_fun(pu.user, &pu) != 0) {
	  flg_block_ex_chg_for_collect=1;
	  prepare_pu0 (&pu0, pu.user);
	  chg_pass (&pu, &pu0, FLG_VIEW | FLG_CHANGE);
	  prepare_pu0 (&pu0, pu.user);
	  chg_grp (&pu, &pu0, FLG_VIEW | FLG_CHANGE);
	  prepare_pu0 (&pu0, pu.user);
	  chg_coding (&pu, &pu0, FLG_VIEW | FLG_CHANGE);
	  prepare_pu0 (&pu0, pu.user);
	  chg_rem (&pu, &pu0, FLG_VIEW | FLG_CHANGE);
	  prepare_pu0 (&pu0, pu.user);
	  chg_keeping (&pu, &pu0, FLG_VIEW | FLG_CHANGE);
	  prepare_pu0 (&pu0, pu.user);
	  chg_gate (&pu, &pu0, FLG_VIEW | FLG_CHANGE);
	  prepare_pu0 (&pu0, pu.user);
	  chg_arch (&pu, &pu0, FLG_VIEW | FLG_CHANGE);
	  prepare_pu0 (&pu0, pu.user);
	  chg_access (&pu, &pu0, FLG_VIEW | FLG_CHANGE);
	  i = pu0.ex_direction; /*     */
	  prepare_pu0 (&pu0, pu.user);
	  chg_mail_gate (&pu, &pu0, FLG_VIEW | FLG_CHANGE);
	  if(have_ext_users()!=0) {  /*   chg_access() */
	    create_new_direction(i);
	    ex_cmd(EXCMD_ADD_NEW_USR, pu.user, 0, &pu_all_user);
	    }
	}
  } else {
    warn_d (" %s   \n", pu.user);
    flg_block_ex_chg_for_collect=pu.ex_direction+1;
    chg_pass (&pu, &pu0, FLG_VIEW);
    if (no_yes (" ") != 0) {
	prepare_pu0 (&pu0, pu.user);
	chg_pass (&pu, &pu0, FLG_CHANGE);
    }
    i = strcmp (pu.grp, "ALL");
    if (strcmp (pu.user, Adm)) {
	chg_grp (&pu, &pu0, FLG_VIEW);
	if (no_yes (" ") != 0) {
	  prepare_pu0 (&pu0, pu.user);
	  chg_grp (&pu, &pu0, FLG_CHANGE);
	}
    }
    chg_coding (&pu, &pu0, FLG_VIEW);
    if (no_yes ("    ") != 0) {
	prepare_pu0 (&pu0, pu.user);
	chg_coding (&pu, &pu0, FLG_CHANGE);
    }
    chg_access (&pu, &pu0, FLG_VIEW);
    if (no_yes (" ") != 0) {
	prepare_pu0 (&pu0, pu.user);
	chg_access (&pu, &pu0, FLG_CHANGE);
    }
    chg_rem (&pu, &pu0, FLG_VIEW);
    if (no_yes (" ") != 0) {
	prepare_pu0 (&pu0, pu.user);
	chg_rem (&pu, &pu0, FLG_CHANGE);
    }
    chg_gate (&pu, &pu0, FLG_VIEW);
    if (no_yes ("  ") != 0) {
	prepare_pu0 (&pu0, pu.user);
	chg_gate (&pu, &pu0, FLG_CHANGE);
    }
    chg_mail_gate (&pu, &pu0, FLG_VIEW);
    if (no_yes ("  -") != 0) {
	prepare_pu0 (&pu0, pu.user);
	chg_mail_gate (&pu, &pu0, FLG_CHANGE);
    }
    prepare_pu0 (&pu0, pu.user);
    chg_arch (&pu, &pu0, FLG_VIEW | FLG_CHANGE);
  }

  if(get_pu (&pu0, pu.user) != 0) {
    ext_chg_user(&pu0, flg_block_ex_chg_for_collect-1);
  }
  flg_block_ex_chg_for_collect=0;
}

static void
delete_user (struct PU *pu, struct PU *pu0,
			 int flg_load_dump_users_no_interactive)
{

  if (flg_load_dump_users_no_interactive == 0 &&
	  have_grants_modify (pu, REQUIRE_PRIV_GRANTS_USERMASTER) == 0)
	return;
  if (!strcmp (pu->user, Adm)) {
	putcs ("  \n");
	return;
  }
  if (flg_load_dump_users_no_interactive != 0 ||
		  yes_no (f_prompt ("  %s", pu->user)) != 0) {
	int i, err;

	put_log ("remove user `%s'\n", pu->user);
	err = del_user (pu->user);
	if (chdir (f_prompt ("../%s", pu->user))) {
	  warn_d ("Error chdir(%s)\n", pu->user);
	  err++;
	} else {
	  unlink_all_db ();
	  chdir ("..");
	  i = my_scandir (pu->user);
	  while (i) {
		i--;
		unlink (f_prompt ("%s/%s", pu->user, name_dlist[i]));
	  }
	  if (rmdir (pu->user)) {
		warn_d ("Error rmdir(%s)\n", pu->user);
		err++;
	  }
	  if (chdir (pu_cur.user))
		error_d (71, "Error chdir(%s)", pu_cur.user);
	}
	remove_user_from_all_news (pu->user);
	if (flg_load_dump_users_no_interactive == 0 && pu->flg_ar != 0)
	  delete_user_archive (pu->user, 0);
	if (err == 0)
	  warn_d ("    \n");
	i = pu->ex_direction;
	ex_cmd(EXCMD_ERASE_USR, pu->user, 0, &pu_all_user);
	get_pu (pu, pu_cur.user);       /*   */
	if(have_ex_direction(i)==0) {
	    /*      */
	    delete_direction(i);
	}
  }
}

typedef void (*PF) (struct PU * pu, struct PU * pu0, int flg_view_only);

static void
chg_abon_chg (PF pf, int flg_view_only)
{
  int n;
  struct PU pu;
  struct PU pu0;
  char *s;
  struct List_To_Ret list_to;

  s = two_e_word ();
  if (s != NULL) {
	if (s[strlen (s) - 1] != '.')
	  strcat (s, ".");
	s = fixeditstr (s);
  }
  else if (pf == chg_arch || pf == chg_keeping || pf == chg_coding
			 || pf == chg_pass) {
	/* user can modify this */
	s = fixeditstr (pu_cur.user);
	strcat (s, ".");
  }
  list_to.n_list_to = 0;
  list_to.list_to = 0;
  get_list_users (s, &list_to, "\n  &", " ", 0);
  for (n = 0; n < list_to.n_list_to;) {
	get_pu (&pu, list_to.list_to[n]);
	prepare_pu0 (&pu0, pu.user);
	free (list_to.list_to[n]);
	if ((flg_view_only & FLG_CHANGE) != 0) {
	  if (strcmp (pu.user, Adm) == 0 && strcmp (pu_cur.user, Adm) != 0) {
		warn_d ("  %s     \n", Adm);
		n++;
		continue;
	  }
	  warn_d ("  %s\n", pu.user);
	}
	(*pf) (&pu, &pu0, flg_view_only);
	if (++n != list_to.n_list_to)
	  if (wait_cr ())
		break;
  }
  free0 (&list_to.list_to);
}

int
chk_adm (void)
{
  if (pu_cur.priv != GRANTS_ADM) {
	putcs ("\r2   \r7\n");
	return 0;
  }
  return 1;
}

static char *dlg_com[] = {
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "-",
  "",
  "\n",
  NULL
};

static char prompt[] =
  "\n (, , , , ..., -, ?)";
static const char alhlp[] = "\
 [par] -    \n\
     [par] -       \n\
       [par] -   \n\
 [par] -       \n\
		      \n\
           -       \n\
    [par] -  \n\
          -     \n\
          \n\
   \n\n";

int
dlg_abon (void)
{
  int n;
  struct IN_DLG in_dlg;
  struct PU pu;
  char *s;
  struct List_To_Ret list_to;

  in_dlg.msgs = &dlg_com;
  in_dlg.prompt = prompt;
  in_dlg.alhlp = alhlp;
  in_dlg.hlps = &abon_dlg_hlps;
  in_dlg.zvezda = 0;

  for (;;) {
	flg_auto_cr = 1;
	n = scan_input (&in_dlg);
	flg_auto_cr = 0;
	switch (n) {
	case 1:
	  chg_abon_chg (chg_arch, FLG_VIEW | FLG_CHANGE);
	  break;
	case 2:
	  chg_abon_chg (chg_keeping, FLG_VIEW | FLG_CHANGE);
	  break;
	case 3:
	  s = two_e_word ();
	  if (s != NULL) {
		if (s[strlen (s) - 1] != '.')
		  strcat (s, ".");
		s = fixeditstr (s);
	  }
	  list_to.n_list_to = 0;
	  list_to.list_to = 0;
	  get_list_users (s, &list_to, "\n  &", " ", 0);
	  for (n = 0; n < list_to.n_list_to;) {
		get_pu (&pu, list_to.list_to[n]);
		s = fixeditstr (" ");
		strcat (s, list_to.list_to[n]);
		free (list_to.list_to[n]);
		s = strcpym (s);
		warn_d ("\n         : %s\n", pu.user);
		chg_abon_chg (chg_rem, FLG_VIEW);
		fixeditstr (s);
		chg_abon_chg (chg_pass, FLG_VIEW);
		fixeditstr (s);
		chg_abon_chg (chg_access, FLG_VIEW);
		fixeditstr (s);
		chg_abon_chg (chg_coding, FLG_VIEW);
		fixeditstr (s);
		chg_abon_chg (chg_grp, FLG_VIEW);
		fixeditstr (s);
		chg_abon_chg (chg_gate, FLG_VIEW);
		fixeditstr (s);
		chg_abon_chg (chg_arch, FLG_VIEW);
		fixeditstr (s);
		chg_abon_chg (chg_keeping, FLG_VIEW);
		fixeditstr (s);
		chg_abon_chg (chg_mail_gate, FLG_VIEW);
		fixeditstr (s);
		chg_abon_chg (chg_aliases, FLG_VIEW);
		fixeditstr (s);
		chg_abon_chg (chg_grants, FLG_VIEW);
		free (s);
		if (++n != list_to.n_list_to)
		  if (wait_cr ())
			break;
	  }
	  free0 (&list_to.list_to);
	  break;
	case 4:
	  chg_abon_chg (chg_coding, FLG_VIEW | FLG_CHANGE);
	  break;
	case 5:
	  return -1;
	case 6:
	  chg_abon_chg (chg_pass, FLG_VIEW | FLG_CHANGE);
	  break;
	case 7:
	  list_abonents ();
	  break;
	case 8:
	  chg_abon_chg (chg_rem, FLG_VIEW | FLG_CHANGE);
	  break;
	case 9:
	  chg_abon_chg (chg_grants, FLG_VIEW | FLG_CHANGE);
	  break;
	case 10:
	  chg_abon_chg (chg_grp, FLG_VIEW | FLG_CHANGE);
	  break;
	case 11:
	  chg_abon_chg (chg_access, FLG_VIEW | FLG_CHANGE);
	  break;
	case 12:
	  chg_abon_chg (chg_mail_gate, FLG_VIEW | FLG_CHANGE);
	  break;
	case 13:
	  chg_abon_chg (chg_aliases, FLG_VIEW | FLG_CHANGE);
	  break;
	case 14:
	  chg_abon_chg (delete_user, 0);
	  break;
	case 15:
	  chg_abon_chg (chg_gate, FLG_VIEW | FLG_CHANGE);
	  break;
	case 16:
	  if (chk_adm ())
		start_single_mode ();
	  break;
	case 17:
	  if (chk_adm ())
		stop_single_mode ();
	  break;
	case 18:
	  if (chk_adm ())
		edit_user ();
	  break;
	case 19:
	  return 2;
	case 20:
	  return 3;
	case 21:
	  return 4;
	case 22:
	  return 5;
	case 23:
	  return 0;
	case 24:
	  return 1;
	}
  }
}

int
dump_abon (void)
{
  int i, n, j;
  time_t t;

  get_pu (&pu_cur, Adm);
  sort_db_abonents ();
  n = n_all_pu;
  time (&t);
  printf ("# Dump users database %s", ctime (&t));
  printf ("#       -l.\n\n\
# :\n\
#\n\
#  :\n\
# '#'   - ,  \n\
# '+'   -  :        \n\
# ' '   -   \n\
# '!'   -    ,      \n\
# '&'   -     \n\
# '-'   -  \n\n\
#  :     :\n\
#  :      :\n\
#  :  :\n\
#  :    \n\
# 'K'   - 8\n\
# 'E'   - \n\
# 'A'   - CP866\n\
# 'W'   - CP1251\n\n\
#  :    \n\
# 'A'   - , ; \n\
# '-'   -  ,  ; \n\
#   ( ): CPGRUN\n\
#           : ACCESSMASTER, POSTMASTER, GATEMASTER,\n\
#                          ARCHIVER, USERMASTER, NEWSMASTER\n\n\
#  :  , '+' - , '-' - \n\
#  :\n\
# 'L' -  ,\n\
# 'A' -    ,\n\
#  :   0: -   \n\
#  :   0: -   ,  -   \n\
# 11-    :  0: -  , 1:  \n\
# 12- :    C: - ansi-  , M: \n\
# 13- :     \n\
# '-':  - \n\
# 'F':  -  \n\
# 'I':  -    \n\
# 'N':  -      \n\n\
# 14- :         \n\
#  -          ____:\n\
#     -  \n\n");

  for (i = 0; i < n; i++) {
	if (strcmp (all_pu[i].user, Adm) == 0)
	  putchar (' ');
	else
	  putchar ('+');
	printf (":%s:%s:%s:%c:", all_pu[i].user, all_pu[i].grp, all_pu[i].pass,
			all_pu[i].l);
	if ((all_pu[i].priv & GRANTS_ADM) == GRANTS_ADM)
	  putchar ('A');
	else {
	  if ((all_pu[i].priv & GRANTS_NO_GRANTS) != 0) {
		putchar ('-');
	  } else {
		if ((all_pu[i].priv & GRANTS_ACCESSMASTER) != 0)
		  putchar ('C');
		if ((all_pu[i].priv & GRANTS_POSTMASTER) != 0)
		  putchar ('P');
		if ((all_pu[i].priv & GRANTS_GATEMASTER) != 0)
		  putchar ('G');
		if ((all_pu[i].priv & GRANTS_ARCHIVER) != 0)
		  putchar ('R');
		if ((all_pu[i].priv & GRANTS_USERMASTER) != 0)
		  putchar ('U');
		if ((all_pu[i].priv & GRANTS_NEWSMASTER) != 0)
		  putchar ('N');
	  }
	}
	putchar (':');
	if ((all_pu[i].af | 040) == 'a')
	  putchar ('+');
	else
	  putchar ('-');
	putchar (':');
	if ((all_pu[i].af | 040) != all_pu[i].af)
		putchar ('A');
	else
		putchar ('L');
	putchar (':');
	printf ("%d:%d:%d:", all_pu[i].ex_direction, all_pu[i].gate,
			all_pu[i].flg_ar != 0);
	if (all_pu[i].flg_nocolor)
	  putchar ('M');
	else
	  putchar ('C');
	putchar (':');
	if (all_pu[i].flg_gmf == 0)
	  putchar ('-');
	else if (all_pu[i].flg_gmf == MAIL_FILE_GATE_COPY)
	  putchar ('F');
	else if (all_pu[i].flg_gmf == MAIL_FILE_GATE_INFO)
	  putchar ('I');
	else if (all_pu[i].flg_gmf == MAIL_FILE_GATE_REG)
	  putchar ('N');
	printf (":%d:", all_pu[i].time_keeping_files);
	for (j = 0; j < all_pu[i].naliases; j++) {
	  if (j)
		putchar (',');
	  printf ("%s", all_pu[i].aliases[j]);
	}
	printf (":%s\n", all_pu[i].rem);
  }
  return n == 0;
}

static void
line_is_err (int line, char *errm, int *err)
{
  warn_d ("%s,  %d\n", errm, line);
  (*err)++;
}

static int
get_word_column (char *s, char **endp)
{
  while (*s != ':' && *s != 0)
	s++;
  *endp = s;
  return *s == ':';
}

char *
get_long_line (void)
{
  static char *buff;
  static int nb;
#define GET_LONG_LINE_ADD 1024
  char *pb;
  int add;

  if (buff == 0) {
	buff = mallocc (GET_LONG_LINE_ADD);
	nb = GET_LONG_LINE_ADD;
  }
  pb = buff;
  add = nb;
  for (;;) {
	int l;

	if (fgets (pb, add, stdin) == NULL) {
	err:
	  free (buff);
	  return NULL;
	}
	l = strlen (pb) - 1;
	if (l < 0)
	  goto err;
	if (pb[l] != '\n') {
	  pb += l + 1;
	  add = GET_LONG_LINE_ADD;
	  nb += GET_LONG_LINE_ADD;
	  buff = reallocc (buff, nb);
	} else
	  return buff;
  }
#undef GET_LONG_LINE_ADD
}

int
load_abon_from_stdin (void)
{
  char *s;
  char *s2;
  int err = 0;
  int line = 0;
  int flg_edit;
  struct PU pu;

  char *buf;
  char *psc[16];
  int i;
  char **new_aliases;
  int old_ex_direction;

  while ((buf = get_long_line ()) != NULL) {
	line++;
	s = buf;
	switch (*s) {
	case '#':
	case '\n':
	  continue;
	case ' ':
	case '+':
	case '!':
	case '&':
	case '-':
	  flg_edit = *s;
	  break;
	default:
	  err++;
	  line_is_err (line, "  ", &err);
	  continue;
	}
	s++;
	if (*s++ != ':') {
	  line_is_err (line, "    ", &err);
	  continue;
	}
	for (i = 0; i < 14; i++) {
	  psc[i] = s;
	  if (get_word_column (s, &s2) == 0) {
		line_is_err (line, "  ", &err);
		return 1;
	  }
	  *s2++ = 0;
	  s = s2;
	  if (flg_edit == '-')
		break;
	}
	psc[14] = s;
	if (check_name (psc[0]) == 0) {
	  line_is_err (line, "  ", &err);
	  continue;
	}
	pu.user[0] = 0;
	str_up (psc[0]);
	get_pu (&pu, psc[0]);
	if ((flg_edit == '!' || flg_edit == ' ' || flg_edit == '-')
		&& pu.user[0] == 0) {
	  if (flg_edit == '!' || flg_edit == '-')
		warn_d ("  '!'  '-'   \n");
	  line_is_err (line, " ", &err);
	  continue;
	}
	if (pu.user[0] != 0 && strcmp (pu.user, psc[0]) != 0) {
	  line_is_err (line, " - , ", &err);
	  continue;
	}
	if (flg_edit == '+' && pu.user[0] != 0) {
	  line_is_err (line, "  ", &err);
	  continue;
	}
	if (flg_edit == '-') {
	  struct PU pu0;
	  pu0 = pu;
	  strcpy (pu_cur.user, Adm);
	  delete_user (&pu, &pu0, 1);
	  continue;
	}
	if (strcmp (pu.user, Adm) == 0 && flg_edit != ' ' && flg_test==0) {
	  line_is_err (line, "    ", &err);
	  continue;
	}
	if (check_name (psc[1]) == 0) {
	  line_is_err (line, "  ", &err);
	  continue;
	}
	str_up (psc[1]);
	if (flg_edit == ' ' && strcmp (pu.grp, psc[1]) != 0) {
	  line_is_err (line, "   ", &err);
	  continue;
	}
	strcpy (pu.grp, psc[1]);

	if (chk_pass (psc[2]) == 0) {
	  line_is_err (line, " ", &err);
	  continue;
	}
	str_up (psc[2]);
	if (flg_edit == ' ' && strcmp (pu.pass, psc[2]) != 0) {
	  line_is_err (line, "  ", &err);
	  continue;
	}
	strcpy (pu.pass, psc[2]);

	str_up (psc[3]);
	if (psc[3][1] != 0
		|| (psc[3][0] != 'K' && psc[3][0] != 'E' && psc[3][0] != 'A'
			&& psc[3][0] != 'W')) {
	  line_is_err (line, " ", &err);
	  continue;
	}
	if (flg_edit == ' ' && pu.l != psc[3][0]) {
	  line_is_err (line, "  ", &err);
	  continue;
	}
	pu.l = psc[3][0];

	str_up (psc[4]);
	s = psc[4];
	i = 0;
	while (*s) {
	  switch (*s++) {
	  case 'A':
		if (i) {
errg:
		  line_is_err (line, " ", &err);
		  return 1;
		  *s = 0;
		  i = -1;
		} else
		  i |= GRANTS_ADM;
		break;
	  case '-':
		if (i)
		  goto errg;
		i |= GRANTS_NO_GRANTS;
		break;
	  case 'C':
		if ((i & GRANTS_NO_GRANTS) != 0)        /* NO_GRANTS or ADM */
		  goto errg;
		i |= GRANTS_ACCESSMASTER;
		break;
	  case 'P':
		if ((i & GRANTS_NO_GRANTS) != 0)        /* NO_GRANTS or ADM */
		  goto errg;
		i |= GRANTS_POSTMASTER;
		break;
	  case 'G':
		if ((i & GRANTS_NO_GRANTS) != 0)        /* NO_GRANTS or ADM */
		  goto errg;
		i |= GRANTS_GATEMASTER;
		break;
	  case 'R':
		if ((i & GRANTS_NO_GRANTS) != 0)        /* NO_GRANTS or ADM */
		  goto errg;
		i |= GRANTS_ARCHIVER;
		break;
	  case 'U':
		if ((i & GRANTS_NO_GRANTS) != 0)        /* NO_GRANTS or ADM */
		  goto errg;
		i |= GRANTS_USERMASTER;
		break;
	  case 'N':
		if ((i & GRANTS_NO_GRANTS) != 0)        /* NO_GRANTS or ADM */
		  goto errg;
		i |= GRANTS_NEWSMASTER;
		break;
	  case 0:
		break;
	  }
	}
	if (i == -1)
	  continue;
	if (flg_edit == ' ' && pu.priv != i) {
	  line_is_err (line, "  ", &err);
	  continue;
	}
	if (strcmp (psc[0], Adm) != 0 && i == GRANTS_ADM) {
	  line_is_err (line,
	      "     ", &err);
	  continue;
	}
	pu.priv = i;

	if (psc[5][1] != 0 || (psc[5][0] != '+' && psc[5][0] != '-')) {
	  line_is_err (line, " ", &err);
	  continue;
	}
	i = psc[5][0] == '+' ? 'A' : 'D';
	if (flg_edit == ' ' && (pu.af | 040) != (i | 040)) {
	  line_is_err (line, "  ", &err);
	  continue;
	}

	str_up (psc[6]);
	if (psc[6][1] != 0 || (psc[6][0] != 'L' && psc[6][0] != 'A')) {
	  line_is_err (line, "  /", &err);
	  continue;
	}
	if (psc[6][0] == 'L')
	  i |= 040;
	if (flg_edit == ' ' && pu.af != i) {
	  line_is_err (line, " /  ", &err);
	  continue;
	}
	pu.af = i;

	s = psc[7];
	i = g_int(&s);
	if(*s != 0 || i<0 || i>MAX_DIRECTIONS) {
	    line_is_err (line, "   ", &err);
	    continue;
	}
	if (flg_edit == ' ' && pu.ex_direction != i) {
	  line_is_err (line, "    ", &err);
	  continue;
	}
	old_ex_direction = pu.ex_direction;
	pu.ex_direction = i;

	s = psc[8];
	i = strtol (psc[8], &s, 10);
	if (s == psc[8] || (i != 0 && gate_exist (i, -1) == 0)) {
	  line_is_err (line, "  ", &err);
	  continue;
	}
	if (flg_edit == ' ' && pu.gate != i) {
	  line_is_err (line, "  ", &err);
	  continue;
	}
	pu.gate = i;

	if (psc[9][1] != 0 || (psc[9][0] != '0' && psc[9][0] != '1')) {
	  line_is_err (line, "  ", &err);
	  continue;
	}
	i = psc[9][0] == '1';
	if (flg_edit == ' ' && pu.flg_ar != i) {
	  line_is_err (line, "   ", &err);
	  continue;
	}
	pu.flg_ar = i;

	str_up (psc[10]);
	if (psc[10][1] != 0 || (psc[10][0] != 'C' && psc[10][0] != 'M')) {
	  line_is_err (line, "  ANSI- ", &err);
	  continue;
	}

	i = psc[10][0] == 'M';
	if (flg_edit == ' ' && pu.flg_nocolor != i) {
	  line_is_err (line, " ANSI-   ",
				   &err);
	  continue;
	}
	pu.flg_nocolor = i;

	str_up (psc[11]);
	i = psc[11][0];
	if (psc[11][1] != 0) {
errpg:
	  line_is_err (line, "  ", &err);
	  continue;
	}
	switch (i) {
	case '-':
	  i = 0;
	  break;
	case 'F':
	  i = MAIL_FILE_GATE_COPY;
	  break;
	case 'I':
	  i = MAIL_FILE_GATE_INFO;
	  break;
	case 'N':
	  i = MAIL_FILE_GATE_REG;
	  break;
	default:
	  goto errpg;
	}
	if (flg_edit == ' ' && pu.flg_gmf != i) {
	  line_is_err (line, "   ", &err);
	  continue;
	}
	pu.flg_gmf = i;

	i = strtol (psc[12], &s, 10);
	if (s == psc[12]) {
	  line_is_err (line, "    ", &err);
	  continue;
	}
	if (flg_edit == ' ' && pu.time_keeping_files != i) {
	  line_is_err (line, "    ", &err);
	  continue;
	}
	pu.time_keeping_files = i;

	i = 0;
	if (psc[13][0] != 0) {
	  i = params (psc[13], &new_aliases);
	  if (i == 0) {
		line_is_err (line, "  ", &err);
		continue;
	  }
	  sort_strndim (i, new_aliases);
	}
	if (flg_edit == ' ' && pu.naliases != i) {
	  line_is_err (line, "   ", &err);
	  continue;
	}
	if (flg_edit == ' ' && pu.naliases > 0) {
	  sort_strndim (pu.naliases, pu.aliases);
	  for (i = 0; i < pu.naliases; i++)
		if (strcmp (new_aliases[i], pu.aliases[i]))
		  break;
	  if (pu.naliases != i) {
		line_is_err (line, "  ", &err);
		for (i = 0; i < pu.naliases; i++)
		  free (new_aliases[i]);
		free (new_aliases);
		continue;
	  }
	}
	if (pu.user[0] == 0) {
	  pu.naliases = 0;
	  pu.aliases = 0;
	} else {
	  while (--pu.naliases >= 0)
		free (pu.aliases[pu.naliases]);
	  pu.naliases = 0;
	}
	add_alias (new_aliases, i, &pu.aliases, &pu.naliases);
	for (i = 0; i < pu.naliases; i++) {
	  struct PU pu1;
	  if (get_pu (&pu1, pu.aliases[i]) != 0
		  && strcmp (pu.user, pu1.user) != 0) {
		strcpy (pu.user, pu1.user);
		break;
	  }
	}
	if (i < pu.naliases) {
	  warn_d (" %s     %s\n",
			  pu.aliases[i], pu.user);
	  line_is_err (line, "  ", &err);
	  continue;
	}

	if (strlen (psc[14]) >= MAXPU_REM_LEN) {
	  warn_d ("     %d \n", MAXPU_REM_LEN - 1);
	  line_is_err (line, "( )", &err);
	  psc[14][MAXPU_REM_LEN - 1] = 0;
	}
	i = strlen (psc[14]) - 1;
	if (psc[14][i] == '\n')
	  psc[14][i] = 0;
	if (flg_edit == ' ' && strcmp (pu.rem, psc[14]) != 0) {
	  line_is_err (line, "  ", &err);
	  continue;
	}
	strcpy (pu.rem, psc[14]);
	if (flg_edit == ' ')
	  continue;
	if (pu.user[0] == 0) {
	  struct PU newpu;

	  if (add_user_fun(psc[0], &newpu) == 0)
		return 1;
	  strcpy(pu.user, newpu.user);
	  old_ex_direction = 0;
	}
	if (db_add_user (&pu, 1) == 0) {
	  warn_d ("     \n");
	  return 1;
	}
	set_pu (&pu);
	ext_chg_user(&pu, old_ex_direction);
  }
  return err != 0;
}
