/*   */

/* #define DEBUG */

#include <unistd.h>
#include <utime.h>

#include "fun.h"
#include "keyboard.h"
#include "db.h"
#include "hlps.h"
#include "ex.h"

#define MAX_IN_FILE_TO_NODELETE 150

static int infile_to_get_reput (void);
static void put_regs_from_ig (void);
static void sz_proto (int flg_sz);
static int form_cansel_gf (int n, int flg_re);


static char flg_auto_deny_outs;

static void
save_arch (int flg_out, char *mm_dd, char *name, char *pthname)
{
  char dir_arch_save[128];
  char *dir_arch_save_file, *s, *t = NULL;
  struct stat statb;
  int nn = 0;

  if (mkdir_save_arch
	  (flg_out, mm_dd, name, dir_arch_save, &dir_arch_save_file) == 0) {
	s = dir_arch_save_file;
	while (stat (s, &statb) == 0) { /*     */
	  free0(&t);
	  t = bb_asprintf("%s.%d", dir_arch_save_file, ++nn);
	  s = t;
	}
	if (link (pthname, s))
	  warn_d ("    \n");
	else
	  utime (s, 0);
	if(s != dir_arch_save_file)
	    free(s);
	free(dir_arch_save_file);
  }
}

static int
qsort_compar_inf (const void *p1, const void *p2)
{
  struct INF_S *inf_s1;
  struct INF_S *inf_s2;
  inf_s1 = (struct INF_S *) p1;
  inf_s2 = (struct INF_S *) p2;
  return strcmp (inf_s1->file_inc, inf_s2->file_inc);
}

static struct INF_S *inf_s;
static int n_inf_s;


void
scan_new_files (void)
{
  int n, un, i;
  char path_tst_uo[10 + MAXPU_LEN + INC_KEY_SIZE];      /* ../user/out/file */
  struct stat statb;
  int n_ud;

  if (stat_db_chg (N_DB_INF) == 0)
	return;
  for(i = n_inf_s; --i >= 0;)
    free(inf_s[i].file);
  free0 (&inf_s);
  n_inf_s = 0;
  n = get_db_inf (&inf_s);
  if (n > 0) {
	n_inf_s = n;
	n_ud = un = 0;
	for (i = 0; i < n; i++) {
	  sprintf (path_tst_uo, "../%s/out/%s", inf_s[i].user, inf_s[i].file_inc);
	  if (stat (path_tst_uo, &statb))
		inf_s[i].flg_uo = 1;
	  if (inf_s[i].flg_new == '1') {
		inf_s[i].flg_new_sav = '1';
		inf_s[i].flg_new = '0';
		inf_s[i].chg_info = 1;
		if(inf_s[i].flg_uo)
		    n_ud++;
		un++;
	  } else
		inf_s[i].flg_new_sav = '0';
	}
	qsort (inf_s, n, sizeof (struct INF_S), qsort_compar_inf);
	if (un) {
	  if((un-n_ud)>0)
	    rus_num_files ("\n", un-n_ud, 1, ".\n");
	  if (mode_auto_get_new_files > 0) {
		fixeditstr ("PRINQTX :NEPR");
		i = infile_to_get_reput ();
		if (i) {
		  if (form_cansel_gf (i, 2) > 0) {
			put_regs_from_ig ();
			if (mode_auto_get_proto)
			  sz_proto (0);
		  }
		  if (mode_auto_del_putted_newfin) {
			for (i = 0; i_synt_l[i] != 0; i++) {
			  inf_s[i_synt_l[i] - 1].flg_d = '1';
			  inf_s[i_synt_l[i] - 1].chg_info = 1;
			}
			n_ud = 0;
			for (un = 0; un < n; un++)
			  if (inf_s[un].flg_d == '0' && inf_s[un].flg_uo != 0) {
				inf_s[un].flg_d = '1';
				inf_s[un].chg_info = 1;
				n_ud++;
			  }
			set_rd_newu_inf (inf_s, n);
			if (i)
			  warn_d ("\n%c %s %s\n",
				    (i == 1 ? '' : ''),
				    (i == 1 ? "" : ""), (i == 1 ? "" : ""));
			if (n_ud)
			  warn_d ("\n%c %s  %s\n",
				    (i == 1 ? '' : ''),
				    (i == 1 ? "" : ""), (i == 1 ? "" : ""));
		  }
		}
	  } else
		set_rd_newu_inf (inf_s, n);
	}
  }
}



int
gf (int n, int flg_re)
{

  struct IN_DLG in_dlg;
  int i, l;
  char *bufc;
  struct stat st;
  long sz = 0;

  in_dlg.msgs = &dlg_gf;
  in_dlg.hlps = &dlg_gf_hlps;
  in_dlg.prompt = prompt_gf;
  in_dlg.alhlp = alhlp_gf;
  in_dlg.zvezda = 0;

  if ((flg_re & 2) != 0)
	i = 1;
  else {
	rus_num_files ("", n, 0,
			(flg_re & 1) ? "  ." : ".");
	if (flg_inetd == 0)
	  i = scan_input (&in_dlg);
	else {
	  putcc ('\n');
	  i = 3;
	}
  }
  switch (i) {
  case 1:
  case 3:
	chdir ("tmp");
	l = strlen("sz -ru -w 1024 ");
	for (i = 0; i < n; i++)
	    l += strlen (name_dlist[i]) + 1;
	bufc = alloca (l);
	strcpy (bufc, (flg_re & 1) ? "sz -ru" : "sz -u");
	if (mode_rz_win) {
	  /* Zmodem c  1024,  512 */
	  strcat (bufc, " -w 1024");
	}
	for (i = 0; i < n; i++) {
	  strcat (bufc, " ");
	  strcat (bufc, name_dlist[i]);
	  if (stat (name_dlist[i], &st) == 0)
		sz += st.st_size;
	  else
		error_d (19, "Error stat tmp file");
	  if (flg_inetd != 0 && send_ip (name_dlist[i], flg_re & 1) > 0)
		unlink (name_dlist[i]);
	}
	if (flg_inetd == 0) {
	  debug1 (printf ("system(%s)\n", bufc));
	  debug2 (run_and_check_idle (bufc));
	  bytes_out += sz + sz / 15;    /*  IHMO */
	  bytes_in += sz / 15;
	}
	chdir ("..");
	debug1 (clear_tmp (0));
	i = my_scandir ("tmp");
	if (i == 0)
	  putcs ("\n .\n");
	else
	  putcs ("\n .\n");
	break;
  case 2:
	clear_tmp (0);
	i = n;
	break;
  }
  return i;
}

static int
form_cansel_gf (int n, int flg_re)
{
  int i, j, k;

  i = gf (n, flg_re);
  if (i == 0)
	return n;
  if (i >= n) {
	i_synt_l[0] = 0;
	return 0;
  }
  for (k = 0; k < i; k++)
	for (j = 0; j < n; j++)
	  if (i_synt_l[j] > 0 &&
		  !strcmp (inf_s[i_synt_l[j] - 1].file, name_dlist[k]))
		  i_synt_l[j] = -1;
  k = 0;
  for (j = 0; j < n; j++)
	if (i_synt_l[j] > 0)
	  i_synt_l[k++] = i_synt_l[j];
  i_synt_l[k] = 0;
  return k;
}

static int
set_flg_in (int reverse_removed)
{
  int i, n, flg_ok;

  if (reverse_removed != 0)
	if (two_e_word () != 0)
	  reverse_removed = 0;
  n = n_inf_s;
  set_flg_from_num (n, FLG_START);
  for (i = 0; i < n;) {
	flg_ok = 0;
	if (inf_s[i].flg_r == '1')
	  flg_ok |= FLG_READ;
	if ((reverse_removed == 0 && inf_s[i].flg_d == '1') ||
		(reverse_removed != 0 && inf_s[i].flg_d != '1'))
	  flg_ok |= FLG_DELET;
	if (inf_s[i].flg_new_sav == '1')
	  flg_ok |= FLG_NEW;
	set_flg_from_num (++i, flg_ok);
  }
  return chk_f_list (n);
}

static char ftitle[] = "\n\
 ##  +-   -+     ()  / +-  -...\n";

static void
put_ls_in (int i, int flg_title)
{
  char s_sz[16];

  if (flg_title != 0)
	warn_d (ftitle);
  snprintf(s_sz, sizeof(s_sz), "%ld", inf_s[i].sz);
  warn_d ("%s %-3d\r1%c\r7", inf_s[i].flg_r == '0' ? "\r1-\r7" : "\r2+\r7",
		i + 1,
		    inf_s[i].flg_d == '1' ? '' :
			inf_s[i].flg_uo ? '' : ' ');
  warn_d (" %s %s %s %s\n", toshort(inf_s[i].file, s_sz), s_sz,
		  decode_inc_may_be_old(inf_s[i].file_inc), inf_s[i].rem);
}

static int
out_n_file (int j, int n, char *name_dir, int flg_auto,
			char *title, int flg_no_eof)
{
  struct stat statb;
  char *na_inc;
  char *namerenames1;
  char namerenames2[INC_KEY_SIZE + 4];
  int i;

  pof = reallocc (pof, (n + j) * sizeof (struct OUTF_S));
  for (i = 0; i < j; i++) {
	pof[n].file = strcpym(name_dlist[i]);
	str_up (pof[n].file);
	na_inc = name_auto_increment ();
	strcpy (pof[n].file_inc, na_inc);
	strcpy (pof[n].rem, title);
	pof[n].flg_noeof = flg_no_eof;
	pof[n].nuser = 0;
	pof[n].user = 0;
	pof[n].din = 0;
	pof[n].flg_r = 0;
	pof[n].flg_d = 0;
	decode_inc (na_inc, pof[n].d);
	namerenames1 = bb_asprintf("%s%s", name_dir, name_dlist[i]);
	stat (namerenames1, &statb);
	if (statb.st_size == 0) {
	  if (flg_no_eof == 0)
	      warn_d (" \r2%s \r1!      \r7\n",
				pof[n].file);
	  free(namerenames1);
	  continue;
	}
	pof[n].sz = statb.st_size;
	if (flg_auto == 0) {
	  bytes_out += statb.st_size / 15;      /* ~ IHMO */
	  bytes_in += statb.st_size + statb.st_size / 15;
	}
	strcpy (namerenames2, "out/");
	strcat (namerenames2, na_inc);
	rename (namerenames1, namerenames2);
	chmod (namerenames2, 0644);
	free(namerenames1);
	if (pu_cur.flg_ar)
	  save_arch (SAVE_ARCH_OUT, &pof[n].d[6], name_dlist[i], namerenames2);
	put_db_ouf (&pof[n], 0);
	n++;
  }
  return n;
}

static int
infile_to_get_reput (void)
{
  int i, j, k;

  char *pathtmp;
/* ../USER/out/FILE\0 */
  char pathuser[10 + MAXPU_LEN + INC_KEY_SIZE];

  k = 0;
  for (i = 0; i < n_inf_s; i++)
	if (inf_s[i].flg_d == '0'
		&& (inf_s[i].flg_r == '1' || inf_s[i].flg_uo != 0)) k++;
  if (k >= MAX_IN_FILE_TO_NODELETE) {
	warn_d ("\r1      !\n\
  .\r7\n");
	return 0;
  }
  if (set_flg_in (0) <= 0)
	return 0;
  k = 0;
  for (i = 0; i_synt_l[i] != 0; i++)
	if (inf_s[i_synt_l[i] - 1].flg_uo == 0)
	  for (j = i + 1; i_synt_l[j] != 0; j++)
		if (inf_s[i_synt_l[j] - 1].flg_uo == 0 &&
			!strcmp (inf_s[i_synt_l[i] - 1].file,
					 inf_s[i_synt_l[j] - 1].file)) k++;
  if (k) {
	warn_d ("\r2       ,\n\
    .\r7\n");
	return 0;
  }
  clear_tmp (0);
  k = j = 0;
  for (i = 0; i_synt_l[i] != 0; i++)
	j++;
  put_names (0, j);
  for (i = 0; i < j; i++) {
	pathtmp = bb_asprintf("tmp/%s", inf_s[i_synt_l[i] - 1].file);
	sprintf (pathuser, "../%s/out/%s", inf_s[i_synt_l[i] - 1].user,
					    inf_s[i_synt_l[i] - 1].file_inc);
	if (link (pathuser, pathtmp) == 0) {
	  put_names (inf_s[i_synt_l[i] - 1].file, 0);
	  k++;
	} else {
	  inf_s[i_synt_l[i] - 1].flg_uo = 1;
	  warn_d (" %s  \n", inf_s[i_synt_l[i] - 1].file);
	}
	free(pathtmp);
  }
  if (k < j) {
	for (i = 0; i < j; i++)
	  if (inf_s[i_synt_l[i] - 1].flg_uo)
		i_synt_l[i] = -1;
	k = 0;
	for (i = 0; i < j; i++)
	  if (i_synt_l[i] > 0)
		i_synt_l[k++] = i_synt_l[i];
	i_synt_l[k] = 0;
  }
  return k;
}

static void
put_regs_from_ig (void)
{
  struct tm *ptm;
  time_t tt;
  int i;

  time (&tt);
  ptm = localtime (&tt);
  for (i = 0; i_synt_l[i] != 0; i++)
	if (inf_s[i_synt_l[i] - 1].flg_r == '0'
		&& inf_s[i_synt_l[i] - 1].flg_uo == 0)
	  put_regs1_from_ig (&inf_s[i_synt_l[i] - 1], ptm);
  set_rd_newu_inf (inf_s, n_inf_s);
}

static void
sz_proto (int flg_sz)
{                                               /*   */
  static const char szcmd[] = "sz -w 1024 ";
  char namefsz[64 + 12];
  char fname[INC_KEY_SIZE];
  struct IN_DLG in_dlg;

  FILE *pr;
  int i;
  long sz = 0;
  char buf[5 * 80];
  time_t di;
  struct tm *ptm;

  clear_tmp (1);
  strcpy (fname, name_auto_increment ());       /* .pid.num */
  strcpy (&fname[9], "prt");                    /* .prt */
  strcpy (namefsz, szcmd);
  strcat (namefsz, fname);                      /* sz -w 1024 .prt */
  pr = fopen (fname, "w");
  if (pr == NULL)
	error_d (3, "      ");
  di = time (NULL);
  ptm = localtime (&di);
  fprintf (pr, "\nProtocol: %02d:%02d %02d.%02d.%d %s.",
		   ptm->tm_hour, ptm->tm_min,
		   ptm->tm_mday, ptm->tm_mon + 1, ptm->tm_year + 1900,
		   tcp_clienthost ());
  for (i = 0; i_synt_l[i] != 0; i++) {
	char s_sz[16];

	strcpy (buf, ftitle);
	strcat (buf, f_prompt ("%c %-3d%c",
			inf_s[i_synt_l[i] - 1].flg_r == '0' ? '-' : '+',
			i + 1,
			inf_s[i_synt_l[i] - 1].flg_d == '1' ? '' :
			    inf_s[i_synt_l[i] - 1].flg_uo ? '' : ' '));
	snprintf(s_sz, sizeof(s_sz), "%ld", inf_s[i_synt_l[i] - 1].sz);
	strcat (buf, f_prompt (" %s %s %s %s\n",
					toshort(inf_s[i_synt_l[i] - 1].file, s_sz),
					s_sz,
					&inf_s[i_synt_l[i] - 1].d[6],
					inf_s[i_synt_l[i] - 1].rem));
	if (inf_s[i_synt_l[i] - 1].flg_uo)
	  strcat (buf, f_prompt ("  %s\n",
				    inf_s[i_synt_l[i] - 1].user));
	else
	  strcat (buf, f_prompt ("  %s %s\n",
						inf_s[i_synt_l[i] - 1].user,
						inf_s[i_synt_l[i] - 1].d));
	putc_encode_buff(buf, pr);
	sz += strlen (buf);
  }
  fclose (pr);

  in_dlg.msgs = &dlg_gf;
  in_dlg.prompt = prompt_gf;
  in_dlg.alhlp = alhlp_gf;
  in_dlg.hlps = &dlg_gf_hlps;
  in_dlg.zvezda = 0;

  if (flg_sz == 0)
	warn_d ("\n    \n");
  if (flg_sz == 0 || scan_input (&in_dlg) == 1) {
	debug1 (printf ("system(%s)\n", namefsz));
	if (flg_inetd)
	  send_ip (fname, 0);
	else {
	  debug2 (run_and_check_idle (namefsz));
	  bytes_out += sz + sz / 15;
	  bytes_in += sz / 15;
	}
  }
  if (flg_sz == 0 && pu_cur.flg_ar != 0) {
	FILE *fcp;
	char dir_arch_save[128];

	sprintf (dir_arch_save, "../../../%s/%s/PROTOCOL.TXT",
			 dir_arch, pu_cur.user);
	fcp = fopen (dir_arch_save, "a");
	if (fcp == NULL)
	  error_d (3, "     ");
	pr = fopen (fname, "r");
	if (pr == NULL)
	  error_d (3, "  ");
	while ((i = getc (pr)) != EOF)
	  putc (i, fcp);
	fclose (pr);
	fclose (fcp);
	warn_d ("\n      .\n");
  }
  unlink (fname);
  chdir ("..");
}

static char *dlg_com[] = {
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "-",
  "",
  "\n",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  NULL
};

static char prompt[] =
  "\n // (, , , ..., -, ?)";

static const char alhlp[] = "\
 []       -    \n\
 [par]   -   \n\
      [par]   -   \n\
         [par]   -  \n\
    [par]   -   \n\
         [par]   -      \n\
       [par]   -     \n\
     [par]   -      \n\
        [par]   -    \n\
      [par]  ,    -\n\
 .      \n\
 : ? *.\n\n";

static int
dlg_files_in (int cmd, char *arg)
{
  int i, n, flg_ok;
  struct IN_DLG in_dlg;

  in_dlg.msgs = &dlg_com;
  in_dlg.hlps = &in_dlg_hlps;
  in_dlg.prompt = prompt;
  in_dlg.alhlp = alhlp;
  in_dlg.zvezda = out_in_zvezda;

  n = n_inf_s;
  if (n <= 0) {
	warn_d ("\r2  \r7\n");
	return 0;
  }
  if (pu_cur.time_keeping_files) {
	long hash = hash_decode_inc (name_auto_increment ());
	long keeping = 60l * 60l * 24l * pu_cur.time_keeping_files;
	char buff[80];

	flg_ok = 0;
	for (i = 0; i < n; i++)
	  if (inf_s[i].flg_uo != 0 && inf_s[i].flg_d == '0' &&
		  /*  time_keeping_files */
		  (hash_decode_inc (inf_s[i].file_inc) + keeping) < hash) {
		inf_s[i].flg_d = '1';
		inf_s[i].chg_info = 1;
		flg_ok++;
	  }
	if (flg_ok) {
	  set_rd_newu_inf (inf_s, n);
	  sprintf (buff, "   %d %s.\r7\n",
			   pu_cur.time_keeping_files,
			   (pu_cur.time_keeping_files == 1 ? "" : ""));
	  rus_num_files ("\r1", flg_ok, 2, buff);
	}
	flg_ok = 0;
	for (i = 0; i < n; i++)
	  if (inf_s[i].flg_r == '1' && inf_s[i].flg_d == '0' &&
		  /*  time_keeping_files */
		  (hash_decode_inc (inf_s[i].file_inc) + keeping) < hash) {
		inf_s[i].flg_d = '1';
		inf_s[i].chg_info = 1;
		flg_ok++;
	  }
	if (flg_ok) {
	  set_rd_newu_inf (inf_s, n);
	  sprintf (buff, "  %d %s.\r7\n",
			   pu_cur.time_keeping_files,
			   (pu_cur.time_keeping_files == 1 ? "" : ""));
	  rus_num_files ("\r1", flg_ok, 3, buff);
	}
  }
  for (;;) {
	flg_auto_cr = 1;
	cmd = scan_input (&in_dlg);
	flg_auto_cr = 0;
	switch (cmd) {
	case 1:                                 /*  */
	  if (set_flg_in (1)) {
		flg_ok = 0;
		for (i = 0; i_synt_l[i] != 0; i++)
		  if (inf_s[i_synt_l[i] - 1].flg_d == '1') {
			inf_s[i_synt_l[i] - 1].flg_d = '0';
			inf_s[i_synt_l[i] - 1].chg_info = 1;
			flg_ok++;
		  }
		if (flg_ok) {
		  set_rd_newu_inf (inf_s, n);
		  rus_num_files ("", flg_ok, 0, ".\n");
		} else
		  warn_d (" .\n");
	  }
	  break;
	case 2:                                 /*  */
	  if (set_flg_in (0)) {
		int cr = 0;
		for (i = 0; i_synt_l[i] != 0; i++) {
		  char *add_info, *add_buf;
		  if (cr >= 22) {
			if (wait_cr ())
			  break;
			cr = 0;
		  }
		  if (inf_s[i_synt_l[i] - 1].flg_uo)
			add_info = f_prompt ("  %s\n",
						inf_s[i_synt_l[i] - 1].user);
		  else
			add_info = f_prompt ("  %s %s\n",
						inf_s[i_synt_l[i] - 1].user,
						inf_s[i_synt_l[i] - 1].d);
		  add_buf = strcpym (add_info);
		  put_ls_in (i_synt_l[i] - 1, 1);
		  putcs (add_buf);
		  free (add_buf);
		  cr += 4;
		}
	  }
	  break;
	case 3:                                 /*  */
	  if (two_e_word () == 0)
		return 5;                       /*   */
	  if (scan_par ("", 0))
		break;
	  if (scan_par ("", 1))
		return 5;
	  break;
	case 4:                                 /*    */
	  i = infile_to_get_reput ();
	  if (i) {
		char title[48], *se;
		int j;

		fixeditstr("");
		for (j = 0; i_synt_l[j] != 0; j++)
		    if (inf_s[i_synt_l[j] - 1].rem[0] != 0) {
			fixeditstr(inf_s[i_synt_l[j] - 1].rem);
			break;
		    }
		se = edit_existed ("   ");
		strncpy (title, se, 38);
		title[38] = 0;
		n_pof = out_n_file (i, n_pof, "tmp/", 1, title, 0);
		rus_num_files ("", i, 0, ".\n");
	  }
	  break;
	case 5:                                 /*  */
	  i = infile_to_get_reput ();
	  if (i == 0)
		break;
	  if (form_cansel_gf (i, 0) > 0)
		put_regs_from_ig ();
	  break;
	case 6:                                 /*  */
	  if (set_flg_in (0)) {
		int cr = 0;
		for (i = 0; i_synt_l[i] != 0; i++) {
		  if (cr >= 22) {
			if (wait_cr ())
			  break;
			cr = 0;
		  }
		  put_ls_in (i_synt_l[i] - 1, cr == 0);
		  if (cr == 0)
			cr += 2;
		  cr++;
		}
	  }
	  break;
	case 7:                                 /*  */
	  if (set_flg_in (0)) {
		int j, flg_del_ask_ok, cr = 2;
		int max_in_file_to_nodelete = 0;

		flg_ok = 0;
		for (i = 0; i_synt_l[i] != 0; i++) {
		  if (inf_s[i_synt_l[i] - 1].flg_r != '0'
			  || inf_s[i_synt_l[i] - 1].flg_uo)
			    max_in_file_to_nodelete++;
		}
		for (i = 0; i_synt_l[i] != 0; i++) {
		  if (cr >= 22) {
			if (wait_cr ())
				break;
			cr = 2;
		  }
		  put_ls_in (i_synt_l[i] - 1, cr == 2);
		  cr++;
		  if (inf_s[i_synt_l[i] - 1].flg_r == '0'
			  && inf_s[i_synt_l[i] - 1].flg_uo == 0) {
			putcs ("\r1  \r7\n");
			j = 1;
			cr++;
		  } else {
			j = 0;
		  }
		  if (inf_s[i_synt_l[i] - 1].flg_d == '1') {
			putcs (" \n");
			cr++;
		  } else {
			flg_del_ask_ok = 0;
			if (inf_s[i_synt_l[i] - 1].flg_uo == 1) {
			  flg_del_ask_ok++;
			} else {
			  long hash = hash_decode_inc (name_auto_increment ());
			  long hashf = hash_decode_inc (inf_s[i_synt_l[i] - 1].file_inc);

			  if(((hashf + 60l * 60l * 8) > hash) &&
			    (max_in_file_to_nodelete < MAX_IN_FILE_TO_NODELETE)) {
			    warn_d ("\r3     8 .\r7\n");
			    cr++;
			  } else if (j == 0 || no_yes ("")) {
			    flg_del_ask_ok++;
			    cr++;
			  }
			}
			if (flg_del_ask_ok) {
			  inf_s[i_synt_l[i] - 1].flg_d = '1';
			  inf_s[i_synt_l[i] - 1].chg_info = 1;
			  flg_ok++;
			  max_in_file_to_nodelete--;
			  putcs ("\n");
			  cr++;
			}
		  }
		}
		if (flg_ok)
		  set_rd_newu_inf (inf_s, n);
	  }
	  break;
	case 8:
	    return 5;
	case 9:
	  return 0;
	case 10:
	  return 100;
	case 11:
	  break;
	case 12:
	  if (scan_par ("", 0))
		return 5;
	  return 55;
	case 13:                                /*  */
	  i = infile_to_get_reput ();
	  if (i == 0)
		break;
	  i = form_cansel_gf (i, 1);
	  if (i > 0)
		put_regs_from_ig ();
	  break;
	case 14:                                /*  */
	  if (set_flg_in (0))
		sz_proto (1);
	  break;
	case 15:
	  return 1;
	case 16:
	  return 2;
	case 17:
	  return 3;
	case 18:
	  return 4;
	case 19:
	  return 6;
	}
  }
}

void
delete_in (void)
{
  struct REG_S pregs;
  struct tm *ptm;
  int i;
  int Ok = 0;
  int n  = n_inf_s;
  struct PU pu;
  time_t tt;
  int del_no_read;

  time (&tt);
  ptm = localtime (&tt);
  if (!ptm)
    error_d (67, "   ");

  for (i = 0; i < n; i++) {
	if (inf_s[i].flg_d == '1')
	  Ok++;
	else
	  continue;
	pregs.file = NULL;
	if (inf_s[i].flg_r == '0' && inf_s[i].flg_uo == 0) {
	  pregs.file = strcpym(inf_s[i].file);
	  strcpy (pregs.file_inc, inf_s[i].file_inc);
	  strcpy (pregs.user, pu_cur.user);
	  sprintf (pregs.din, "-%02d.%02d %02d/%02d",
			   ptm->tm_hour, ptm->tm_min, ptm->tm_mday,
							ptm->tm_mon + 1);
	  strcpy (pregs.rem, inf_s[i].rem);
	  del_no_read = 1;
	} else {
	  del_no_read = 0;
	}
	if(get_pu (&pu, inf_s[i].user) == 0) {
	    free(pregs.file);
	    continue;
	}
	if (chdir (f_prompt ("../%s", inf_s[i].user)) == 0) {
		/*   */
		if(del_no_read)
		    put_db_reg (&pregs);
		if(pu.ex_direction!=host_direction)  {
		    if(del_no_read) {
			/*     */
			/*     
			     */
			ex_cmd(EXCMD_NOTIFY_FILE, pregs.file_inc,
			    f_prompt ("%s/%s/%s", convert_din(pregs.file),
						    convert_din(pregs.din),
						      convert_din(pregs.rem)),
			    &pu);
		    }
		    /*       */
		    ex_cmd(EXCMD_REVOKE_FILE, inf_s[i].file_inc, pu_cur.user, &pu);
		}
		chdir (f_prompt ("../%s", pu_cur.user));
	  }
	  free(pregs.file);
  }
  if (Ok)
	unlink_db_in (inf_s, n, 0);
}

static int
put_ls_out (int i, int flg_title, int *num_no_read)
{
  int flg_no_read = 0;
  int cr;
  char s_sz[16];

  cr = 0;
  if (flg_title != 0) {
	putcs (ftitle);
	cr += 2;
  }
  if (pof[i].flg_noeof)
	putcs ("\r1!\r7");
  else {
	putcs ("\r2");
	flg_no_read = chk_no_read (&pof[i]);
	if(flg_no_read) {
	    putcc(' ');
	} else {
	    int j;

	    for(j = 0; j < pof[i].nuser; j++)
		if(pof[i].din[j][0] == '-')
		    break;
	    putcs (j == pof[i].nuser ? "\r2+\r7" : "\r3X\r7");
	}
  }
  warn_d (" %-3d", i + 1);
  if (pof[i].flg_d)
	putcs ("\r1");
  else
	putcs (pof[i].nuser == 0 ? "\r3" : flg_no_read ? "\r6" : "\r2");
  snprintf(s_sz, sizeof(s_sz), "%ld", pof[i].sz);
  warn_d ("\r7 %s %s %s %s\n",
		  toshort(pof[i].file, s_sz), s_sz,
		  decode_inc_may_be_old(pof[i].file_inc), pof[i].rem);
  cr++;
  if (num_no_read)
	*num_no_read = pof[i].nuser == 0 ? 0 : flg_no_read;
  return cr;
}

void send_email_ex(int flg_gmf, const char *file, const char *user, long sz,
		    const char *touser, const char *fi)
{
    if (flg_gmf == MAIL_FILE_GATE_INFO)
	send_email (f_prompt ("  %s  %s (%ld )\n",
				    file, user, sz), 0, 0, 0, 0);
    else if (flg_gmf == MAIL_FILE_GATE_COPY) {
	send_email (f_prompt ("  %s  %s (%ld )\n",
	    file, user, sz), fi, file, user, touser);
    }
}

static void
out_to (struct OUTF_S *p_o, char *pa)
{
  int i, u, flg_ok;
  struct INF_S inf;
  struct List_To_Ret list_to;
  struct PU pu;
  char *file = p_o->file;

  list_to.n_list_to = 0;
  list_to.list_to = 0;

  get_list_users (pa, &list_to, (p_o->nuser ? " " : ""),
				  " ", file);
  if (list_to.n_list_to < 0) {
	warn_d ("\r1%s !\r7\n", p_o->nuser ? "" : "");
	return;
  }
  flg_ok = 0;
  for (i = 0; i < list_to.n_list_to; i++) {
	for (u = 0; u < p_o->nuser; u++)
	  if (!strcmp (p_o->user[u], list_to.list_to[i]))
		break;
	if (u == p_o->nuser || get_r_inf (p_o->file_inc, list_to.list_to[i]) != 0) {
	  int tst_present;

	  inf.file = strcpym(file);
	  strcpy (inf.file_inc, p_o->file_inc);
	  tst_present = test_present_file (list_to.list_to[i], &inf, pof, n_pof);
	  if (tst_present) {
	    if ((tst_present & 4))
		warn_d ("\r2  %s \
       \r1%s\r7\n", list_to.list_to[i], file);
	    else if ((tst_present & 2))
			warn_d ("\r2  %s \
   \r1%s   \r2  \r7\n", list_to.list_to[i], file);
	    else
		warn_d ("\r2  %s \
      \r1%s\r7\n", list_to.list_to[i], file);
	    warn_d ("  '\r3\r7'   \n");
	    free(inf.file);
	    continue;
	  }
	  strcpy (inf.user, pu_cur.user);
	  decode_inc (name_auto_increment (), inf.d);
	  inf.flg_r = '0';
	  inf.flg_new = '1';
	  inf.flg_d = '0';
	  inf.sz = p_o->sz;
	  strcpy (inf.rem, p_o->rem);
	  if (get_pu (&pu, list_to.list_to[i]) == 0) {
erri:
		warn_d (" %s   \n", list_to.list_to[i]);
		free(inf.file);
		continue;
	  }
	  if (chdir (f_prompt ("../%s", list_to.list_to[i])) == 0) {
		put_db_inf (&inf);
		if(pu.ex_direction==host_direction)
		    send_email_ex(pu.flg_gmf, file, pu_cur.user, p_o->sz,
			    list_to.list_to[i], p_o->file_inc);
		chdir (f_prompt ("../%s", pu_cur.user));
		if(pu.ex_direction!=host_direction) {
		    /*    
		          */
		    char *rem = convert_din(p_o->rem);

		    ex_cmd(EXCMD_SEND_FILE, p_o->file_inc,
			f_prompt ("%s/%s/%lx", file, rem, p_o->sz),
			&pu);
		    decode_converted_din(rem);
		}
		free(inf.file);
	  } else
		goto erri;
	  if (u == p_o->nuser) {
		p_o->nuser++;
		p_o->user = reallocc (p_o->user, p_o->nuser * sizeof (char *));
		p_o->din = reallocc (p_o->din, p_o->nuser * sizeof (char *));
		p_o->flg_r = reallocc (p_o->flg_r, p_o->nuser);
		p_o->user[u] = strcpym (list_to.list_to[i]);
	  } else
		free (p_o->din[u]);
	  p_o->din[u] =
		strcpym (f_prompt ("   %s\n", list_to.list_to[i]));
	  p_o->flg_r[u] = '0';
	  flg_ok++;
	} else
	  warn_d ("\r2 %s  \r7\n", p_o->user[u]);
  }
  if (flg_ok) {
	char dir[128];
	char *file;

	put_db_ouf (p_o, 1);
	if (flg_auto_deny_outs == 0)
	  warn_d (" \n");
	else
	  flg_auto_deny_outs = 0;
	decode_inc (name_auto_increment (), inf.d);
	if (mkdir_save_arch (pu_cur.flg_ar != 0 ? SAVE_ARCH_OUT :
						      SAVE_ARCH_PRO,
			      &inf.d[6],
			      pu_cur.flg_ar != 0 ? "out.prot" : pu_cur.user,
						 dir, &file) == 0) {
	  FILE *out;

	  out = fopen (file, "a");
	  free(file);
	  if (out == 0)
		warn_d ("    \n");
	  else {
		putc_encode_buff (" ", out);
		putc_encode_buff (inf.d, out);
		putc_encode_buff ("  ", out);
		putc_encode_buff (p_o->file, out);
		putc_encode_buff ("\t(", out);
		putc_encode_buff (&p_o->d[6], out);
		putc_encode_buff (") :", out);
		for (i = 0; i < flg_ok; i++) {
		  putc(' ', out);
		  putc_encode_buff (p_o->user[p_o->nuser - flg_ok + i], out);
		}
		putc ('\n', out);
		fclose (out);
	  }
	}
  }
  destroy_nlist (&list_to);
}


static void
out_put_file (char *list)
{

  static char *dlg_com_o[] = { "", "", "-", "\n", NULL };

  static char *dlg_com_o1[] = { "", "", "-", "\n", NULL };

  struct IN_DLG in_dlg;
  static char alhlp_o[] = "\
      -     \n\
     -    \n\
-       -     \n\n";

  static char *out_put_hlps[] = {
	"      -     \n",
	"     -    \n",
	"-       -     \n"
  };

  int n, i, cr;
  struct OUTF_S *p_o;
  struct List_To_Ret list_to;

  list_to.n_list_to = 0;
  list_to.list_to = 0;
  in_dlg.alhlp = alhlp_o;
  in_dlg.hlps = &out_put_hlps;
  in_dlg.zvezda = 0;
  cr = 0;

  for (n = 0; i_synt_l[n] != 0; n++) {

	i = i_synt_l[n] - 1;
	p_o = &pof[i];
	if (cr >= 22) {
	  if (wait_cr ())
		break;
	  cr = 0;
	}
	cr += put_ls_out (i, 1, 0);
	if (p_o->flg_d) {
	  putcs (
"\r2   ,     \r7\n");
	  cr++;
	  continue;
	}
	if (p_o->flg_noeof) {
	  putcs (
"\r2       ,\n\
      \r7\n");
	  cr += 2;
	  continue;
	}
	cr = 0;
	if (list == 0) {
	  in_dlg.msgs = p_o->nuser ? &dlg_com_o1 : &dlg_com_o;
	  in_dlg.prompt = p_o->nuser ?
		"\r1\r7 (\r2[]\r7, , -)" :
		" (\r2[]\r7, , -)";
	  i = 0;
	  if (p_o->nuser == 0) {
		scan_mask ("AUTO", &list_to, p_o->file, 0);
		if (list_to.n_list_to > 0) {
		  char *dot = strchr(list_to.list_to[0], '.');

		  if(dot == NULL) {
		    static char *dlg_com_o5[] = { "", "", "-", "\n", ".", NULL };
		    in_dlg.msgs = &dlg_com_o5;
		    in_dlg.prompt = strcpym (f_prompt(
				" (\r2[%s]\r7, , , -, .)",
						list_to.list_to[0]));
		  } else {
		    in_dlg.prompt = strcpym (f_prompt(
				" (\r2[%s]\r7, , , -)",
						list_to.list_to[0]));
		  }
		  i = scan_input (&in_dlg);
		  free (in_dlg.prompt);
		  if (i >= 4) {
			warn_d ("\r2\r7  \r1%s\r7.\n",
				list_to.list_to[0]);
			if(i == 5) {
			    dot = strcpym (f_prompt("%s.", list_to.list_to[0]));
			    free(list_to.list_to[0]);
			    list_to.list_to[0] = dot;
			}
		  }
		}
	  }
	  if (i == 0)
		i = scan_input (&in_dlg);
	  if (i == 3) {
		warn_d ("\r1%s !\r7\n", p_o->nuser ? "" : "");
		break;
	  }
	  if ((i == 2 && p_o->nuser == 0)
		  || ((i == 4 || i == 1) && p_o->nuser != 0)) {
		destroy_nlist (&list_to);
		continue;
	  }
	}
	if (list_to.n_list_to) {
	  out_to (p_o, i == 1 ? 0 : list_to.list_to[0]);
	  destroy_nlist (&list_to);
	} else
	  out_to (p_o, list);
  }
}


static void
auto_out_put_file (void)
{
  int n, i, j;
  struct OUTF_S *p_o;
  char auto_dir[128];
  char title[48];
  static char *pa = "!AUTO";
  static char *pa_comma = "!AUTO.";
  int fd_save_dir;
  FILE *Ffd_save_dir;

  Ffd_save_dir = fopen (".", "r");
  fd_save_dir = fileno (Ffd_save_dir);

  sprintf (auto_dir, "../../%s/%s", dir_auto, pu_cur.user);
  if (chdir (auto_dir)) {
	putcs ("   \n");
	return;
  }
  chdir ("..");
  n = my_scandir (pu_cur.user);
  if (n <= 0) {
	putcs ("      \n");
  ret_chdir:
	fchdir (fd_save_dir);
	fclose (Ffd_save_dir);
	return;
  }
  chdir (pu_cur.user);
  for (i = 0; i < n; i++) {
	if (test_long_name (name_dlist[i], 1) == 0) {
	  unlink (name_dlist[i]);
	  putcs ("\r1\r7\n");
	}
  }
  chdir ("..");
  n = my_scandir (pu_cur.user);
  if (n <= 0) {
	putcs ("       \n");
	goto ret_chdir;
  }
  fchdir (fd_save_dir);
  fclose (Ffd_save_dir);
  if (get_mask_to_file (pa + 1) == 0)
	return;
  sprintf (auto_dir, "../../%s/%s/", dir_auto, pu_cur.user);
  strncpy (title, editrem ("  "), 38);
  title[38] = 0;
  n_pof = out_n_file (n, n_pof, auto_dir, 1, title, 0);
  i = 0;
  for (j = 0; j < n; j++) {
	p_o = &pof[n_pof - n + j];/*      */
	flg_auto_deny_outs = 1;
	out_to (p_o, pa_comma);
	if (flg_auto_deny_outs) {
	  put_ls_out (n_pof - n + j, 1, 0);
	  warn_d ("\n");
	} else
	  i++;
  }
  flg_auto_deny_outs = 0;
  if (i > 0)
	rus_num_files ("", i, 0, "  \n");
}

static int
scan_in_tmp (char *dir, int **flg_read_not_full)
{
  int i, j, n;
  char **pnames;
  int *pf;

  /*     */
  j = my_scandir (dir);
  if (j <= 0)
	return j;
  pf = mallocc (j * sizeof (int));
  *flg_read_not_full = pf;
  pnames = mallocc (j * sizeof (char *));
  n = 0;
  chdir(dir);
  for (i = 0; i < j; i++) {
	int flg_ok = (name_dlist[i][0] == '.' && name_dlist[i][1] == '.');
	char *r_name = flg_ok ? name_dlist[i] + 2 : name_dlist[i];

	if (test_long_name (r_name, 0) == 0) {
	  unlink (name_dlist[i]);
test_rn:
	  warn_d ("\n");
	  pnames[i] = 0;
	} else {
	  if(r_name!=name_dlist[i])
	    rename(name_dlist[i], r_name);
	  if (test_long_name (r_name, 1) == 0) {
	    unlink (r_name);
	    goto test_rn;
	  }
	  pnames[i] = strcpym (r_name);
	  pf[n] = !flg_ok;
	  n++;
	}
  }
  put_names (0, n);
  for (i = 0; i < j; i++) {
	if (pnames[i] == 0)
	  continue;
	put_names (pnames[i], 0);
	free (pnames[i]);
  }
  free (pnames);
  chdir("..");
  return n;
}

static void
out_addition_rewriter_files (void)
{
  char namerenames1[INC_KEY_SIZE + 5];
  char *namerenames2;
  struct stat statb;
  int i, j, k;
  int *p_flg_not_full = 0;

  clear_tmp (0);
  for (i = 0; i_synt_l[i] != 0; i++) {
    strcpy (namerenames1, f_prompt ("out/%s", pof[i_synt_l[i] - 1].file_inc));
    debug1 (namerenames2 = strcpym (f_prompt ("tmp/..%s", pof[i_synt_l[i] - 1].file)));
    debug2 (namerenames2 = strcpym (f_prompt ("tmp/%s", pof[i_synt_l[i] - 1].file)));
    link (namerenames1, namerenames2);
    free(namerenames2);
  }
  j = my_scandir ("tmp");
  if (j != i) {
	putcs(
"       ,\n\
 ,    \n");
	clear_tmp (0);
	return;
  }
  if (flg_inetd == 0)
	putcs ("    Zmodem\n");
  sleep_kill_start ();
  chdir ("tmp");
  if (flg_inetd == 0)
	debug2 (run_and_check_idle ("rz -yD")); /* -D - Dionis rz */
  else
	for (i = 0; i_synt_l[i] != 0; i++) {
	  j = recv_a_ip (pof[i_synt_l[i] - 1].file, pof[i_synt_l[i] - 1].sz);
	  if (j < 0)                            /*  */
		unlink (pof[i_synt_l[i] - 1].file);
	  if (j > 0)                            /*   */
		pof[i_synt_l[i] - 1].flg_noeof = 0;
	}
  chdir ("..");
  sleep_kill_stop ();
  if (flg_inetd == 0)
	j = scan_in_tmp ("tmp", &p_flg_not_full);
  else
	j = my_scandir ("tmp");
  if (j <= 0)
	return;

  for (k = 0; k < j; k++) {
	for (i = 0; i_synt_l[i] != 0; i++)
	  if (!strcmp (pof[i_synt_l[i] - 1].file, name_dlist[k]))
		break;
	namerenames2 = strcpym(f_prompt ("tmp/%s", name_dlist[k]));
	if (i_synt_l[i] == 0) {
	  char *name_dlist0;
	  int flg_not_full;

	  flg_not_full = flg_inetd == 0 ? p_flg_not_full[k] : 0;
	  name_dlist0 = name_dlist[0];
	  name_dlist[0] = name_dlist[k];
	  /* rem not defined */
	  n_pof = out_n_file (1, n_pof, "tmp/", 0, "", flg_not_full);
	  name_dlist[0] = name_dlist0;
	  warn_d(
  ":  `%s'      .\n",
			  name_dlist[k]);
	} else {
	  if (stat (namerenames2, &statb) < 0) {
		warn_d("%s: Stat error\n", namerenames2);
		free(namerenames2);
		continue;
	  }
	  if (statb.st_size == 0)
		warn_d (
	  " `%s'  .      - .\n",
				name_dlist[k]);
	  else if (pof[i_synt_l[i] - 1].sz > statb.st_size)
		warn_d (":  `%s'   .\n",
						name_dlist[k]);
	  pof[i_synt_l[i] - 1].sz = statb.st_size;
	  if (flg_inetd == 0)
		pof[i_synt_l[i] - 1].flg_noeof = p_flg_not_full[k];
	  put_db_ouf (&pof[i_synt_l[i] - 1], 1);
	  if (pof[i_synt_l[i] - 1].flg_noeof == 0)
		warn_d ("  `%s'   \n", name_dlist[k]);
	  unlink (namerenames2);
	  free(namerenames2);
	}
  }
  free (p_flg_not_full);
}

static void
remove_to (struct OUTF_S *p_o)
{
  int i, j, flg_ok;
  struct INF_S inf;
  struct PU pu;
  char *flg_remove;
  struct IN_DLG in_dlg;

  static char alhlp_o[] = "\
      -     \n\
     -     \n\
    -       \n\
-       -     \n\n";

  static char *remove_hlps[] = {
	"      -     \n",
	"     -     \n",
	"    -       \n",
	"-       -     \n"
  };
  static char *dlg_com_o1[] = { "", "", "\n", NULL };
  static char *dlg_com_o[] = { "", "", "", "V", "-", "\n", NULL };

  flg_remove = alloca (p_o->nuser);
  memset (flg_remove, 0, p_o->nuser);
  i = 0;
  for (j = 0; j < p_o->nuser; j++)
	if (p_o->flg_r[j] == '0') {
	  flg_remove[j] = 1;
	  i++;
	}
  if(i == 1) {
    in_dlg.msgs = &dlg_com_o1;
  } else {
    in_dlg.msgs = &dlg_com_o;
  }
  in_dlg.alhlp = alhlp_o;
  in_dlg.hlps = &remove_hlps;
  in_dlg.zvezda = 0;

  if (i == 1) {
	for (j = 0; j < p_o->nuser; j++)
	  if (flg_remove[j])
		break;
	in_dlg.prompt =
	  strcpym (f_prompt("\r3\r7  \r1%s\r7 (\r2[]\r7, )",
				p_o->user[j]));
	i = scan_input (&in_dlg);
	free (in_dlg.prompt);
	if (i == 2)
	  flg_remove[j] = 2;
  } else {
	for (j = 0; j < p_o->nuser; j++)
	  if (flg_remove[j]) {
		in_dlg.prompt =
		  strcpym (f_prompt(
	  "\r3\r7  \r1%s\r7 (\r2[]\r7, , , -)",
					p_o->user[j]));
		i = scan_input (&in_dlg);
		free (in_dlg.prompt);
		if (i == 2)
		  flg_remove[j] = 2;
		else if (i == 3 || i == 4) {
		  for (j = 0; j < p_o->nuser; j++)
			if (flg_remove[j])
			  flg_remove[j] = 2;
		  break;
		} else if (i == 5)
		  return;
	  }
  }
  flg_ok = 0;
  for (j = 0; j < p_o->nuser; j++)
	if (flg_remove[j] == 2) {
	  if (get_pu (&pu, p_o->user[j]) == 0) {
erri:
		warn_d ("   \n");
		continue;
	  }
	  if (chdir (f_prompt ("../%s", p_o->user[j])) == 0) {
		strcpy (inf.file_inc, p_o->file_inc);
		inf.flg_d = '1';
		unlink_db_in (&inf, 1, 0);
		if(pu.ex_direction != host_direction && inf.flg_d == '1') {
		    /*         */
		    /*     */
		    ex_cmd(EXCMD_REVOKE_FILE, p_o->file_inc, p_o->user[j], &pu);
		}
		chdir (f_prompt ("../%s", pu_cur.user));
		if (inf.flg_d != '1')
		  continue;
	  } else
		goto erri;
	  flg_remove[j] = 3;
	  free (p_o->user[j]);
	  free (p_o->din[j]);
	  flg_ok++;
	}
  if (flg_ok) {
	if ((p_o->nuser - flg_ok) == 0) {
	  free0 (&p_o->user);
	  free0 (&p_o->din);
	  free0 (&p_o->flg_r);
	} else {
	  i = 0;
	  for (j = 0; j < p_o->nuser; j++)
		if (flg_remove[j] != 3) {
		  p_o->user[i]  = p_o->user[j];
		  p_o->din[i]   = p_o->din[j];
		  p_o->flg_r[i] = p_o->flg_r[j];
		  i++;
		}
	}
	p_o->nuser -= flg_ok;
	put_db_ouf (p_o, 1);
	warn_d (" \n");
  }
}


static char *dlg_com_o[] = {
  "",
  "",
  "",
  "",
  "",
  "E",
  "",
  "",
  "",
  "",
  "-",
  "",
  "\n",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  NULL
};

static char prompt_o[] =
  "\n /./ (, ., ., ..., ?)";

static int
test_of (int n)
{
  if (n <= 0) {
	warn_d ("\r2  \r7\n");
	return 0;
  }
  return 1;
}


static int
set_flg_out (int reverse_removed)
{
  int j, i, n;

  n = n_pof;
  if (test_of (n) == 0)
	return 0;
  if (reverse_removed != 0)
	if (two_e_word () != 0)
	  reverse_removed = 0;
  set_flg_from_num (n, FLG_START);
  for (i = 0; i < n;) {
	j = chk_no_read (&pof[i]) ? 0 : FLG_READ;
	if ((reverse_removed == 0 && pof[i].flg_d != 0) ||
		(reverse_removed != 0 && pof[i].flg_d == 0))
	  j |= FLG_DELET;
	if (pof[i].nuser == 0)
	  j |= FLG_MY;
	set_flg_from_num (++i, j);
  }
  return chk_f_list (n);
}

static char alhlp_o[] = "\
            -  ,   \n\
			       !auto\n\
 []        -    \n\
         -   \n\
        [par]   -  \n\
      [par]   -   \n\
         [par]   -  \n\
    [par]   -   \n\
         [par]   -      \n\
                -      \n\
       [par]   -   \n\
     [par]   -       \n\
        [par]   -    \n\
      [par]  ,    \n\
.        : ? *.\n\n";


static int
dlg_files_out (int cmd, char *arg)
{
  int n, i, j;
  struct IN_DLG in_dlg;
  char title[48];
  char *s;

  in_dlg.msgs = &dlg_com_o;
  in_dlg.prompt = prompt_o;
  in_dlg.alhlp = alhlp_o;
  in_dlg.hlps = &out_dlg_hlps;
  in_dlg.zvezda = out_in_zvezda;

  n = n_pof;

  if (pu_cur.time_keeping_files) {
	long hash = hash_decode_inc (name_auto_increment ());
	char buff[80];
	long keeping = 60l * 60l * 24l * pu_cur.time_keeping_files;

	j = 0;

	for (i = 0; i < n; i++)
	  if (chk_no_read (&pof[i]) == 0 && pof[i].flg_d == 0 &&
		  (hash_decode_inc (pof[i].file_inc) + keeping) < hash) {
		pof[i].flg_d = 1;
		j++;
	  }
	if (j) {
	  sprintf (buff, " , %s  %d %s.\r7\n",
			   (j > 1 ? "" : ""),
			   pu_cur.time_keeping_files,
			   (pu_cur.time_keeping_files == 1 ? "" : ""));
	  rus_num_files ("\r1", j, 3, buff);
	}
	j = 0;
	for (i = 0; i < n; i++)
	  if (pof[i].nuser == 0 && pof[i].flg_d == 0 &&
		  (hash_decode_inc (pof[i].file_inc) + keeping) < hash) {
		pof[i].flg_d = 1;
		j++;
	  }
	if (j) {
	  sprintf (buff, ", %s  %d %s.\r7\n",
			   (j > 1 ? "" : ""),
			   pu_cur.time_keeping_files,
			   (pu_cur.time_keeping_files == 1 ? "" : ""));
	  rus_num_files ("\r1", j, 0, buff);
	}
  }
  for (;;) {
	flg_auto_cr = 1;
	cmd = scan_input (&in_dlg);
	flg_auto_cr = 0;
	switch (cmd) {
	case 1:                                 /*  */
	  s = two_e_word ();
	  if (s == 0) {
		auto_out_put_file ();
		n = n_pof;
	  } else {
		char *sw, *sws;
		if (n_pof == 0) {
		  putcs ("   .\n");
		  break;
		}
		sws = sw = strcpym (s);
		while (*sw != ' ' && *sw != 0)
		  sw++;
		/*    set_flg_out() */
		if (*sw == ' ')                 /* A nn user */
		  s[sw - sws] = 0;              /* A nn */
		else
		  s = fixeditstr ("A");
		if (set_flg_out (0) == 0)
		  putcs ("    .\n");
		else {
		  if (*sw == ' ')
			while (*sw == ' ')
			  sw++;
		  else
			sw = sws;
		  out_put_file (sw);
		}
		free (sws);
	  }
	  break;
	case 2:
	  if (set_flg_out (1)) {
		int flg_ok = 0;
		for (i = 0; i_synt_l[i] != 0; i++)
		  if (pof[i_synt_l[i] - 1].flg_d) {
			pof[i_synt_l[i] - 1].flg_d = 0;
			flg_ok++;
		  }
		if (flg_ok)
		  rus_num_files ("", flg_ok, 0, ".\n");
		else
		  warn_d (" \n");
	  }
	  break;
	case 3:                                 /*  */
	  if(set_flg_out (0)) {
	    struct OUTF_S *p_o;
	    int cr = 0;
	    for (i = 0; i_synt_l[i] != 0; i++) {
		j = i_synt_l[i] - 1;
		p_o = &pof[j];
		if (cr >= 22) {
			if (wait_cr ())
			  break;
			cr = 0;
		}
		cr += put_ls_out (j, 1, 0);
		if (p_o->nuser) {
		    warn_d (" \n");
		    cr++;
		} else {
		   cr = 0;
		   fixeditstr(p_o->file);
		   s = edit_existed ("");
		   while(*s == ' ')
		    s++;
		   if(*s == '.') {
		    warn_d ("  \n");
		    continue;
		   }
		   if(s[0] == 0 || strcmp(s, p_o->file) == 0) {
		    warn_d ("  \n");
		    continue;
		   }
		   if(s[0] == '-') {
		    warn_d ("  \n");
		    break;
		   }
		   if(test_long_name(s, 0) == 0)
		    continue;
		   free(p_o->file);
		   p_o->file = strcpym(s);
		   put_db_ouf (p_o, 1);
		   warn_d ("\n");
		}
	    }
	  }
	  break;
	case 4:                                 /*  */
	  if (set_flg_out (0)) {
		struct OUTF_S *p_o;
		int cr = 0;
		for (i = 0; i_synt_l[i] != 0; i++) {
		  j = i_synt_l[i] - 1;
		  p_o = &pof[j];
		  if (cr >= 22) {
			if (wait_cr ())
			  break;
			cr = 0;
		  }
		  cr += put_ls_out (j, 1, 0);
		  if (p_o->flg_r == 0) {
			warn_d (" %s\n", p_o->d);
			cr++;
		  } else {
			for (j = 0; j < p_o->nuser; j++) {
			  switch (p_o->din[j][0]) {
			  case '+':
				warn_d ("  %s %s\n",
						p_o->user[j], &p_o->din[j][1]);
				break;
			  case '-':
				warn_d ("\r1 %s    \r2%s\r7\n",
						&p_o->din[j][1], p_o->user[j]);
				break;
			  default:
				putcs (p_o->din[j]);
				break;
			  }
			  cr++;
			  if (cr >= 22) {
				if (wait_cr ()) {
				  j = -1;
				  break;
				}
				cr = 0;
			  }
			}
			if (j < 0)
			  break;
		  }
		}
	  }
	  break;
	case 5:                                 /*  */
	  if (scan_par ("", 0))
		break;
	  if (two_e_word () == 0 || scan_par ("", 1) != 0) {
		if (n_inf_s <= 0)
		  putcs ("\r2  \r7\n");
		else
		  return 5;
	  }
	  break;
	case 6:                                 /*  */
	  strncpy (title, editrem ("   "), 38);
	  title[38] = 0;
	  clear_tmp (1);
	  if (flg_inetd == 0)
		putcs ("    Zmodem\n");
	  debug1 (link ("../../../test.long.name", "test.very-very-long.name"));
	  debug1 (link ("../../../Makefile", "Makefile"));
	  sleep_kill_start ();
	  if (flg_inetd == 0) {
		debug2 (run_and_check_idle ("rz -D"));  /* Dionis rz */
	  } else {
		for (;;) {
		  i = recv_ip (&s, 0);
		  if (i >= 0) {
			put_names (0, 1);
			put_names (s, 0);
			free (s);
			if (test_long_name (name_dlist[0], 1) > 0) {
			  chdir ("..");
			  n = out_n_file (1, n, "tmp/", 0, title, i == 0);
			  chdir ("tmp");
			}
			if (i == 0)
			  break;
		  } else
			break;
		}
	  }
	  chdir ("..");
	  if (flg_inetd == 0) {
		int *p_flg_not_full = 0;

		j = scan_in_tmp ("tmp", &p_flg_not_full);
		for (i = 0; i < j; i++) {
		  char *so = name_dlist[0];

		  name_dlist[0] = name_dlist[i];
		  n = out_n_file (1, n, "tmp/", 0, title, p_flg_not_full[i]);
		  name_dlist[0] = so;
		}
		free (p_flg_not_full);
	  }
	  sleep_kill_stop ();
	  if (n > n_pof) {
		if ((n_pof + 1) == n)
		  warn_d ("\n\n      \r2%d\r7.\n", n);
		else
		  warn_d ("\n\n      \r2%d-%d\r7.\n",
				  n_pof + 1, n);
		n_pof = n;
	  }
	  clear_tmp (0);
	  break;
	case 7:                                 /*  */
	  if (set_flg_out (0)) {
		char name2[INC_KEY_SIZE + 8];
		j = 0;
		for (i = 0; i_synt_l[i] != 0; i++) {
		  if (j < 0)
			break;
		  for (j = i + 1; i_synt_l[j] != 0; j++)
			if (!strcmp
				(pof[i_synt_l[i] - 1].file, pof[i_synt_l[j] - 1].file)) {
			  j = -j;
			  break;
			}
		}
		if (j < 0) {
		  warn_d (
"\r2       ,\n\
    .\r7\n");
		  break;
		}
		j = 0;
		for (i = 0; i_synt_l[i] != 0; i++)
		  j++;
		clear_tmp (1);
		put_names (0, j);
		strcpy (name2, "../out/");
		for (i = 0; i < j; i++) {
		  put_names (pof[i_synt_l[i] - 1].file, 0);
		  strcpy (&name2[7], pof[i_synt_l[i] - 1].file_inc);
		  link (name2, name_dlist[i]);
		}
		chdir ("..");
		gf (j, 0);
	  }
	  break;
	case 8:                                 /*  */
	  s = two_e_word ();
	  if (s == 0) {
		if (set_flg_out (0))
		  out_put_file (0);
	  } else {
		char *sw, *sws;
		if (n_pof == 0) {
		  putcs ("   .\n");
		  break;
		}
		sws = sw = strcpym (s);
		while (*sw != ' ' && *sw != 0)
		  sw++;
		/*    set_flg_out() */
		if (*sw == ' ')                 /* A nn user */
		  s[sw - sws] = 0;              /* A nn */
		if (set_flg_out (0) == 0)
		  putcs ("    .\n");
		else {
		  if (*sw == ' ')
			while (*sw == ' ')
			  sw++;
		  else
			sw = 0;
		  out_put_file (sw);
		}
		free (sws);
	  }
	  break;
	case 9:
	  if (set_flg_out (0)) {
		int cr = 0;
		for (i = 0; i_synt_l[i] != 0; i++) {
		  if (cr >= 22) {
			if (wait_cr ())
			  break;
			cr = 0;
		  }
		  cr += put_ls_out (i_synt_l[i] - 1, cr == 0, 0);
		}
	  }
	  break;
	case 10:                                /*  */
	  if (set_flg_out (0)) {
		int cr = 0;
		for (i = 0; i_synt_l[i] != 0; i++) {
		  if (cr >= 22) {
			if (wait_cr ())
			  break;
			cr = 0;
		  }
		  cr += put_ls_out (i_synt_l[i] - 1, cr == 0, &j);
		  if (j) {
			if (j == 1) {
			  if (pof[i_synt_l[i] - 1].nuser > 1)
				putcs ("\r1     \r7\n");
			  else
				warn_d ("\r1   : \r2%s\r7\n",
						pof[i_synt_l[i] - 1].user[0]);
			} else
			  warn_d ("\r1   \r2%d\r1 \r7\n", j);
		  }
		  if (pof[i_synt_l[i] - 1].flg_d) {
			putcs (" \n");
			cr++;
		  } else {
			if(j) {
				j = no_yes ("");
				cr++;
			} else {
				j++;
			}
			if (j) {
			  pof[i_synt_l[i] - 1].flg_d = 1;
			  putcs ("\n");
			  cr++;
			}
		  }
		}
	  }
	  break;
	case 11:
	  return 0;
	case 12:
	  return 100;
	case 13:
	  break;
	case 14:
	  i = n_inf_s;
	  if (scan_par ("", 0)) {
		if (i <= 0)
		  putcs ("\r2  \r7\n");
		else
		  return 5;
	  }
	  return 55;
	case 15:                                        /*  */
	  if (set_flg_out (0)) {
		for (i = 0; i_synt_l[i] != 0; i++)
		  if (pof[i_synt_l[i] - 1].flg_noeof == 0) {
			put_ls_out (i_synt_l[i] - 1, 1, 0);
			putcs ("    \n");
			break;
		  }
		if (i_synt_l[i] != 0)
		  break;
		out_addition_rewriter_files ();
	  }
	  break;
	case 16:                                        /*  */
	  if (set_flg_out (0)) {
		int cr = 0;
		for (i = 0; i_synt_l[i] != 0; i++) {
		  if (cr >= 22) {
			if (wait_cr ())
			  break;
			cr = 0;
		  }
		  cr += put_ls_out (i_synt_l[i] - 1, 1, &j);
		  if (pof[i_synt_l[i] - 1].nuser == 0) {
			putcs ("    \n");
			cr++;
		  } else if (j == 0) {
			warn_d ("  %s%s\n",
			  (pof[i_synt_l[i] - 1].nuser == 1 ? "" : " "),
			  (pof[i_synt_l[i] - 1].nuser == 1 ? "" : ""));
			cr++;
		  } else if (pof[i_synt_l[i] - 1].flg_d) {
			putcs(
"\r2    ,     \r7\n"
"\r2         \r7\n");
			cr += 2;
		  } else {
			cr = 0;
			remove_to (&pof[i_synt_l[i] - 1]);
		  }
		}
	  }
	  break;
	case 17:
	  return 1;
	case 18:
	  return 2;
	case 19:
	  return 3;
	case 20:
	  return 4;
	case 21:
	  return 6;
	}
  }
}

void
delete_out (void)
{
  int i, n, ok, j;
  struct PU pu;
  struct INF_S inf;

  n = n_pof;
  ok = 0;
  for (i = 0; i < n; i++)
	if (pof[i].flg_d) {
	  ok++;
	  unlink (f_prompt ("out/%s", pof[i].file_inc));

	  /*        */
	  for(j=0; j<pof[i].nuser; j++)
	    if (get_pu (&pu, pof[i].user[j]) > 0 &&
					    pu.ex_direction!=host_direction) {
		/*     */
		if(chdir (f_prompt ("../%s", pof[i].user[j]))==0) {
		    /*    */
		    ex_cmd(EXCMD_DELETE_FILE, pof[i].file_inc, 0, &pu);
		    /*       
		            */
		    strcpy (inf.file_inc, pof[i].file_inc);
		    inf.flg_d = '1';
		    unlink_db_in (&inf, 1, 1);
		    chdir (f_prompt ("../%s", pu_cur.user));
		}
	    }
	}
  if (ok)
	unlink_db_out (pof, n);
}

/*   */
int
dlg_files (void)
{
  int n, chg;
  char *s0 = two_e_word ();

  n = inf_s != 0;
  if (n) {
	for (chg = 0; chg < n; chg++)
	  if (inf_s[chg].flg_d != '1' && inf_s[chg].flg_uo == 0)
		break;
	if (chg == n)                   /*      */
	  n = 0;
  }
  for (;;) {
	if(s0) {
	    if(*s0 == 'I') {
		n = 0;
	    } else {
		if(*s0 == 'W' || *s0 == 'V')
		    n = *s0;
	    }
	    s0 = NULL;
	}
	if (n)
	  chg = dlg_files_in (0, 0);
	else
	  chg = dlg_files_out (0, 0);
	switch (chg) {
	case 5:                                 /*   */
	  n = !n;
	  break;
	case 55:
	  chg = n_inf_s;
	  for (n = 0; n < n_inf_s; n++)
		if (inf_s[n].flg_d == '1')
		  chg--;
	  n = chg;
	  break;
	default:      /* 1,2,3,4,6,100 */
	  return chg;
	}
  }
}

void
put_regs1_from_ig (struct INF_S *pinf_s, struct tm *ptm)
{
  struct REG_S pregs;
  struct PU pu;
/* ../USER/out/FILE\0 */
  char pathuser[10 + MAXPU_LEN + INC_KEY_SIZE];

  pregs.file = strcpym (pinf_s->file);
  strcpy (pregs.file_inc, pinf_s->file_inc);
  strcpy (pregs.user, pu_cur.user);
  sprintf (pregs.din, "+%02d.%02d %02d/%02d",
		   ptm->tm_hour, ptm->tm_min, ptm->tm_mday, ptm->tm_mon + 1);
  strcpy (pregs.rem, pinf_s->rem);
  if (get_pu (&pu, pinf_s->user) == 0)  {
	/*    ? */
	free(pregs.file);
	return;
  }
  if (chdir (f_prompt ("../%s", pinf_s->user)) == 0) {
	put_db_reg (&pregs);
	if(pu.ex_direction!=host_direction)  {
	  /*     */
	  /*      */
	  ex_cmd(((pu.flg_gmf == MAIL_FILE_GATE_REG) ?
		    EXCMD_NOTIFYEFILE : EXCMD_NOTIFY_FILE),
		    pinf_s->file_inc,
		    f_prompt ("%s/%s/%s", pregs.file, convert_din(pregs.din),
						convert_din(pregs.rem)),
		    &pu);
	  decode_converted_din(pregs.din);
	  decode_converted_din(pregs.rem);
	} else if (pu.flg_gmf == MAIL_FILE_GATE_REG)
	  send_email (f_prompt ("  %s     %s\n",
			pu_cur.user, pinf_s->file), 0, 0, 0, 0);
	chdir (f_prompt ("../%s", pu_cur.user));
  }
  pinf_s->flg_r = '1';
  pinf_s->chg_info = 1;
  if (pu_cur.flg_ar) {
	sprintf (pathuser, "../%s/out/%s", pinf_s->user, pinf_s->file_inc);
	save_arch (SAVE_ARCH_IN, &pregs.din[7], pinf_s->file, pathuser);
  }
  free(pregs.file);
}
