/*    */
/* #define DEBUG */

#include <stdio.h>
#include "keyboard.h"
#include "fun.h"
#include "db.h"
#include "hlps.h"
#include "ex.h"


#define MAX_IN_REG_TO_NODELETE 200

static struct REG_S *reg_s;
static int n_regs;

static int
list_reg (int i, int flg_title)
{
  char *t;
  int num_cr = 0;
  static char ftitle[] = "\
\n # +-   -+          / +-  -...\n";

  if (flg_title) {
	putcs (ftitle);
	num_cr += 2;
  }
  if (reg_s[i].flg_d != '0')
	t = "\r1\r7";
  else if (reg_s[i].flg_r == '1')
	t = "\r2+\r7";
  else if (reg_s[i].flg_new_sav)
	t = "\r6\r7";
  else
	t = " ";
  warn_d ("%s %-4d %s %s %s %s\n", t, i + 1,
		  toshort(reg_s[i].file, reg_s[i].user),
		  reg_s[i].user, &reg_s[i].din[7], reg_s[i].rem);
  num_cr++;
  return num_cr;
}

static void
sz_uved (int no_prompt_zm)
{
  static const char szcmd[] = "sz -uw 1024 ";
  char namefsz[12 + 16];
  char fname[12 + 8];
  struct IN_DLG in_dlg;

  FILE *pr;
  int i, n;
  long sz = 0;
  time_t di;
  struct tm *ptm;

  clear_tmp (1);
  strcpy (fname, name_auto_increment ());       /* .pid.num */
  strcpy (&fname[9], "uva");                    /* .uva */
  strcpy (namefsz, szcmd);
  strcat (namefsz, fname);                      /* sz -w 1024 .uva */
  pr = fopen (fname, "w");
  if (pr == NULL)
	error_d (3, "      ");

  di = time (NULL);
  ptm = localtime (&di);
  fprintf (pr, "\nRegs: %02d:%02d %02d.%02d.%d %s.",
		   ptm->tm_hour, ptm->tm_min,
		   ptm->tm_mday, ptm->tm_mon + 1, ptm->tm_year + 1900,
		   tcp_clienthost ());
  n = n_regs;
  for (i = 0; i_synt_l[i] != 0; i++)
	sz += read_reg (reg_s + (i_synt_l[i] - 1), pr);
  if (no_prompt_zm == 0)
	warn_d (" %d %c.\n", i, (i == 1 ? '' : ''));
  fclose (pr);
  in_dlg.msgs = &dlg_gf;
  in_dlg.prompt = prompt_gf;
  in_dlg.alhlp = alhlp_gf;
  in_dlg.hlps = &dlg_gf_hlps;
  in_dlg.zvezda = 0;

  i = 1;

  if (no_prompt_zm == 1 || (i=scan_input (&in_dlg)) == 1 || i==3) {
	debug1 (printf ("system(%s)\n", namefsz));
	if (flg_inetd == 0) {
	  debug2 (run_and_check_idle (namefsz));
	  bytes_out += sz + sz / 15;
	  bytes_in += sz / 15;
	  i = my_scandir (".");
	} else {
	  if (send_ip (fname, 0) > 0)
		i = 0;
	}
  }
  unlink (fname);
  chdir ("..");
  if (i == 0)
	set_r_reg (reg_s, n);
}

static void
auto_put_regs (int flg_put_any)
{
  int i, j;
  int n = n_regs;

  i_synt_l = alloca ((n + 1) * sizeof (int));
  for (i = j = 0; i < n; i++)
	if (reg_s[i].flg_new_sav) {
	  i_synt_l[j++] = i + 1;
	}
  i_synt_l[j] = 0;
  if (mode_nogetrem == 0 || flg_put_any != 0) {
    sz_uved (1);
  }
  if (mode_auto_del_putted_regs) {
	for (i = 0; i < j; i++) {
	  reg_s[i_synt_l[i] - 1].flg_d = '1';
	  set_d_reg (&reg_s[i_synt_l[i] - 1]);
	}
	warn_d ("\n%s  \n",
			mode_nogetrem ? "" : "");
  }
  i_synt_l = 0;
}

void
scan_new_reg (void)
{
  static char *dlg_nreg[] = { "", "", "", "\n", "-", NULL };
  static char prompt[] = " ? (\r2[]\r7, , , -)";
  static char ahlp[] = "\
      -    \n\
     -  \n\
 -     \n\
`-'     -  \n";

  struct IN_DLG in_dlg;

  int n, i, un, j;

  if (stat_db_chg (N_DB_REG) == 0)
	return;
  for(i = n_regs; --i >= 0;)
    free(reg_s[i].file);
  free0 (&reg_s);
  n_regs = 0;
  n = get_db_reg (&reg_s);

  if (n > 0) {
	n_regs = n;
	if (pu_cur.time_keeping_files) {
	  long hash = hash_decode_inc (name_auto_increment ());
	  long keeping = 60l * 60l * 24l * pu_cur.time_keeping_files;

	  j = 0;
	  for (i = 0; i < n; i++)
		if (reg_s[i].flg_r == '1' && reg_s[i].flg_d == '0' &&
			/*    */
		    (hash_decode_inc (reg_s[i].file_inc) + keeping) < hash) {
		  reg_s[i].flg_d = '1';
		  set_d_reg (&reg_s[i]);
		  j++;
		}
	  if (j)
		warn_d ("\
\r1 \r2%d\r7 %s %c,  %d %s.\n", j,
			    (j == 1 ? "" : ""),
			    (j == 1 ? '' : ''),
			    pu_cur.time_keeping_files,
			    (pu_cur.time_keeping_files == 1 ? "" : ""));
	}
	un = 0;
	qsort (reg_s, n, sizeof (struct REG_S), qsort_compar_reg);
	for (i = 0; i < n; i++)
	  if (reg_s[i].flg_new == '1') {
		/*   -     
		      */
		reg_s[i].flg_new_sav = 1;
		reg_s[i].flg_new = '2';
		put_r_from_reg (reg_s[i].file_inc, reg_s[i].user, reg_s[i].din);
		un++;
	  } else
		reg_s[i].flg_new_sav = 0;
	if (un) {
	  unset_new_reg (reg_s, n);
	  warn_d ("\n \r2%d\r7 %c.\n", un, un == 1 ? '' : '');
	  if(pu_cur.flg_ar != 0) {
	    char dir[128];
	    char *file;
	    char d[16];

	    /*         */
	    j = 0;
	    for (i = 0; i < n; i++)
		if (reg_s[i].flg_new_sav && reg_s[i].file[0] != '')
		    j++;
	    if(j)
		decode_inc (name_auto_increment (), d);
	    if (j != 0 && mkdir_save_arch (SAVE_ARCH_IN, &d[6], "@notices.txt", dir, &file) == 0) {
		FILE *out = fopen (file, "a");

		if (out == 0) {
		    warn_d ("   %s\n", file);
		    free(file);
		} else {
		    time_t di;
		    struct tm *ptm;

		    free(file);
		    di = time (NULL);
		    ptm = localtime (&di);
		    fprintf (out, "\nRegs: %02d:%02d %02d.%02d.%d %s.",
			ptm->tm_hour, ptm->tm_min,
			ptm->tm_mday, ptm->tm_mon + 1, ptm->tm_year + 1900,
			tcp_clienthost ());
		    for (i = 0; i < n; i++)
			if (reg_s[i].flg_new_sav && reg_s[i].file[0] != '')
			    read_reg (reg_s + i, out);
		    fclose (out);
		    warn_d ("\n    \r2%d\r7 %c.\n", j, j == 1 ? '' : '');
		}
	    }
	  }
	  if (mode_auto_put_regs > 0 || mode_nogetrem != 0) {
		auto_put_regs (0);
		goto lret;
	  }
	  in_dlg.msgs = &dlg_nreg;
	  in_dlg.prompt = prompt;
	  in_dlg.alhlp = ahlp;
	  in_dlg.hlps = &new_reg_hlps;
	  in_dlg.zvezda = 0;
	  flg_auto_cr = 1;
	  i = scan_input (&in_dlg);
	  flg_auto_cr = 0;
	  switch (i) {
	  case 1:
	  case 4:
		j = 0;
		for (i = 0; i < n; i++)
		  if (reg_s[i].flg_new_sav) {
			read_reg (reg_s + i, 0);
			j++;
			if (j < un) {
			  if (yes_no (" ") == 0)
				break;
			}
		  }
		if (j)
		  set_r_reg (reg_s, n);
		break;
	  case 2:
	  case 5:
		break;
	  case 3:
		auto_put_regs (1);
		break;
	  }
	}
  lret:
	test_big_reg ();
  }
}

static int
set_flg_reg (int reverse_removed)
{
  int i, n, j;

  if (reverse_removed != 0)
	if (two_e_word () != 0)
	  reverse_removed = 0;
  n = n_regs;
  set_flg_from_num (n, FLG_START);
  for (i = 0; i < n;) {
	j = 0;
	if (reg_s[i].flg_new_sav)
	  j |= FLG_NEW;
	if (reg_s[i].flg_r == '1')
	  j |= FLG_READ;
	if ((reverse_removed == 0 && reg_s[i].flg_d != '0') ||
		(reverse_removed != 0 && reg_s[i].flg_d == '0'))
	  j |= FLG_DELET;
	set_flg_from_num (++i, j);
  }
  return chk_f_list (n);
}


int
dlg_reg (void)
{
  static char *dlg_com[] = {
	"",
	"",
	"",
	"",
	"",
	"-",
	"",
	"+++",
	"\n",
	"",
	"",
	"",
	"",
	"",
	NULL
  };

  static const char alhlp[] = "\
            -   \n\
                 -     \n\
                  -     \n\
              -    \n\
                 -  \n\
      ,   .\n\
    `? *'\n\n";

  static char prompt[] =
	"\n (, ., , , ., -, ?)";

  int n, i, j;
  struct IN_DLG in_dlg;

  in_dlg.msgs = &dlg_com;
  in_dlg.prompt = prompt;
  in_dlg.alhlp = alhlp;
  in_dlg.hlps = &dlg_reg_hlps;
  in_dlg.zvezda = reg_zvezda;

  n = n_regs;
  if (n == 0)
	putcs ("\r2 \r7\n");
  else
	for (;;) {
	  flg_auto_cr = 1;
	  i = scan_input (&in_dlg);
	  flg_auto_cr = 0;
	  switch (i) {
	  case 1:
		if (set_flg_reg (1) != 0) {
		  j = 0;
		  for (i = 0; i_synt_l[i] != 0; i++)
			if (reg_s[i_synt_l[i] - 1].flg_d != '0') {
			  reg_s[i_synt_l[i] - 1].flg_d = '0';
			  set_d_reg (&reg_s[i_synt_l[i] - 1]);
			  j++;
			}
		  if (j)
			putcs ("\n");
		  else
			putcs (" \n");
		}
		break;
	  case 2:
		if (set_flg_reg (0) != 0)
		  sz_uved (0);
		break;
	  case 3:
		if (set_flg_reg (0) != 0) {
		  int cr = 0;
		  for (i = 0; i_synt_l[i] != 0; i++) {
			if (cr >= 22) {
			  if (wait_cr ())
				break;
			  cr = 0;
			}
			cr += list_reg (i_synt_l[i] - 1, cr == 0);
		  }
		}
		break;
	  case 4:
		if (set_flg_reg (0) != 0) {
		  for (i = 0; i_synt_l[i] != 0;) {
			list_reg (i_synt_l[i] - 1, 1);
			read_reg (reg_s + (i_synt_l[i] - 1), 0);
			i++;
			if (i_synt_l[i] != 0) {
			  if (yes_no (" ") == 0)
				break;
			}
		  }
		  set_r_reg (reg_s, n);
		}
		break;
	  case 5:
		if (set_flg_reg (0) != 0) {
		  j = 0;
		  for (i = 0; i_synt_l[i] != 0; i++) {
			if (reg_s[i_synt_l[i] - 1].flg_r != '1') {
			  list_reg (i_synt_l[i] - 1, 1);
			  putcs (" \n");
			  if (no_yes ("") == 0)
				continue;
			}
			if (reg_s[i_synt_l[i] - 1].flg_d == '0') {
			  reg_s[i_synt_l[i] - 1].flg_d = '1';
			  set_d_reg (&reg_s[i_synt_l[i] - 1]);
			  j++;
			} else {
			  list_reg (i_synt_l[i] - 1, 1);
			  putcs (" \n");
			}
		  }
		  if (j)
			putcs ("\n");
		  else
			putcs (" \n");
		}
		break;
	  case 6:
		return 0;
	  case 7:
	  case 8:
		return 100;
	  case 9:
		break;
	  case 10:
		return 1;
	  case 11:
		return 2;
	  case 12:
		return 3;
	  case 13:
		return 5;
	  case 14:
		return 6;
	  }
	}
  return 0;
}

void
delete_reg (void)
{
  struct PU pu;
  int i;

  /*     */
  if(have_ext_users()) {
    /*    */
    for (i = 0; i < n_regs; i++) {
	if (reg_s[i].flg_d != '0') {
	    if(get_pu (&pu, reg_s[i].user) > 0 && pu.ex_direction!=host_direction) {
		    /*      */
		    ex_cmd(EXCMD_DELETE_NOTF, reg_s[i].file_inc, 0, &pu);
		}
	}
    }
  }
  unlink_db_reg (reg_s, n_regs);
}

int
test_big_reg (void)
{
  int i, n;
  if (n_regs > MAX_IN_REG_TO_NODELETE) {
	n = n_regs;
	for (i = 0; i < n_regs; i++)
	  if (reg_s[i].flg_d != '0')
		n--;
	if (n >= MAX_IN_REG_TO_NODELETE) {
	  warn_d ("   !\n");
	  return 1;
	}
  }
  return 0;
}
