#include "keyboard.h"
#include "fun.h"
#include "hlps.h"

static int
view_list (char *name, int flg_view)
{
  FILE *in;
  char buff[80];
  int n;

  in = fopen (f_prompt ("list/%s", name), "r");
  n = 0;
  if (in) {
	while (fgets (buff, 80, in) != NULL) {
	  buff[strlen (buff) - 1] = 0;
	  n++;
	  if (flg_view) {
		warn_d ("%25s", buff);
		if ((n % 2) == 0)
		  putcc ('\n');
		if ((n % 40) == 0)
		  if (wait_cr ())
			flg_view = 0;
	  }
	}
	if (flg_view)
	  putcc ('\n');
	fclose (in);
  }
  return n;
}

static void
edit_list (char *l)
{
  int i;
  char *ln;
  char *l_sav;
  FILE *out;
  struct List_To_Ret list_to;

  list_to.n_list_to = 0;
  list_to.list_to = 0;

  l_sav = alloca (strlen (l) + 1);
  ln = alloca (strlen (l) + 2);
  strcpy (ln, "&");
  strcat (ln, l);
  strcpy (l_sav, l);
  warn_d (" %s\n", ln);
  out = fopen (f_prompt ("list/%s", l_sav), "r");
  if (out == NULL) {
	out = fopen (f_prompt ("list/%s", l_sav), "w");
	if (out == NULL)
	  error_d (2, "   ");
	fprintf (out, ".\n");
  }
  fclose (out);

  get_list_users (ln, &list_to, "", "   .", 0);
  if (list_to.n_list_to < 0) {
	putcs ("\r1  \r7\n");
	return;
  }
  out = fopen (f_prompt ("list/%s", l_sav), "w");
  if (out == NULL)
	error_d (2, "   ");
  for (i = 0; i < list_to.n_list_to; i++)
	fprintf (out, "%s\n", list_to.list_to[i]);
  destroy_nlist (&list_to);
  fclose (out);
  if (i == 0) {
	unlink (f_prompt ("list/%s", l));
	warn_d ("\r2 `%s'   \r7\n", ln);
  }
}


static int
tst_msk_exist (int n, char *s, int flg_exist)
{
  int i;
  char *sp;
  static char ermsf[] = "\r2 `%s' %s   \r7\n";

  for (i = 0; i < n; i++) {
	sp = msk_u[i];
	while (*sp != 0 && *sp != ' ')
	  sp++;
	if (strncmp (msk_u[i], s, (sp - msk_u[i])) == 0) {
	  if (flg_exist)
		warn_d (ermsf, s, "");
	  return i + 1;
	}
  }
  if (flg_exist == 0)
	warn_d (ermsf, s, "");
  return 0;
}

static void
edit_mask (char *l)
{

  int nu, i, flg_chg, j;
  char *s, *ss;
  char *sp;
  char *ls;
  FILE *out;
  struct List_To_Ret list_to;

  static const char alhlp[] = "\n\
+      -     \n\
+ &     -       \n\
-             -  \n\
<Enter>            -   \n\
.                  -  \n\
?                  -  \n\
-                  -    \n\n";

  flg_chg = 0;
  ls = alloca (strlen (l) + 1);
  strcpy (ls, l);
  warn_d ("  `%s'\n", ls);
  nu = view_mask (ls, 1);
  for (;;) {
	s = editstring ("(+|- |&, . ? -)");
	switch (*s) {
	case 0:
	  for (i = 1; i <= nu; i++) {
		if (strlen (msk_u[i - 1]) >= 30)
		  warn_d ("\t%s\n", msk_u[i - 1]);
		else {
		  s = strdup (msk_u[i - 1]);
		  sp = strchr (s, ' ');
		  if (sp == 0) {
			warn_d ("\t%-30s", s);
		  } else {
			*sp = 0;
			warn_d ("\t%-14s %-14s", s, sp + 1);
		  }
		  free (s);
		  if ((i % 2) == 0)
			putcc ('\n');
		}
		if ((i % 40) == 0)
		  if (wait_cr ())
			break;
	  }
	  putcc ('\n');
	  break;
	case '-':
	  if (*(s + 1) == ' ') {
		s = two_e_word ();
	  } else {
		do
			s++;
		while(*s == ' ');
	  }
	  if (s == NULL || *s == 0) {
		if (flg_chg)
			warn_d ("\r1      \r7 `%s'\n", ls);
		goto ret_free;
	  }
	  if ((i = tst_msk_exist (nu, s, 0))) {
		i--;
		free (msk_u[i]);
		nu--;
		for (; i < nu; i++)
		  msk_u[i] = msk_u[i + 1];
		flg_chg++;
	  }
	  break;
	case '.':
	  if (flg_chg) {
		if (nu <= 0) {
		  putcs ("\r2    \r7\n");
		  unlink (f_prompt ("%s.msk", ls));
		} else {
		  sleep_kill_start ();
		  out = fopen (f_prompt ("%s.msk", ls), "w");
		  if (out == NULL)
			warn_d ("     %s\n", ls);
		  else {
			for (i = 0; i < nu; i++)
			  fprintf (out, "%s\n", msk_u[i]);
			fclose (out);
		  }
		  sleep_kill_stop ();
		}
	  }
	ret_free:
	  for (i = 0; i < nu; i++)
		free (msk_u[i]);
	  free0 (&msk_u);
	  return;
	case '?':
	  putcs (alhlp);
	  break;
	case '+':
	  sp = s;
	  do
		sp++;
	  while(*sp == ' ');
	  sp = strcpy (s, sp);
	  while (*sp) {
		if (*sp == ' ')
		  break;
		sp++;
	  }
	  if (*sp != ' ')
		goto err;
	  *sp++ = 0;
	  ss = strcpym (s);
	  while (*sp == ' ')
		strcpy (sp, sp + 1);
	  if (*sp == 0) {
		free(ss);
		goto err;
	  }
	  list_to.n_list_to = 0;
	  list_to.list_to = 0;

	  get_list_users (sp, &list_to, "", "   .", 0);
	  if (list_to.n_list_to < 0) {
		putcs ("   \n");
		break;
	  }
	  if (tst_msk_exist (nu, ss, 1) == 0) {
		if (nu == 0)
		  msk_u = 0;
		msk_u = reallocc (msk_u, (nu + 1) * sizeof (char **));
		i = 0;
		for (j = 0; j < list_to.n_list_to; j++)
		  i += strlen (list_to.list_to[j]) + 1;
		msk_u[nu] = mallocc (strlen (ss) + 2 + i);
		strcpy (msk_u[nu], ss);
		for (j = 0; j < list_to.n_list_to; j++) {
		  strcat (msk_u[nu], j == 0 ? " " : ",");
		  strcat (msk_u[nu], list_to.list_to[j]);
		}
		nu++;
		flg_chg++;
	  }
	  destroy_nlist (&list_to);
	  free (ss);
	  break;
	default:
	err:
	  putcs ("    \n");
	  break;
	}
  }
}

static char *dlg_com[] = {
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "-",
  "",
  "\n",
  "",
  "",
  "",
  "",
  NULL
};


static char prompt[] =
  "\n (, , , , , ..., -, ?)";

static const char alhlp[] = "\
            -     \n\
         [par] -     \n\
         [par] -   \n\
          -    \n\
 [par] -  \n\
        [par] -    \n\
       [par] -  \n\n";


int
dlg_list (void)
{

  int n, i;
  struct IN_DLG in_dlg;
  char *s;

  in_dlg.msgs = &dlg_com;
  in_dlg.hlps = &dlg_list_hlps;
  in_dlg.prompt = prompt;
  in_dlg.alhlp = alhlp;
  in_dlg.zvezda = 0;

  for (;;) {
	n = my_scandir ("list");
	switch (scan_input (&in_dlg)) {
	case 1:                                 /*  */
	  list_abonents ();
	  break;
	case 2:                                 /*  */
	  s = two_e_word ();
	  for (;;) {
		if (s == NULL)
		  s = editstring ("  , \r2[auto]\r7, `-' ");
		if (*s == 0)
		  s = "AUTO";
		if (*s == '-')
		  break;
		if (*s == '!')
		  s++;
		if (test_long_name (s, 0) == 0)
		  s = NULL;
		else {
		  edit_mask (s);
		  break;
		}
	  }
	  break;
	case 3:                                 /*  */
	  s = two_e_word ();
	  for (;;) {
		if (s == NULL)
		  s = editstring (" , `-' ");
		if (*s == 0) {
		  s = NULL;
		  continue;
		}
		if (*s == '-')
		  break;
		if (*s == '&')
		  s++;
		if (test_long_name (s, 0) == 0)
		  s = NULL;
		else {
		  edit_list (s);
		  break;
		}
	  }
	  break;
	case 4:                                 /*  */
	  if (n <= 0) {
		putcs ("\r2 \r7\n");
		continue;
	  }
	  for (i = 0; i < n; i++)
		warn_d ("%2d) &%-14s ( %s%3d)\n",
			  i + 1, name_dlist[i], ": ",
			  view_list (name_dlist[i], 0));
	  break;
	case 5:                                 /*  */
	  set_flg_from_num (0, FLG_START);
	  if (chk_f_list (n) == 0)
		continue;
	  for (i = 0; i_synt_l[i] != 0; i++)
		edit_list (name_dlist[i_synt_l[i] - 1]);
	  break;
	case 6:                                 /*  */
	  set_flg_from_num (0, FLG_START);
	  if (chk_f_list (n) == 0)
		continue;
	  for (i = 0; i_synt_l[i] != 0; i++) {
		putcs (name_dlist[i_synt_l[i] - 1]);
		if (yes_no (" "))
		  unlink (f_prompt ("list/%s", name_dlist[i_synt_l[i] - 1]));
	  }
	  break;
	case 7:                                 /*  */
	  set_flg_from_num (0, FLG_START);
	  if (chk_f_list (n) == 0)
		continue;
	  for (i = 0; i_synt_l[i] != 0; i++) {
		warn_d (" &%s\n", name_dlist[i_synt_l[i] - 1]);
		view_list (name_dlist[i_synt_l[i] - 1], 1);
		if (i_synt_l[i + 1] != 0)
		  if (wait_cr ())
			break;
	  }
	  break;
	case 8:                                 /* - */
	  return 0;
	case 9:                                 /*  */
	  return 100;
	case 10:                                /* \n */
	  break;
	case 11:                                /*  */
	  return 2;
	case 12:                                /*  */
	  return 4;
	case 13:                                /*  */
	  return 5;
	case 14:                                /*  */
	  return 6;
	}
  }
}
