#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <time.h>
#include <sys/stat.h>
#include <sys/file.h>
#include <dirent.h>

extern char hostname[32];
extern char *prgname;
extern char dir_users[];
extern char fname_single[];
extern char dir_arch[];
extern char dir_arch_no_arch[];
extern char dir_news[];
extern char dir_auto[];
extern char dir_ext[];
extern char Adm[];
extern char gates_group[];

extern int single_user_mode;
extern int flg_test;
extern int host_direction;

void start_single_mode(void);
void stop_single_mode(void);

void str_up(unsigned char *s);

/*    man printf, -     */
char *f_prompt(char *fmt, ...) __attribute__ ((format (printf, 1, 2)));

/*  ,   ,     :) */
void *mallocc(size_t size);
void *reallocc(void *ptr, size_t size);
void free0(void *p);
char *strcpym(const char *s);

int  login     (int flg_no_adm_pass);
int  add_user  (char *user);
void log_login (int);

char * sort_db_abonents(void);
int    dump_abon(void);
int    load_abon_from_stdin(void);

#define MAXPU_LEN 12
#define MAXPU_REM_LEN 70

struct PU {     /*   */
	char user[MAXPU_LEN];
	char grp [MAXPU_LEN];
	char pass[MAXPU_LEN];
	int  l;
	int  priv;
	int  af;
	int  gate;
	int  flg_ar;
	int  flg_nocolor;
	int  flg_gmf;
	int  time_keeping_files;
	int  ex_direction;
	char rem [MAXPU_REM_LEN];
	int  naliases;
	char **aliases;
};

/* priv bits */
#define GRANTS_NO_GRANTS          32   /* ' ' */
#define GRANTS_ACCESSMASTER       1    /* change access */
#define GRANTS_POSTMASTER         2    /* change or disable email */
#define GRANTS_GATEMASTER         4    /* only change number gate for users */
#define GRANTS_ARCHIVER           8    /* ena/disable/destroy archive for users */
#define GRANTS_USERMASTER         16   /* remove user & change groups/pass/rem for users */
#define GRANTS_NEWSMASTER         64   /* only create & destroy conferences */
#define GRANTS_RESERVED           128  /* not use! flag ADM */
#define GRANTS_ADM                255  /* ADM user */

#define MAIL_FILE_GATE_COPY 2
#define MAIL_FILE_GATE_INFO 4
#define MAIL_FILE_GATE_REG  8

extern struct PU pu_cur; /*   */
extern struct PU *all_pu; /*   */
extern int n_all_pu;
int    get_pu(struct PU *pu, char *u); /*   */
void   set_pu(struct PU *pu);          /*     */
int    get_all_group(char ***groupsl); /*    */

void scan_new_reg(void);
void scan_new_files(void);
void scan_new_konf(void);

int my_scandir(char *dir);
extern char **name_dlist;

extern long int bytes_out;

void putc_encode_buff(char *p, FILE *out);

/* log cariables */
extern int disable_out;
extern FILE *cuslog;

extern int mode_auto_put_regs;
extern int mode_auto_del_putted_regs;
extern int mode_auto_get_new_files;
extern int mode_auto_get_proto;
extern int mode_auto_del_putted_newfin;
extern int mode_nogetrem;
extern int mode_nolist;
extern int mode_rz_win;

void putcc (int c);
void putcs (const unsigned char *s);
void putcs_mnogo (const char *ps);

void  error_d    (int exit_code, const char *s, ...)
			__attribute__ ((noreturn, format (printf, 2, 3)));

void  error_prot (int exit_code, const char *s, ...)
			__attribute__ ((noreturn, format (printf, 2, 3)));

void  warn_d     (const char *s, ...)
			__attribute__ ((format (printf, 1, 2)));

char *tcp_clienthost (void);


struct IN_DLG {
	char *(*msgs)[];
	char *(*hlps)[];
	const char *alhlp;
	char *prompt;
	char *zvezda;
	};
void putcsl(struct IN_DLG *pin);
int  scan_input(struct IN_DLG *pin);

int dlg_list(void);
int dlg_files(void);
int dlg_reg(void);
int dlg_abon(void);
int dlg_konf(void);
int dlg_gates(void);

int   chk_adm(void);

void  start_gate(int s);
void *gate_exist(int g, int flg_all);


int g_int(char **s1);

extern int *i_synt_l;
int  chk_f_list(int max);

void list_abonents(void);
int  test_long_name (char *name, int flg_rename);

unsigned char *two_e_word(void);
int scan_par(unsigned char *two_word, int err_flg);

void delete_reg(void);
void delete_in(void);
void delete_out(void);

void put_names(char *name, int num);

#define INC_KEY_SIZE  32

struct REG_S {
	char file_inc[INC_KEY_SIZE];
	char *file;                /*    */
	char user[MAXPU_LEN];      /*  */
	int  flg_r;                /*    */
	int  flg_new;              /*    */
	int  flg_new_sav;       /*       */
	char dfile[16];            /*   */
	char din[16];           /*    /   */
	char rem[48];           /*   */
	int  flg_d;             /*       */
	};

struct INF_S {
	char file_inc[INC_KEY_SIZE];
	char *file;                 /*    */
	char user[MAXPU_LEN];       /*  */
	int  flg_r;                 /*   */
	int  flg_d;             /*       */
	int  flg_new;               /*    */
	int  flg_new_sav;       /*        */
	int  flg_uo;                /*      */
	char d[16];                 /*   */
	long sz;                    /*   */
	char rem[48];               /*   */
	int  chg_info;              /*       */
	};                          /*     */

struct OUTF_S {
	char file_inc[INC_KEY_SIZE];
	char *file;             /*    */
	int  flg_d;             /*       */
	char d[16];             /*   (  file_inc */
	long sz;                /*   */
	char rem[48];           /*   */
	int  nuser;             /*    */
	int  flg_noeof;         /*     */
	char **user;            /*    */
	char *flg_r;            /*    */
	char **din;             /*    /   */
	};

#define LEN_NAME_KONFY 48

struct SYS_NEWS {
	int num;                   /*   */
	char name[LEN_NAME_KONFY]; /*  ()  */
	char moder[MAXPU_LEN];     /*   */
	int  nusers;               /*   */
	char **users;              /*   */
	int  *priv;                /*   () */
	long time_new;             /*    */
	};

struct U_NEWS {
	int     num;        /*    */
	int     sz;         /*   */
	char  **tof;        /*       */
	long   *hash;       /*   (  ) */
	long    time_lr;    /*    */
	};


struct NUM_NEWS {
	int     tema;             /*   */
	int     otvet;            /*   */
	char    author[MAXPU_LEN];/*   */
	long    ls;               /*   */
	char    rem[48];          /*    () */
	int     nf;               /*    */
	char    bb[INC_KEY_SIZE]; /*     */
	char  **namef;            /*    */
	char  **nsf;              /*     */
	char  **nameu;            /*    */
	long   *sizef;            /*   */
	};


	/*      */
struct ALL_KONF {
	struct NUM_NEWS *num_news;
	int    u_news;          /*      U_NEWS */
	char   *nameu;          /*      */
	int        nf;          /*   , 0 -  */
	char   *namef;          /*    */
	char     *nsf;          /*     */
	int     flg_r;          /*   (  -  ) */
	long    sizef;          /*     */
	};

extern char *dlg_gf[];
extern char prompt_gf[];
extern char alhlp_gf[];

extern int login_year;
extern int login_mon;

void clear_tmp(int ch_to);
char *name_auto_increment(void);
void decode_inc(const char *name_inc, char *str_time);
char * decode_inc_may_be_old (const char *name_inc);
long hash_decode_inc(char *name_inc);
void remove_user_from_all_news(char *user);
int  test_big_reg(void);
void set_flg_from_num(int num, int flg);
#define FLG_START 1
#define FLG_DELET 2
#define FLG_NEW   4
#define FLG_READ  8
#define FLG_MY    16

int gf(int n, int flg_re);
			/* string match as in glob */
int gmatch(const unsigned char *s, const unsigned char *p);

/*     */
char **msk_u;
int get_mask_to_file(char *name_mask);
/*   */
int view_mask (char *name, int flg_buf);


/*   */
int parser_konf(struct NUM_NEWS *to, int n, struct U_NEWS *uns,
					struct ALL_KONF **pall_conf);

int putcs_mnogo_in_file(unsigned char *file);

struct List_To_Ret {
	char **list_to;
	int n_list_to;
	int err_ok;
	};

void strip_dup_space(char *src, char **endp);
int get_list_users(char *fix_get_str, struct List_To_Ret *list_to,
			char *prompt1, char *promt_again, char *file);
void scan_mask(char *name, struct List_To_Ret *list_to_ret, char *file,
							    int flg_err_put);
void destroy_nlist(struct List_To_Ret *ltr);
void add_alias    (char **pg, int      n, char ***anames, int *nanames);
void delete_alias (char **pg, int      n, char ***anames, int *nanames);
void sort_strndim (int    n,  char   **ps);

/*      idle timeout */
void run_and_check_idle(char *command);

void rus_num_files(char *first_word, int n, int newm, char *end_word);

/*        */
void put_regs1_from_ig(struct INF_S *pinf_s, struct tm *ptm);

char * get_abon_email (void);
void send_email(char *info, const char *file_inc, const char *file,
			const char *u_from, const char *u_to);
int main_mailgate(void);

/*     */
int send_ip(const char *fname, int flg_not_begin);
int recv_ip (char **name, int flg_not_full_as_errror);
int recv_a_ip(char *name, long s);
void create_delete_arch_ex(const char *user, int flg_ar);

/*     */
void  get_ouf(void);
void put_r_from_reg(char *file_inc, char *user, char *din);
int chk_no_read (struct OUTF_S *p_o);
int qsort_compar_reg (const void *p1, const void *p2);
int read_reg (struct REG_S *reg_s, FILE * out);

extern struct OUTF_S *pof;
extern int n_pof;

char * bb_asprintf(const char *fmt, ...);
char * toshort(const char *name, const char *s11);

int lsz_main(int argc, char **argv);

#define SAVE_ARCH_IN  0
#define SAVE_ARCH_OUT 1
#define SAVE_ARCH_PRO 2

int
mkdir_save_arch (int flg_out, char *mm_dd, char *name, char *dir, char **file);
