#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

/* #define DEBUG */
#include "fun.h"
#include "db.h"
#include "keyboard.h"


static char find_from[] = "From: ";
static char find_cmd2[] = "Reg: ";
static char mailgate_find_cmd1[] = "Get: ";

static char debug_mailgate_filename[] = "mailgate.debug";

static char *
tst_find_str (char *line, char *find_line, char **addr)
{
  char *strfound;
  strfound = strstr (line, find_line);
  if (strfound != NULL) {
	strfound += strlen (find_line);
	if (*strfound) {
	  char *ps;

	  ps = strfound;
	  if (addr == 0) {
		while (*ps) {
		  if (*ps == '.' || *ps == '/' || *ps == '-' ||
			  *ps == '@' || *ps == '=' ||
			    (*ps >= 'A' && *ps <= 'Z') ||
			      (*ps >= '0' && *ps <= '9') ||
				(*ps >= 'a' && *ps <= 'z'))
			ps++;
		  else
			*ps = 0;
		}
	  } else {
		while (*ps) {
		  if (*ps == '<') {
			if (*addr) {
			  *addr = 0;
			  break;
			}
			ps++;
			*addr = ps;
		  } else if (*ps == '>')
			*ps = 0;
		  else
			ps++;
		}
	  }
	  return strfound;
	}
  }
  return NULL;
}


void
send_email (char *info, const char *file_inc, const char *file,
		const char *u, const char *u_to)
{
  char *bufm;
  char command[1024];
  char file_body_tmp[10 + MAXPU_LEN + INC_KEY_SIZE];

  bufm = get_abon_email();
  if (bufm) {
	  if (file_inc) {
		/* $1 - To, $2 - Key, $3 info, $4 file, $5 fileinc */
		sprintf(command, "../../dpager '%s' '%s@%s/%s'"
				 " '%s' '%s' '../%s/out/%s'",
			bufm, u_to, u, file_inc,
			info, file, u, file_inc);
	  } else {
	    char *file_body;
	    FILE *femail;

	    if (info) {
		file_body = name_auto_increment ();
		sprintf (file_body_tmp, "../%s/tmp/%s", pu_cur.user, file_body);
		femail = fopen (file_body_tmp, "w");
		if (femail == 0) {
		    warn_d ("   email\n");
		    return;
		}
		fputs (info, femail);
		fclose (femail);
	    } else
		return; /* hmm */
	    sprintf (command, "mail -s '   ' %s < %s",
			   bufm, file_body_tmp);
	  }
	  free (bufm);
	  debug1 (puts (command));
	  debug2 (system (command));
	  if (file_inc==0)
	    unlink (file_body_tmp);
  }
}

static void
mailgate (char *file, int flg_reg)
{
  char *cur_user = 0;
  char *from_user = 0;
  char *filename;
  char *sav_file;
  struct INF_S *inf_s;
  int i, n;
  char path_tst_uo[10 + MAXPU_LEN + INC_KEY_SIZE];      /* ../user/out/file */
  struct stat statb;

  sav_file = filename = file;
  while (*filename) {
	if (*filename == '@') {
	  if (*(filename + 1) != 0)
		cur_user = file;
	  *filename = 0;
	} else
	  filename++;
  }
  if (cur_user == 0) {
  err:
	error_d (2, "Bad format for %s", sav_file);
  }
  cur_user = strcpym (cur_user);
  *filename++ = '@';
  file = filename;
  while (*filename) {
	if (*filename == '/') {
	  if (*(filename + 1) != 0)
		from_user = file;
	  *filename = 0;
	} else
	  filename++;
  }
  if (from_user == 0)
	goto err;
  from_user = strcpym (from_user);
  *filename++ = '/';
  if (chdir (cur_user) < 0)
	error_d (2, "Error: %s chdir(%s) (user not found?)", sav_file, cur_user);
  if (get_pu (&pu_cur, cur_user) == 0)
	error_d (2, "Error %s user %s not found", sav_file, cur_user);
  pu_cur.flg_nocolor = 1;
  pu_cur.l = 'K';
  if(strncmp(from_user, "=out", 4) == 0) {
    /*    */
    FILE *fregs;
    char buff[1024];
    struct REG_S *reg_s;
    int n_regs;

    filename = f_prompt ("%s/%s", from_user + 1, filename);
    fregs = fopen(filename, "r");
    if(fregs==NULL)
	error_d (2, "Error %s not found", filename);
    n_regs = get_db_reg (&reg_s);

    while(fgets(buff, sizeof(buff), fregs) != NULL) {
	sav_file = strchr(buff, '\n');
	if(sav_file==NULL)
	    continue;   /* hmm */
	*sav_file++ = 0;
	sav_file = strchr(buff, '/');
	if(sav_file==NULL)
	    continue;   /* hmm */
	*sav_file++ = 0;
	from_user = buff;
	n=0;
	for(i=0; i<n_regs; i++) {
	    if(strcmp(reg_s[i].user, from_user)==0 &&
		    strcmp(reg_s[i].file_inc, sav_file)==0) {
		reg_s[i].flg_r = 'Y';
		n++;
	    }
	}
	if(n)
	    set_r_reg (reg_s, n_regs);
    }
    fclose(fregs);
    unlink(filename);
    goto ret;
  }
  n = get_db_inf (&inf_s);
  for (i = 0; i < n; i++)
	if (strcmp (filename, inf_s[i].file_inc) == 0 &&
		strcmp (from_user, inf_s[i].user) == 0)
	  break;
  if (i == n) {
	filename = f_prompt ("   %s\n", filename);
	warn_d ("Error %s %s", sav_file, filename);
	if(flg_reg == 0)
	    send_email (filename, 0, 0, 0, 0);
	goto ret;
  }
  sprintf (path_tst_uo, "../%s/out/%s", inf_s[i].user, inf_s[i].file_inc);
  if (stat (path_tst_uo, &statb)) {
	filename = f_prompt (" %s  \n", inf_s[i].file);
	send_email (filename, 0, 0, 0, 0);
	goto ret;
  }
  if (flg_reg == 0) {
	file = f_prompt (" :  %s  %s %s\n\n",
			    inf_s[i].file, inf_s[i].user, inf_s[i].d);
	file = strcpym (file);
	send_email (file, inf_s[i].file_inc, inf_s[i].file, inf_s[i].user, pu_cur.user);
  } else {
	struct tm *ptm;
	time_t tt;

	inf_s[i].flg_new = '0';
	inf_s[i].chg_info = 1;
	time (&tt);
	ptm = localtime (&tt);
	put_regs1_from_ig (&inf_s[i], ptm);
	set_rd_newu_inf (&inf_s[i], 1);
  }

ret:
  chdir("..");
}

int
main_mailgate (void)
{
  int c, cprev;
  int flg_body;
  char body_line[4096];
  int nline;
  char *strfound;
  char *addr;

  pu_cur.flg_nocolor = 1;
  cuslog = fopen (debug_mailgate_filename, "a");
  if (cuslog == NULL)
	error_d (1, "Can`t write to %s", debug_mailgate_filename);
  setlinebuf (cuslog);
  freopen (debug_mailgate_filename, "a", stdout);
  freopen (debug_mailgate_filename, "a", stderr);
  flg_body = 0;
  nline = 0;
  addr = 0;
  cprev = EOF;
  while ((c = getchar ()) != EOF) {
	if (c == '\r')
	  continue;
	debug1 (putchar (c));
	if (c == '\n') {
	  body_line[nline] = 0;
	  nline = 0;
	} else {
	  body_line[nline++] = c;
	  if (nline == sizeof (body_line))
		nline--;
	}
	if (flg_body == 0 && cprev == '\n' && cprev == c) {
	  flg_body++;
	  debug1 (printf ("==body==\n"));
	  continue;
	}
	if (flg_body == 0) {
	  cprev = c;
	  if (c == '\n') {
		if (addr)
		  continue;
		strfound = tst_find_str (body_line, find_from, &addr);
		if (strfound != NULL) {
		  if (addr == 0)
			error_d (1, "Error format %s %s", find_from, strfound);
		  addr = strcpym (addr);
		}
		body_line[0] = 0;
	  }
	} else {
	  if (addr == 0)
		error_d (1, "Error: %s empty", find_from);
	  if (c == '\n') {
		debug1 (printf ("==body=%s=\n", body_line));
		strfound = tst_find_str (body_line, mailgate_find_cmd1, 0);
		if (strfound != NULL) {
		  mailgate (strfound, 0);
		  debug1 (printf("==%s=%s= To: %s\n", mailgate_find_cmd1,
							    strfound, addr));
		} else {
		  strfound = tst_find_str (body_line, find_cmd2, 0);
		  if (strfound != NULL) {
			mailgate (strfound, 1);
			debug1 (printf ("==%s=%s= Reg: %s\n", find_cmd2,
							    strfound, addr));
		  }
		}
		body_line[0] = 0;
	  }
	}
  }
  return 0;
}
