#include <sys/types.h>
#include <pwd.h>
#include <stdarg.h>
#include <crypt.h>
#include "fun.h"
#include "db.h"
#include "cgi_fun.h"



static const char first[] = "HTTP/1.0 200 OK\nContent-type: text/html\n\n"
	"<HTML>\n<HEAD>\n <META HTTP-EQUIV=\"Content-Type\" "
	"CONTENT=\"text/html; charset=koi8-r\">\n</HEAD>\n"
	" <TITLE>    "
	"   </TITLE>\n<BODY>";

static const char main_form[]="/html/main.form";

/* from d_in_reg.c */
static void set_R_vars(void)
{
  int n, i, un;
  struct REG_S *reg_s;

  n = get_db_reg (&reg_s);

  if (n > 0) {
	un = 0;
	for (i = 0; i < n; i++)
	  if (reg_s[i].flg_new == '1') {
		/*   -     
		      */
		reg_s[i].flg_new_sav = 1;
		reg_s[i].flg_new = '2';
		put_r_from_reg (reg_s[i].file_inc, reg_s[i].user, reg_s[i].din);
		un++;
	  } else
		reg_s[i].flg_new_sav = 0;
	if(un)
	    unset_new_reg (reg_s, n);
	dvar[find_var("RF")].v.ival = un;
	un = 0;
	for (i = 0; i < n; i++)
	    if (reg_s[i].flg_r == '0')
		un++;
	dvar[find_var("RN")].v.ival = un;

	dvar[find_var("RA")].v.ival = n;
  }
}

/* from d_in_f.c */
static void set_I_vars(void)
{
  int n, un, i;
  char path_tst_uo[10 + MAXPU_LEN + INC_KEY_SIZE];      /* ../user/out/file */
  struct stat statb;
  int n_ud;
  struct INF_S *inf_s;

  n = get_db_inf (&inf_s);
  if (n > 0) {
	n_ud = un = 0;
	for (i = 0; i < n; i++) {
	  sprintf (path_tst_uo, "../%s/out/%s", inf_s[i].user, inf_s[i].file_inc);
	  if (stat (path_tst_uo, &statb))
		inf_s[i].flg_uo = 1;
	  if (inf_s[i].flg_new == '1') {
		inf_s[i].flg_new_sav = '1';
		inf_s[i].flg_new = '0';
		inf_s[i].chg_info = 1;
		if(inf_s[i].flg_uo)
		    n_ud++;
		un++;
	  } else
		inf_s[i].flg_new_sav = '0';
	}
	if (un) {
	  if((un-n_ud)>0)
	    dvar[find_var("IF")].v.ival = un-n_ud;
	  set_rd_newu_inf (inf_s, n);
	}
	un = 0;
	for (i = 0; i < n; i++)
	    if(inf_s[i].flg_r == '0')
		un++;
	dvar[find_var("IN")].v.ival = un;

	dvar[find_var("IA")].v.ival = n;
  }
}

/* from d_in_f.c */
static void set_O_vars(void)
{
  int i;
  int num_no_read = 0;
  int num_no_to = 0;

  for(i = 0; i < n_pof; i++) {
      int flg_no_read = 0;

      if (pof[i].flg_noeof == 0)
	    flg_no_read = chk_no_read (&pof[i]) > 0;
      if (pof[i].flg_d == 0 && pof[i].nuser == 0)
	    num_no_to++;
      if (pof[i].flg_d == 0)
	    num_no_read += pof[i].nuser == 0 ? 0 : flg_no_read;
  }
  dvar[find_var("ON")].v.ival = num_no_read;
  dvar[find_var("OF")].v.ival = num_no_to;
  dvar[find_var("OA")].v.ival = i;
}

int main()
{
	struct passwd *pwd;
	FILE *inp;
	char *uri;
	char *user;
	int login_ok = 0;
	int i;

	printf("%s", first);
	atexit(exit_bottom_msg);

	pu_cur.l = 'K';                 /* koi8 */
	pu_cur.flg_nocolor = 1;         /* no ESC color */

	pwd = getpwuid (geteuid());
	if(pwd == NULL)
		error_d(1, "     %d", geteuid());
	if(chdir (pwd->pw_dir))
		error_d(1, "   chdir(%s)", pwd->pw_dir);

	uri = getenv("PATH_INFO");
	if(uri == NULL || *uri == 0 || (*uri == '/' && uri[1] == 0))
		error_d(1, " //  ");

	user = uri+1;
	uri = strchr(user+1, '/');
	if(uri)
	    *uri = 0;   /*  /  [/]?*   */
	str_up(user);
	if(chdir (dir_users) || chdir (Adm))
		error_d(1, "   chdir   ");

	n_all_pu = all_abonents (&all_pu);
	i = get_pu(&pu_cur, user);
	pu_cur.l = 'K';                 /* koi8 */
	pu_cur.flg_nocolor = 1;         /* no ESC color */
	if(i == 0)
		error_d(1, "     %s", user);
	uri = getenv("HTTP_COOKIE");
	if(uri != NULL) {
	    if(strncmp(uri, "pass=", 5) != 0) {
		error_d(1, "  %s", uri);
		uri = NULL;
	    } else {
		char *pass;

		pass = crypt(pu_cur.pass, salt);
		if(strcmp(uri+5, pass) != 0) {
		    // printf("  \n");
		    uri = NULL;
		} else {
		    uri = f_prompt("%s%s", pwd->pw_dir, main_form);
		    login_ok = 1;
		    chdir("..");
		    if(chdir(pu_cur.user))
			error_d(1, "      %s", pu_cur.user);
		}
	    }
	}
	if(uri == NULL)
	    uri = f_prompt("%s%s", pwd->pw_dir, reg_form);
	if(uri == NULL)
		error_d(2, " !");
	inp = fopen(uri, "r");
	if(inp == NULL)
		error_d(3, "     %s: %m", uri);
	i = find_var("UR");
	dvar[i].v.sval = pu_cur.user;

	if(login_ok) {
	    get_ouf();
	    set_R_vars();
	    set_I_vars();
	    set_O_vars();
	}
	parse_form(inp);
	return 0;
}
