#include "fun.h"

			/*    find   1.2 */
static int amatch (const unsigned char *, const unsigned char *);
static int umatch (const unsigned char *, const unsigned char *);

			/* string match as in glob */
int
gmatch (const unsigned char *s, const unsigned char *p)
{
  if (*s == '.' && *p != '.')
	return (0);
  return (amatch (s, p));
}

static int
amatch (const unsigned char *s, const unsigned char *p)
{
  register int cc, scc, k;
  int c, lc;

  scc = *s;
  lc = 077777;
  switch (c = *p) {

  case '[':
	k = 0;
	while ((cc = *++p) != '\0') {
	  switch (cc) {

	  case ']':
		if (k)
		  return (amatch (++s, ++p));
		else
		  return (0);

	  case '-':
		k |= (lc <= scc) & (scc <= (cc = p[1]));
	  }
	  if (scc == (lc = cc))
		k++;
	}
	return (0);

  case '?':
  caseq:
	if (scc)
	  return (amatch (++s, ++p));
	return (0);
  case '*':
	return (umatch (s, ++p));
  case 0:
	return (!scc);
  }
  if (c == scc)
	goto caseq;
  return (0);
}

static int
umatch (const unsigned char *s, const unsigned char *p)
{
  if (*p == 0)
	return (1);
  while (*s)
	if (amatch (s++, p))
	  return (1);
  return (0);
}
