#include <sys/types.h>
#include <pwd.h>
#include <stdarg.h>
#include <crypt.h>
#include "fun.h"
#include "db.h"
#include "cgi_fun.h"



static const char first0[] = "HTTP/1.0 200 OK\nContent-type: text/html\n";
static const char first2[] = "\n"
	"<HTML>\n<HEAD>\n <META HTTP-EQUIV=\"Content-Type\" "
	"CONTENT=\"text/html; charset=koi8-r\">\n";
static const char first3[] =  "</HEAD>\n"
	" <TITLE>    "
	"   </TITLE>\n<BODY>";


# define error_h(msg, args...) do { printf("%s%s", first2, first3); \
				    error_d(1, msg, ## args); \
			       } while(0)

int main()
{
	struct passwd *pwd;
	char *uri;
	char *user;
	char *pass;
	char *pth;
	char post[256];
	int i;

	printf("%s", first0);
	atexit(exit_bottom_msg);

	pu_cur.l = 'K';                 /* koi8 */
	pu_cur.flg_nocolor = 1;         /* no ESC color */

	pwd = getpwuid (geteuid());
	if(pwd == NULL)
		error_h("     %d", geteuid());
	if(chdir (pwd->pw_dir))
		error_h("   chdir(%s)", pwd->pw_dir);

	uri = getenv("PATH_INFO");
	if(uri == NULL || *uri == 0 || (*uri == '/' && uri[1] == 0))
		error_h(" //  ");

	user = uri+1;
	uri = strchr(user+1, '/');
	if(uri)
	    *uri = 0;   /*  /  [/]?*   */
	pth = strcpym(user);
	str_up(user);
	if(chdir (dir_users) || chdir (Adm))
		error_h("   chdir   ");

	n_all_pu = all_abonents (&all_pu);
	i = get_pu(&pu_cur, user);
	pu_cur.l = 'K';                 /* koi8 */
	pu_cur.flg_nocolor = 1;         /* no ESC color */
	if(i == 0)
	    error_h("     %s", user);

	uri = getenv("REQUEST_METHOD");
	if(uri == NULL)
	    error_h("   %s", "REQUEST_METHOD");
	if(strcmp(uri, request_method) != 0)
	    error_h(" %s,  %s %s", uri, "REQUEST_METHOD", request_method);
	if(fgets(post, sizeof(post), stdin) == NULL)
	    error_h("  ");
	if(strncmp(post, "pass=", 5) != 0)
	    error_h("  ");
	str_up(post);
	if(strcmp(post + 5, pu_cur.pass) == 0) {
	    pass = crypt(pu_cur.pass, salt);
	    printf("Set-Cookie: pass=%s; Max-Age=%d; "
			"Path=/cgi-bin/; Version=1\n", pass, Max_Age);
	}
	printf("%s", first2);
	printf("<meta http-equiv=\"Refresh\" content=\"2; URL=%s/%s\">\n", main_cgi, pth);
	printf("%s", first3);
	printf("<A HREF=\"%s/%s\"></A>\n", main_cgi, pth);
	return 0;
}
