#include <sys/types.h>
#include <pwd.h>
#include <stdarg.h>
#include <crypt.h>
#include "fun.h"
#include "db.h"
#include "cgi_fun.h"



static const char first[] = "HTTP/1.0 200 OK\nContent-type: text/html\n\n"
	"<HTML>\n<HEAD>\n <META HTTP-EQUIV=\"Content-Type\" "
	"CONTENT=\"text/html; charset=koi8-r\">\n</HEAD>\n"
	" <TITLE>    "
	"   </TITLE>\n<BODY>";

static const char cur_cgi[]="/cgi-bin/reg.cgi";


/* from d_in_reg.c */
static struct REG_S *reg_s;

static void
list_reg (int i, int flg_title)
{
  char *t;

  if (flg_title) {
	printf ("<h1> </h1><BR>\n");
	printf ("<p>      <BR><BR>\n");
	printf("<FORM ACTION=\"%s/%s?select\" METHOD=%s>\n",
		    cur_cgi, pu_cur.user, request_method);
	printf ("<TABLE border=1>\n");
	printf (" <TH><center></center></TH>\n");
	printf (" <TH></TH>\n");
	printf (" <TH>&nbsp;</TH>\n");
	printf (" <TH><center></center></TH>\n");
	printf (" <TH><br></TH>\n");
	printf (" <TH>&nbsp;...</TH>\n");
	printf (" <TH></TH>\n");
  }
  if (reg_s[i].flg_d == '1')
	t = "";
  else if (reg_s[i].flg_r == '1')
	t = "";
  else if (reg_s[i].flg_new_sav)
	t = "";
  else
	t = "";
  printf (" <TR>\n");
  printf ("  <td>%s</td>", t);
  printf ("  <td align=right><TT>%d</TT></td>", i + 1);
  printf ("  <td><a href=\"%s/%s?read=%s&%s\">%s</a></td>", cur_cgi,
		    pu_cur.user, reg_s[i].file_inc, reg_s[i].user, reg_s[i].file);
  printf ("  <td>%s</td>", reg_s[i].user);
  printf ("  <td>%s</td>", reg_s[i].din + 1);
  printf ("  <td>%s</td>", reg_s[i].rem);
  printf ("  <td><SELECT NAME=%s/%s>",  reg_s[i].user, reg_s[i].file_inc);
  if (reg_s[i].flg_r == '1' && reg_s[i].flg_d == '1')
      printf ("<OPTION>  ");
  if (reg_s[i].flg_r == '1')
      printf ("<OPTION><OPTION><OPTION> ");
  else
      printf ("<OPTION> <OPTION>");
  printf ("</SELECT></td>");
  printf (" </TR>\n");
}

static int show_html_reg(int i)
{
    printf("<TABLE Border=1>\n");
    printf(" <TR>\n");
    printf("  <TD>:</TD>\n");
    printf("  <TD>%s</TD>\n", reg_s[i].file);
    printf("  <TD>%s</TD>\n", reg_s[i].dfile);
    printf(" </TR>\n");
    printf(" <TR>\n");
    printf("  <TD>:</TD>\n");
    printf("  <TD colspan=2>%s</TD>\n", reg_s[i].rem);
    printf(" </TR>\n");
    printf(" <TR>\n");
    if (reg_s[i].din[0] == '+')
      printf("  <TD> :</TD>\n");
    else
      printf("  <TD>   :</TD>\n");
    printf("  <TD>%s</TD>\n", reg_s[i].user);
    printf("  <TD>%s</TD>\n", &reg_s[i].din[1]);
    printf(" </TR>\n");
    printf("</TABLE>\n");
    if(reg_s[i].flg_r != '1') {
	reg_s[i].flg_r = 'Y';
	return 1;
    }
    return 0;
}

static void send_reg2email(const char *email, int i, int n)
{
	static char *cmd;
	static FILE *nof;
	static FILE *frf;

    if(email) {
	if(cmd == 0) {
	    char fname[16 + 8];
	    char client_fname[16 + 8];
	    char fkey[16 + 8];
	    const char *ai = name_auto_increment ();

	    strcpy (fname, "tmp/");
	    strcpy (fkey, "out/");
	    strcat (fname, ai);
	    strcat (fkey, ai);
	    strcpy (client_fname, ai);
	    strcpy (&client_fname[9], "uva");  /* .uva */
	    cmd = f_prompt("../../dpager "
		/* $1 - To, $2 - Key, $3 info, $4 file, $5 fileinc */
		"'%s' '%s@=%s'"
		     " ' ' '%s' '%s'",
		    email, pu_cur.user, fkey,
		    client_fname, fname);
	    cmd = strcpym(cmd);
	    nof = fopen(fname, "w");
	    frf = fopen(fkey, "w");
	    if(nof==NULL || frf==NULL)
		error_d (3, "      ");
	}
	if(i < 0) {
	    for (i = 0; i < n; i++)
		if (reg_s[i].flg_r != '1' && reg_s[i].flg_d == '0') {
		    read_reg(reg_s + i, nof);
		    fprintf(frf, "%s/%s\n", reg_s[i].user, reg_s[i].file_inc);
	    }
	} else {
	    read_reg(reg_s + i, nof);
	    fprintf(frf, "%s/%s\n", reg_s[i].user, reg_s[i].file_inc);
	}
    } else {
	char *fname;

	fclose(nof);
	fclose(frf);
	system (cmd);
	fname = strrchr(cmd, '\'');
	if(fname == NULL)
	    error_d (8, "Internal error 1 cmd=%s", cmd);
	*fname = 0;
	fname = strrchr(cmd, '\'');
	if(fname == NULL)
	   error_d (8, "Internal error 2 cmd=%s", cmd);
	unlink(fname+1);    /*    */
	free0(&cmd);
	set_r_reg (reg_s, n);
    }
}

static void set_R_vars(void)
{
  int n, i, un = 0;
  char *qs = 0;
  char *del_ok = 0;

  n = get_db_reg (&reg_s);

  if (n > 0) {
	if (pu_cur.time_keeping_files) {
	  long hash = hash_decode_inc (name_auto_increment ());
	  long keeping = 60l * 60l * 24l * pu_cur.time_keeping_files;
	  int j;

	  j = 0;
	  for (i = 0; i < n; i++)
		if (reg_s[i].flg_r == '1' && reg_s[i].flg_d == '0' &&
			/*    */
		    (hash_decode_inc (reg_s[i].file_inc) + keeping) < hash) {
		  reg_s[i].flg_d = '1';
		  set_d_reg (&reg_s[i]);
		  j++;
		}
	  if (j)
		printf (" %d %s %c,  %d %s.<BR>\n",
			    j,
			    (j == 1 ? "" : ""),
			    (j == 1 ? '' : ''),
			    pu_cur.time_keeping_files,
			    (pu_cur.time_keeping_files == 1 ? "" : ""));
	}
	un = 0;
	qsort (reg_s, n, sizeof (struct REG_S), qsort_compar_reg);
	for (i = 0; i < n; i++)
	  if (reg_s[i].flg_new == '1') {
		/*   -     
		      */
		reg_s[i].flg_new_sav = 1;
		reg_s[i].flg_new = '2';
		put_r_from_reg (reg_s[i].file_inc, reg_s[i].user, reg_s[i].din);
		un++;
	  } else
		reg_s[i].flg_new_sav = 0;
	if(un)
	    unset_new_reg (reg_s, n);
	dvar[find_var("RA")].v.ival = n;
	/*   */
	qs = getenv("QUERY_STRING");
	if(qs) {
	    if(strncmp(qs, "read=", 5) != 0 &&
					strcmp(qs, "select") != 0 && *qs)
		error_d(6, "  %s", qs);
	    if(strncmp(qs, "read=", 5) == 0) {
		char *file_inc = qs + 5;

		qs = strchr(file_inc, '&');
		if(qs==NULL)
		    error_d(6, "   read=%s", file_inc);
		*qs++ = '\0';
		if(*qs == '\0')
		    error_d(6, "  read %s & ", file_inc);
		for (i = 0; i < n; i++) {
		    if(strcmp(reg_s[i].file_inc, file_inc) == 0 &&
			strcmp(reg_s[i].user, qs) == 0)
			    break;
		}
		if(i != n)
		  if(show_html_reg(i))
		    set_r_reg (reg_s+i, 1);
	    }
	    else if(strcmp(qs, "select") == 0) {
		int l;
		char *e;
		const char *email = 0;
		int set_r_reg_flg = 0;

		qs = getenv("REQUEST_METHOD");
		if(qs == NULL)
		    error_d(7, "   %s", "REQUEST_METHOD");
		if(strcmp(qs, request_method) != 0)
		    error_d(7, " %s,  %s %s", qs,
					"REQUEST_METHOD", request_method);
		qs = getenv("CONTENT_LENGTH");
		if(qs == NULL)
		    error_d(7, "   %s", "CONTENT_LENGTH");
		l = strtol(qs, &e, 10);
		if(l <= 0 || *e != 0)
		    error_d(7, "  %s", "CONTENT_LENGTH");
		e = mallocc(l+1);
		if(fread(e, 1, l, stdin) != l)
		    error_d(7, "   %d ", l);
		e[l] = 0;
		qs = e;

		while (qs && *qs) {
		  const char *name = qs;
		  char *value = strchr(qs, '=');

		  if (!value)         /* &XXX without '=' */
		      break;
		  *value++ = 0;
		  qs = strchr(value, '&');
		  if (qs)
		      *qs++ = 0;
		  e = (char *)name;
		  decodeString(e);

		  decodeString(value);
		  l = strlen(value);
		  e = strchr(name, '/');
		  if(e==NULL)
		    error_d(7, "   =%s=", name);
		  *e++ = 0;
		  for (i = 0; i < n; i++)
		    if(strcmp(reg_s[i].user, name) == 0 &&
				strcmp(reg_s[i].file_inc, e) == 0)
			break;
		  if(i == n)
		    continue;
		  if(l==strlen("  ")) {
		    if(reg_s[i].flg_d == '1') {
			if(del_ok == 0)
			    del_ok = mallocc(n);
			del_ok[i] = 1;
		    }
		  }
		  else if(l==strlen("")) {
		    reg_s[i].flg_d = '1';
		    set_d_reg (&reg_s[i]);
		  }
		  else if(l==strlen("")) {
		    set_r_reg_flg += show_html_reg(i);
		  }
		  else if(l==strlen(" ")) {
		    if(email == 0)
			email = get_abon_email();
		    if(email == 0) {
			warn_d ("   email<br>\n");
			email = pu_cur.user;
			}
		    if(email != pu_cur.user)
			send_reg2email(email, i, i);
		  }
		  else
		    error_d(7, "   =%s=", value);
		}
		if(email && email != pu_cur.user)
		    send_reg2email(NULL, 0, n);    /* send */
		else if(set_r_reg_flg)
		    set_r_reg (reg_s, n);
	    }
	}
	/*    */
	un = 0;
	for (i = 0; i < n; i++)
	    if (reg_s[i].flg_new_sav)
		list_reg(i, un++ == 0);
	/*    */
	for (i = 0; i < n; i++)
	    if (reg_s[i].flg_new_sav == 0 && reg_s[i].flg_r != '1' &&
				    reg_s[i].flg_d != '1')
		list_reg(i, un++ == 0);

	/*    */
	for (i = 0; i < n; i++)
		if (reg_s[i].flg_new_sav == 0 &&
			(del_ok == 0 || del_ok[i] == 0) &&
			(reg_s[i].flg_r == '1' || reg_s[i].flg_d == '1'))
		    list_reg(i, un++ == 0);
	if(un) {
	    printf("</TABLE>\n<HR>\n");
	    printf("<P><INPUT TYPE=SUBMIT VALUE=> </FORM>\n");
	}
  }

  un = 0;
  if(del_ok) {
    for(i=0; i<n; i++) {
	if(del_ok[i]) {
	    reg_s[i].flg_d = '1';
	    un++;
	} else if(reg_s[i].flg_d == '1') {
		reg_s[i].flg_d = '0';
	}
    }
    unlink_db_reg (reg_s, n);
    free(del_ok);
  }
  dvar[find_var("RA")].v.ival = n-un;
}

int main()
{
	struct passwd *pwd;
	FILE *inp;
	char *uri;
	char *user;
	int login_ok = 0;
	int i;

	printf("%s", first);
	atexit(exit_bottom_msg);

	pu_cur.l = 'K';                 /* koi8 */
	pu_cur.flg_nocolor = 1;         /* no ESC color */

	pwd = getpwuid (geteuid());
	if(pwd == NULL)
		error_d(1, "     %d", geteuid());
	if(chdir (pwd->pw_dir))
		error_d(1, "   chdir(%s)", pwd->pw_dir);

	uri = getenv("PATH_INFO");
	if(uri == NULL || *uri == 0 || (*uri == '/' && uri[1] == 0))
		error_d(1, " //  ");

	user = uri+1;
	uri = strchr(user+1, '/');
	if(uri)
	    *uri = 0;   /*  /  [/]?*   */
	str_up(user);
	if(chdir (dir_users) || chdir (Adm))
		error_d(1, "   chdir   ");

	n_all_pu = all_abonents (&all_pu);
	i = get_pu(&pu_cur, user);
	pu_cur.l = 'K';                 /* koi8 */
	pu_cur.flg_nocolor = 1;         /* no ESC color */
	if(i == 0)
		error_d(1, "     %s", user);
	i = find_var("UR");
	dvar[i].v.sval = pu_cur.user;

	uri = getenv("HTTP_COOKIE");
	if(uri != NULL) {
	    if(strncmp(uri, "pass=", 5) != 0) {
		error_d(1, "  %s", uri);
	    } else {
		char *pass;

		pass = crypt(pu_cur.pass, salt);
		if(strcmp(uri+5, pass) == 0) {
		    login_ok = 1;
		    chdir("..");
		    if(chdir(pu_cur.user))
			error_d(1, "      %s", pu_cur.user);
		}
	    }
	}
	if(!login_ok) {
	    uri = f_prompt("%s%s", pwd->pw_dir, reg_form);
	    if(uri == NULL)
		error_d(2, " !");
	    inp = fopen(uri, "r");
	    if(inp == NULL)
		error_d(3, "     %s: %m", uri);
	    parse_form(inp);
	    return 0;
	}

	get_ouf();
	set_R_vars();
	if(dvar[find_var("RA")].v.ival == 0) {
	    printf("<p>  <BR>\n"
		    "<a href=\"%s/%s\"> </a>\n", main_cgi, pu_cur.user);
	    return 0;
	}
	return 0;
}
